/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.AttachmentRestClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function()
{
	var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
	
	com.ibm.rqm.planning.web.client.internal.AttachmentRestClient = 
	{
		ATTACHMENT_REST_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IAttachmentWithArtifactRestService",
		
		_invokeAttachService: function(responseHandler, method, appArgs) 
		{
			var actualArgs= {};
			if (appArgs)
			{
				var jsonArgs= dojo.toJson(appArgs);
				actualArgs.jsonString = jsonArgs;
				if(appArgs.artifactUUID)
				{
					actualArgs.artifactUUID = appArgs.artifactUUID;
				}
				if(appArgs.addedAttachments)
				{
					actualArgs.addedAttachments = appArgs.addedAttachments;
				}
				if(appArgs.deletedAttachments)
				{
					actualArgs.deletedAttachments = appArgs.deletedAttachments;
				}
				if(appArgs.artifactType)
				{
					actualArgs.artifactType = appArgs.artifactType;
				}
			}
			
			var serviceRequest = new ServiceRequest(this.ATTACHMENT_REST_SERVICE_URI, method, actualArgs);
			TeamServerClient.invokeService(serviceRequest, responseHandler);
		},
		
		postAttachmentsWithArtifact: function(serviceResponseHandler, args)
		{
			this._invokeAttachService(serviceResponseHandler, "postAttachmentsWithArtifact", args);
		},
		
		getAttachmentsWithArtifact: function(serviceResponseHandler, args)
		{
			this._invokeAttachService(serviceResponseHandler, "getAttachmentsWithArtifact", args);
		}
	}	
})();
