/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");

dojo.declare("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	// transforms summary DTO to a full DTO
	map: function(summaryDTO) {
		// script
		summaryDTO.script = {};
		summaryDTO.script.id = summaryDTO.scriptId;
		summaryDTO.script.name = summaryDTO.scriptName;
		summaryDTO.scriptId = null;
		summaryDTO.scriptName = null;
		
		// test case
		summaryDTO.testCase = {};
		summaryDTO.testCase.id = summaryDTO.testCaseId;
		summaryDTO.testCase.name = summaryDTO.testCaseName;
		summaryDTO.testCaseId = null;
		summaryDTO.testCaseName = null;
		
		// state
		if (summaryDTO.stateName!=null) {
			stateId = summaryDTO.state;
			summaryDTO.state = { name : summaryDTO.stateName, id: stateId};
			summaryDTO.stateName = null;
		}
		
		return summaryDTO;
	}
	
});