/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { // module container 	

var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient = {

    REQ_WORKITEM_SERVICE_URI: "com.ibm.rqm.requirement.common.service.rest.IRequirementWorkItemRestService",
    
    _invokeService: function(responseHandler, method, appArgs){
        var actutualArgs = {};
        if (appArgs.testPlanItemId) {
            actutualArgs.testPlanItemId = appArgs.testPlanItemId;
        }
        if (appArgs.testCaseItemId) {
            actutualArgs.testCaseItemId = appArgs.testCaseItemId;
        }
        if (appArgs.addedRequirements) {
			actutualArgs.jsonString = dojo.toJson(appArgs.addedRequirements);
		}
		if (appArgs.workItemId) {
            actutualArgs.workItemId = appArgs.workItemId;
        }
		if (appArgs.reqWorkItemUUID) {
			actutualArgs.reqWorkItemUUID = appArgs.reqWorkItemUUID;
		}
		if (appArgs.relatedTestCaseItemId) {
			actutualArgs.relatedTestCaseItemId = appArgs.relatedTestCaseItemId;
		}
		actutualArgs.processArea = getCurrentProjectArea().itemId;
        var serviceRequest = new ServiceRequest(this.REQ_WORKITEM_SERVICE_URI, method, actutualArgs);
        TeamServerClient.invokeService(serviceRequest, responseHandler);
    },
    
    getRequirementWorkItemDTOs: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getWorkItemDTOs", params);
    },
    
    postRequirementWorkItems: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "postWorkItems", params);
    },
	
	getLastestWorkItemDTOs: function(serviceResponseHandler, params){
        this._invokeService(serviceResponseHandler, "getLastestWorkItemDTOs", params);
    },
	
	getTestCasesByRequirement: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getTestCasesByRequirement", params);
	},
	
	getTestPlansByRequirement: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getTestPlansByRequirement", params);
	}
};

})();