/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.rqm.defects.web.spi.RequirementsProvider");

dojo.require("com.ibm.team.repository.web.foundation.Status");

(function() {

var Status								= com.ibm.team.repository.web.foundation.Status;

dojo.declare("com.ibm.rqm.defects.web.spi.RequirementsProvider", null, {
	
	_providerId: null,
	_providerName: null,

	constructor: function(id, name) {
		this._providerId= id;
		this._providerName= name;	
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getProviderId: function() {
		return this._providerId;
	},
	
	getProviderName: function() {
		return this._providerName;
	},

	getConnectionName: function() {
		return null;
	},

	getConnectionDetails: function() {
		return null;
	},

	checkProviderStatus: function(resultCallback, cancelIfNotNotLoggedIn) {
		resultCallback(Status.OK_STATUS);
	},

	needsConfiguration: function() {
		return false;
	},

	isConfigured: function() {
		return true;
	},
	
	getConfigurationWizard: function() {
		return null;
	},
	
	initialize: function(runAfterInitialization) {
		runAfterInitialization();
	},

	queryAssociatedRequirements: function(ewiItemIdOrUri, monitor, runAfterQuery) {
		throw new Error("The RequirementsProvider " + this._providerId + " does not implement queryAssociatedDefects");
	},

	associateRequirement: function(linkDescription, monitor, runAfterAssociation) {
		throw new Error("The RequirementsProvider " + this._providerId + " does not implement associateDefect");
	},
		
	// ---- spi ------------------------------------------------------------------------------------------------------------	

	__sentinel: null // terminates this class definition
});

})();
