/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function() { //module container
    dojo.declare("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper",
        com.ibm.team.repository.web.transport.ServiceResponseHandler, {

        offlineAlert: { 'Dialog': null }, // use array to serve as class static variable

        // override the error call back to put up an alert dialog if the server seems to be down
        doErrorCallback: function(errorObj) {
            if (!errorObj.exception &&
                ((errorObj.status == 0) || (errorObj.status == 12029)) && // 12029 is used by IE for cannot connect
                (!errorObj.message ||
                    (errorObj.message.indexOf("Unknown") >= 0) ||  // "Unknown" is used by IE
                    (errorObj.message.indexOf("bad http response") >= 0))) {
                if (!this.offlineAlert.Dialog) {
                    try {
                        // show the alert dialog only if none is currently opened
                        this.offlineAlert.Dialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog({
                            'message': MessageUtil.getMessage(MessageBundle.COMMON, "serverMsgMaybeDown"),
                            'onClose': dojo.hitch(this, "closeAlertDialog")
                        });
                        this.offlineAlert.Dialog.open();
                    } catch (ex) {
                        // use javascript alert just in case the server is so down that
                        // it can't create the alert dialog
                        alert(MessageUtil.getMessage(MessageBundle.COMMON, "serverMsgMaybeDown"));
                    }
                }
            }
            com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper.superclass.doErrorCallback.apply(this, arguments);
        },
        
        // handler to track that the alert dialog is closed
        closeAlertDialog: function() {
            this.offlineAlert.Dialog = null;
        }
    })
})();