/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.asq.common.web.ui.internal.app.Layout");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.app.PaddedPageList");

(function() {

var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
var Constants = com.ibm.asq.common.web.client.internal.Constants;

function workbenchRootNode(){
    return net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode();
}

dojo.declare("com.ibm.asq.common.web.ui.internal.app.Layout", [dijit._Widget, dijit._Templated], {

    templatePath: dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/app/templates/Layout.html"),
    
    postCreate: function() {
        com.ibm.asq.common.web.ui.internal.app.Layout.superclass.postCreate.apply(this);
        
        this.createPageList();
        this.initHeaderPanels();
    },
    
    createPageList: function() {
        var args = {};
        var pageList = new com.ibm.asq.common.web.ui.internal.app.PaddedPageList(args);
        this.pageListContainer.appendChild(pageList.domNode);
    },

    initHeaderPanels: function() {
        var user = InitializationData.get("com.ibm.team.repository.service.currentContributorInitializer").currentContributor;
        this.loginUserLabel.innerHTML = Constants.getMessage("labelWelcome", user.neme);
        
        if (location.href.match(/^https/) === null) {
            this.logInOutLabel.innerHTML = Constants.getMessage("labelSignIn");
            this.logInOutAction.href = "https://" + window.location.hostname + ":9443" + window.location.pathname + window.location.search + window.location.hash;
        } else {
            this.logInOutLabel.innerHTML = Constants.getMessage("labelSignOut");
            this.logInOutAction.href = "/jazz/auth/logout";
        }
    },
    
    // setup and display the Help Info Center
    initHelpCenter: function(infoCenterLabel, infoCenterURL) {
        this.helpCenterContainer.style.visibility = "visible";
        this.helpCenterAction.href = infoCenterURL;
        this.helpCenterLabel.innerHTML = infoCenterLabel;
    },
    
    _setGutterHeight: function(gutterHeight) {
        this.leftGutter.style.height = gutterHeight + "px";
        this.rightGutter.style.height = gutterHeight + "px";
        
        var headerBannerHeight = this.headerBanner.clientHeight;
        var tabBarHeight = this.tabBar.clientHeight;
        var totalHeaderHeight = (gutterHeight == 0) ? 0 : headerBannerHeight + tabBarHeight;
         
        this.leftBorder.style.height = gutterHeight - totalHeaderHeight + "px";
        this.rightBorder.style.height = gutterHeight - totalHeaderHeight + "px";
    }
});

})();
