/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.page.planning.PlanningPageView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.planning.PlanningPageView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");

// Require the controller widget
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.planning.PlanningPageController");

// Require the repository widget needed to show the two column layout
dojo.require("com.ibm.team.repository.web.client.session.Session");

// Require the local widgets
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.PlanningBody");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.SearchNavWidget");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.HelpNavWidget");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SideActionPanel");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

// CML: hack: included here so they show up in firebug
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.viewlets.TestPlanViewlet");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.viewlets.TestCaseViewlet");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.viewlets.TestScriptViewlet");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.viewlets.TestViewlet");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WorkitemEditorViewlet");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WorkItemsViewlet"); //does not work and causing load error, comment out for now

(function()
{
	var Utility	                    = com.ibm.rqm.planning.web.ui.internal.util.Utility;
	var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
	var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	
	// This page view is not longer used, so don't abstract String to messages.js
	var STR_CREATE_TITLE       = "Create";
	var STR_CREATE_TEST_PLAN   = "New Test Plan";
	var STR_CREATE_TEST_GROUP  = "New Test Case Group";
	var STR_CREATE_TEST_CASE   = "New Test Case";
	var STR_CREATE_TEST_SCRIPT = "New Test Script"
	var STR_CREATE_EWI         = "New Test Execution Record";		// CML: term
	
	var STR_PLAN_TITLE    = "Test Plan Views";
	var STR_PLAN_MY_PLANS = "My Test Plans";
	var STR_PLAN_DUMMY    = "Project ABC Plans";
	
	var STR_EWI_TITLE   = "Test Execution Record Views";			// CML: term
	var STR_EWI_MY_EWIS = "My Test Execution Records";				// CML: term
	//var STR_EWI_DUMMY   = "Dummy EWI Entry";
	
	var STR_CASE_TITLE    = "Test Case Views";
	var STR_CASE_MY_CASES = "My Test Cases";
	var STR_CASE_DUMMY    = "Unassigned Test Cases";
	
	var STR_SCRIPT_TITLE     = "Test Scripts View";
	var STR_SCRIPT_MY_SCRIPTS = "My Test Scripts";
	
	var STR_GROUP_TITLE     = "Test Case Group View";
	var STR_GROUP_MY_GROUPS = "My Test Case Groups";
	//var STR_GROUP_DUMMY     = "Dummy Groups Entry";
	
	var PlatformUI			= net.jazz.ajax.ui.PlatformUI;
	var ActionRegistry		= null; // initialize later
	
	var NO_SECTION         = 0;
	var CREATE_SECTION     = 1;
	var PLAN_SECTION       = 2;
	var EWI_SECTION        = 3;
	var TEST_CASE_SECTION  = 4;
	var TEST_GROUP_SECTION = 5;
	var TEST_SCRIPT_SECTION = 6;

	dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.planning.PlanningPageView",
		 		 [dijit._Widget, dijit._Templated],
		{
			templateString: "<div class=\"com-ibm-rqm-test-planning-page\" dojoAttachPoint=\"_pageContainer\"></div>",
//			templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/planning/PlanningPageView.html"),
//			templateCssPath: dojo.uri.dojoUri( "../com.ibm.rqm.planning.web/ui/internal/page/templates/planning/PlanningPage.css"),
		
			_actions: [ 
				"defaultView",
				"genericSearch", "newQuery",
				"viewWorkItem",
				"newTestPlan", "viewTestPlan", "copyTestPlan", "viewTestPlans", 
				"newTestGroup", "viewTestGroup", "copyTestGroup", "viewTestGroups"], 
				
			_configurationActions: ["generateEWI", "showConfigurationList", "showEWILists"],
				
			_currentViewSelection: "My Test Plans",
			_currentViewSection: PLAN_SECTION,
				
			/*
			 * Required by Jazz web framework to make hyperlinking and back/forward
			 * work.
			 */
			getController: function()
			{
				return (this.controller);
			},
		
			// initialization
			postCreate: function() 
			{
				this.controller = new com.ibm.rqm.planning.web.ui.internal.page.planning.PlanningPageController(this);
//				this._leftNavigationLayout = new net.jazz.ajax.ui.SideNavigationLayout();
				this._leftNavigationLayout = new com.ibm.rqm.planning.web.ui.internal.view.common.SideActionPanel();
				this._pageContainer.appendChild(this._leftNavigationLayout.domNode);
//				this._leftNavigationLayout = dojo.widget.createWidget("LeftNavigationLayout", {}, this._pageContainer);

//				this.parentController = this._leftNavigationLayout.controller;
//			 	this.controller.parentController = this._leftNavigationLayout.controller;
//			 	this.controller.prototype = this._leftNavigationLayout.controller;

				this._bodyWidget = new com.ibm.rqm.planning.web.ui.internal.view.planning.PlanningBody({ parentController: this.controller });
//				this._bodyWidget = dojo.widget.createWidget("PlanningBody", { parentController: this.controller });
				this._leftNavigationLayout.setMainContent(this._bodyWidget.domNode, null);

				// lazily initialize the ActionRegistry alias
				ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();

				// register actions			
				for (var i = 0; i < this._actions.length; i++) 
				{
					var actionName = this._actions[i];
			        ActionRegistry.registerAction("com.ibm.rqm.planning.planning." + actionName, this.controller, actionName);
				}
				for (var i = 0; i < this._configurationActions.length; i++) 
				{
					var actionName = this._configurationActions[i];
			        ActionRegistry.registerAction("com.ibm.rqm.configuration." + actionName, this.controller, actionName);
				}						

				this._contributor = getAuthenticatedContributor();

				this._initializeNavigation({ parentController: this.controller });
			},
		
			_initializeNavigation: function(args)
			{
				this._navWidgetList = [];
				
				// add in search widget 
				this._searchNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.planning.SearchNavWidget(args);
				this._leftNavigationLayout.addNavigationSection(this._searchNavWidget.domNode, "");
				// don't push this onto the navWidgetList!!!
				
				// add in the help widget
				args.cshelpid = "rqm_planning_panel.html";
				this._helpNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.planning.HelpNavWidget(args);
				this._leftNavigationLayout.addNavigationSection(this._helpNavWidget.domNode, "");
				// don't push this onto the navWidgetList!!!

				args.bold = true;
				this._createNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);

				if ((this._contributor.name != "Joe Tester") &&
					(this._contributor.name != "Mary Testlead"))
				{
					this._createNavWidget.addEntry({ name: STR_CREATE_TEST_PLAN, href: Utility.getNewTestPlanURI(STR_CREATE_TEST_PLAN), isUnique: true});
				}
				
				if (this._contributor.name != "Joe Tester")
				{
					this._createNavWidget.addEntry({ name: STR_CREATE_TEST_GROUP, href: Utility.getNewTestGroupURI(STR_CREATE_TEST_GROUP), isUnique: true});
				}

//				this._createNavWidget.addEntry({ name: STR_CREATE_TEST_CASE, href: Utility.getNewTestCaseURI(STR_CREATE_TEST_CASE), isUnique: true});
				
				if (this._contributor.name != "John Architect")
				{
//					this._createNavWidget.addEntry({ name: STR_CREATE_TEST_SCRIPT, href: Utility.getNewTestScriptURI(STR_CREATE_TEST_SCRIPT), isUnique: true});
				}

				if (this._contributor.name != "John Architect")
				{
//					this._createNavWidget.addEntry({ name: STR_CREATE_EWI, href: Utility.getNewEwiURI(STR_CREATE_EWI), isUnique: true});
				}

				var sectionArray = [];
				sectionArray.push(this._createNavWidget);
				this._createNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_CREATE_TITLE, sectionWidgets: sectionArray, open: true});
				
				this._leftNavigationLayout.addNavigationSection(this._createNavSection.domNode, "");
//				this._leftNavigationLayout.addNavigationSection(this._createNavWidget.domNode, STR_CREATE_TITLE);
				this._navWidgetList.push(this._createNavWidget);
				
//				if ((this._contributor.name != "Joe Tester") &&
//					(this._contributor.name != "Mary Testlead"))
//				{
					args.bold = false;
					this._plansNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
					this._plansNavWidget.addEntry({ name: STR_PLAN_MY_PLANS, href: Utility.getTestPlansURI(STR_PLAN_MY_PLANS)});
					this._plansNavWidget.addEntry({ name: STR_PLAN_DUMMY, href: Utility.getTestPlansURI(STR_PLAN_DUMMY)});		

					sectionArray = [];
					sectionArray.push(this._plansNavWidget);
					this._plansNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_PLAN_TITLE, sectionWidgets: sectionArray, open: true});

					this._leftNavigationLayout.addNavigationSection(this._plansNavSection.domNode, "");
//					this._leftNavigationLayout.addNavigationSection(this._plansNavWidget.domNode, STR_PLAN_TITLE);
					this._navWidgetList.push(this._plansNavWidget);
//				}
				
				if (this._contributor.name != "John Architect")
				{
					args.bold = false;
//					this._ewiNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
//					this._ewiNavWidget.addEntry({ name: STR_EWI_MY_EWIS, href: Utility.getEwisURI(STR_EWI_MY_EWIS)});
   //					this._ewiNavWidget.addEntry({ name: STR_EWI_DUMMY, href: Utility.getEwisURI(STR_EWI_DUMMY)});			

					sectionArray = [];
//					sectionArray.push(this._ewiNavWidget);
//					this._ewiNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_EWI_TITLE, sectionWidgets: sectionArray, open: true});

//					this._leftNavigationLayout.addNavigationSection(this._ewiNavSection.domNode, "");
   //					this._leftNavigationLayout.addNavigationSection(this._ewiNavWidget.domNode, STR_EWI_TITLE);				
//					this._navWidgetList.push(this._ewiNavWidget);
				}

				if (this._contributor.name != "John Architect")
				{
					args.bold = false;
//					this._scriptsNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
//					this._scriptsNavWidget.addEntry({ name: STR_SCRIPT_MY_SCRIPTS, href: Utility.getTestScriptsURI(STR_SCRIPT_MY_SCRIPTS)});

					sectionArray = [];
//					sectionArray.push(this._scriptsNavWidget);
//					this._scriptsNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_SCRIPT_TITLE, sectionWidgets: sectionArray, open: true});

//					this._leftNavigationLayout.addNavigationSection(this._scriptsNavSection.domNode, "");
//					this._navWidgetList.push(this._scriptsNavWidget);
				}
				
				args.bold = false;
//				this._casesNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
//				this._casesNavWidget.addEntry({ name: STR_CASE_MY_CASES, href: Utility.getTestCasesURI(STR_CASE_MY_CASES)});
//				this._casesNavWidget.addEntry({ name: STR_CASE_DUMMY, href: Utility.getTestCasesURI(STR_CASE_DUMMY)});		

				sectionArray = [];
//				sectionArray.push(this._casesNavWidget);
//				this._casesNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_CASE_TITLE, sectionWidgets: sectionArray, open: true});

//				this._leftNavigationLayout.addNavigationSection(this._casesNavSection.domNode, "");
   //				this._leftNavigationLayout.addNavigationSection(this._casesNavWidget.domNode, STR_CASE_TITLE);				
//				this._navWidgetList.push(this._casesNavWidget);

//				if (this._contributor.name != "Joe Tester")
//				{
					args.bold = false;
					this._groupsNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
					this._groupsNavWidget.addEntry({ name: STR_GROUP_MY_GROUPS, href: Utility.getTestGroupsURI(STR_GROUP_MY_GROUPS)});
//					this._groupsNavWidget.addEntry({ name: STR_GROUP_DUMMY, href: Utility.getTestGroupsURI(STR_GROUP_DUMMY)});		

					sectionArray = [];
					sectionArray.push(this._groupsNavWidget);
					this._groupsNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_GROUP_TITLE, sectionWidgets: sectionArray, open: true});

					this._leftNavigationLayout.addNavigationSection(this._groupsNavSection.domNode, "");
//					this._leftNavigationLayout.addNavigationSection(this._groupsNavWidget.domNode, STR_GROUP_TITLE);				
					this._navWidgetList.push(this._groupsNavWidget);
//				}
			},
			
			_deselectPrevious: function(widget)
			{
				for(var i=0;i<this._navWidgetList.length;i++)
				{
					if(!(this._navWidgetList[i] === widget))
					{
						this._navWidgetList[i].selectEntry("");
					}
				}	
			},

			showWorkItem: function(args)
			{
				this._bodyWidget.viewWorkItem(args);				
			},

			/**************************************************************************************
			 * showGenericSearchResults
			 * 
			 * @param {Object} plan
			 **************************************************************************************/
			showGenericSearchResults: function(results)
			{
				this._deselectPrevious(null);
				this._bodyWidget.showGenericSearchResults(results);				
			},

			newQuery: function()
			{
				this._deselectPrevious(null);
				this._bodyWidget.newQuery();				
			},
					
			/* 
			 * TEST PLAN ACTIONS
			 */	
			showTestPlan: function(plan)
			{
				this._deselectPrevious(null);
				this._bodyWidget.showTestPlan(plan);				
			},
				
			copyTestPlan: function(plan)
			{
				this._deselectPrevious(null);
				this._bodyWidget.copyTestPlan(plan);				
			},
			
			showTestPlanList: function(plans, name)
			{
				this._deselectPrevious(this._plansNavWidget);
				this._plansNavWidget.selectEntry(name);
				this._currentViewSelection = name;
				this._currentViewSection = PLAN_SECTION;

				this._bodyWidget.showTestPlanList(plans, name); //displayTableData(name);
			},
				
			showNewTestPlan: function(name)
			{
				this._deselectPrevious(this._createNavWidget);
				this._createNavWidget.selectEntry(name);

				this._bodyWidget.newTestPlan();				
			},
			
			/*
			 * TEST PLAN GLOBAL SAVE
			 */
			saveTestPlan: function(){
				this._bodyWidget.saveTestPlan();
			},
				
			/* 
			 * TEST GROUP ACTIONS
			 */	
			showTestGroup: function(testGroup)
			{
				this._deselectPrevious(this._groupsNavWidget);
				this._bodyWidget.showTestGroup(testGroup);				
			},
				
			copyTestGroup: function(testGroup)
			{
				this._deselectPrevious(this._groupsNavWidget);
				this._bodyWidget.copyTestGroup(testGroup);				
			},
				
			showTestGroupList: function(groups, name)
			{
				this._deselectPrevious(this._groupsNavWidget);
				this._groupsNavWidget.selectEntry(name);
				this._currentViewSelection = name;
				this._currentViewSection = TEST_GROUP_SECTION;
				
				this._bodyWidget.showTestGroupList(groups, name);
			},
				
			showNewTestGroup: function(name)
			{
				this._deselectPrevious(this._createNavWidget);
				this._createNavWidget.selectEntry(name);
				
				this._bodyWidget.newTestGroup();				
			},
			
			returnToPreviousView: function()
			{
				switch(this._currentViewSection)
				{
//					case CREATE_SECTION:
//						widget = this._createNavWidget;
//						break;
					case PLAN_SECTION:
						Utility.setLocationToActionWithKeywords("viewTestPlans", {name: this._currentViewSelection});
						break;
//					case EWI_SECTION:
//						Utility.setLocationToActionWithKeywords("viewEwis", {name: this._currentViewSelection});
//						break;
//					case TEST_CASE_SECTION:
//						Utility.setLocationToActionWithKeywords("viewTestCases", {name: this._currentViewSelection});
//						break;
					case TEST_GROUP_SECTION:
						Utility.setLocationToActionWithKeywords("viewTestGroups", {name: this._currentViewSelection});
						break;
				}
			},
			
			/* 
			 * TEST SIZING ACTIONS
			 */	
			showTestSizing: function(sizing)
			{
				this._deselectPrevious(this._groupsNavWidget);
				this._bodyWidget.showTestSizing(sizing);				
			},	
			
			/*
			 * EXCUTION WORK ITEM ACTIONS
			 */
			generateEWI: function(param) {
				this._hideLeftNav();
				this._bodyWidget.generateEWI(param);
			},
			
			showConfigurationList:function(params) {
				this._hideLeftNav();
				this._bodyWidget.showConfigurationList(params);
			},
			
			showEWILists:function(params) {
				this._hideLeftNav();
				this._bodyWidget.showEWILists(params, this.controller);
			},
			
			_hideLeftNav: function(){
				if(this._leftNavigationLayout._currentLeftNavState == "open"){
					this._leftNavigationLayout._toggleLeftNav();
				}
			},
			openLeftNav: function(){
				if(this._leftNavigationLayout._currentLeftNavState == "close"){
					this._leftNavigationLayout._toggleLeftNav();
				}
			}
			
		}
	);
}
)();
