/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

PageUtil = dojo.provide("com.ibm.rational.test.lm.web.ui.internal.pages.PageUtil");
PageUtil.AssetsPageId       = "ASSETS";
PageUtil.RequestsPageId     = "REQUESTS";
PageUtil.ReservationsPageId = "RESERVATIONS";
PageUtil.ConfigurationsPageId = "CONFIGURATIONS";
PageUtil.InventoryPageId 	= "INVENTORY";
PageUtil.PageCache = {};


dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea");

(function() {

var BaseActionHref = "#action=com.ibm.rational.test.lm.web.ui.internal.pages.LabManagement.showViewPage";

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.pages.PageNavigator",
    com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea,
    {
        fixedSelection: null,
        
        postCreate: function() {
            com.ibm.rational.test.lm.web.ui.internal.pages.PageNavigator.superclass.postCreate.apply(this, arguments);

            this.setTitle("Views");
            if (this.fixedSelection && (this.fixedSelection == "Assets"))
                this.addFixedSelectionLink(dojo.hitch(this, "showAssets"), "Assets");
            else
                this.addLink(dojo.hitch(this, "showAssets"), "Assets");
                
            if (this.fixedSelection && (this.fixedSelection == "Requests"))
                this.addFixedSelectionLink(dojo.hitch(this, "showRequests"), "Requests");
            else
                this.addLink(dojo.hitch(this, "showRequests"), "Requests");

            if (this.fixedSelection && (this.fixedSelection == "Reservations"))
                this.addFixedSelectionLink(dojo.hitch(this, "showReservations"), "Reservations");
            else
                this.addLink(dojo.hitch(this, "showReservations"), "Reservations");

            if (this.fixedSelection && (this.fixedSelection == "Configurations"))
                this.addFixedSelectionLink(dojo.hitch(this, "showConfigurations"), "Configurations");
            else
                this.addLink(dojo.hitch(this, "showConfigurations"), "Configurations");

            if (this.fixedSelection && (this.fixedSelection == "Inventory"))
                this.addFixedSelectionLink(dojo.hitch(this, "showInventory"), "Inventory");
            else
                this.addLink(dojo.hitch(this, "showInventory"), "Inventory");
        },

        showAssets: function() {
            window.location.href = BaseActionHref + "&page=" + PageUtil.AssetsPageId;
        },
        
        showRequests: function() {
            window.location.href = BaseActionHref + "&page=" + PageUtil.RequestsPageId;
        },
        
        showReservations: function() {
            window.location.href = BaseActionHref + "&page=" + PageUtil.ReservationsPageId;
        },
		
        showConfigurations: function() {
            window.location.href = BaseActionHref + "&page=" + PageUtil.ConfigurationsPageId;
        },
		
        showInventory: function() {
            window.location.href = BaseActionHref + "&page=" + PageUtil.InventoryPageId;
        }
});

})();
