/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.test.RichTextPage");

dojo.require("dijit.Editor");
dojo.require("dojox.data.dom");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PageLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl");

(function(){

    function getWorkbench(){
        return net.jazz.ajax.ui.PlatformUI.getWorkbench();
    }
    
    var RichTextControl = com.ibm.asq.common.web.ui.internal.widgets.richtext.RichTextControl;
    
    dojo.declare("com.ibm.asq.common.web.ui.internal.test.RichTextPage", com.ibm.asq.common.web.ui.internal.view.layout.PageLayout, {
        postCreate: function(){
            this.defaultView = new com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout("Rich Text");
            this.defaultView.setTitle("Rich Text");
            this.inherited('postCreate', arguments);
            
            ActionRegistry = getWorkbench().getActionRegistry();
            ActionRegistry.registerAction("com.ibm.asq.common.web.ui.internal.test.RichTextPage.init", this, "init");
            
        },
        
        init: function(){
			console.debug("RichTextPage: init");
            var show = document.createElement("button");
            show.id = "button.show.editor";
            show.innerHTML = "Show Editor";
            dojo.connect(show, "onclick", this, this.showEditor);

            var toggle = document.createElement("button");
            toggle.id = "button.toggle.editable";
            toggle.disabled = true;
            toggle.innerHTML = "Toggle Editable";
            dojo.connect(toggle, "onclick", this, this.toggleEditable);

            var display = document.createElement("button");
            display.id = "button.get.content";
            display.disabled = true;
            display.innerHTML = "Get Content";
            dojo.connect(display, "onclick", this, this.showContentHTML);
                                    
            dojox.data.dom.removeChildren(this.defaultView.getContentNode());
            this.defaultView.getContentNode().appendChild(show);
            this.defaultView.getContentNode().appendChild(toggle);
			this.defaultView.getContentNode().appendChild(display);   
        },
        
        showEditor: function(){
			if (!this._richText) {
				this._richText = new RichTextControl({
					inEditMode: true,
					contentHTML: "<b>Add some content here</b>"
				});
	            var containerDiv = document.createElement("div");
	            containerDiv.style.width = "75%";
	            containerDiv.appendChild(this._richText.domNode);
	            
	            this.defaultView.getContentNode().appendChild(containerDiv);
	            dojo.byId("button.toggle.editable").disabled = false;
	            dojo.byId("button.get.content").disabled = false;
			}
			this._richText.show(); 	
        },
		
        toggleEditable: function(){
            if (this._richText) {
				this._richText.toggleEditable();
			}      
        },
		
		showContentHTML: function() {
		  alert("RichText's Content: \n" + this._richText.getContentHTML());
		} 				
    });
    
})();
