/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility")
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
(function() 
{
	var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var EditorFactory 	   				= com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
    var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
	var TestCaseTableView               = com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
	var TestCaseMapper				    = com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
	var TestCaseClient         		    = com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var Utility                         = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var PermissionsClient           	= com.ibm.asq.common.web.client.internal.PermissionsClient;
	var RegistryClient					= com.ibm.rqm.planning.web.client.internal.RegistryClient;
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
				this._stepsHaveVerdict = false; 
				this._executionElementResultStates = []; 
			},
	
			postCreate: function(args)
			{
                this.alreadyLoaded = [];
                
				// pre-load the required classes to avoid the extra wait when the user
				// first hit the action entries.
                this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView", null);
			},
			
		   /*
			* Provide access to an EditorFactory instance.
			*/
			getEditorFactory: function()
			{
				return EditorFactory;
			},
			
			initialize: function(args)
			{
				com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry.superclass.initialize.call(this, args);
				
                var tcPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
                var ewiPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
                var tsuitePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);	
				var resultPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_RESULT); 			

//                if (!ewiPerm || ewiPerm.create) 
//                {
//                    this._addMenuEntry(Constants.getMessage("labelMyEWI"), dojo.hitch(this, "_onClickMyExecutionWorkItems"), false, {'subAction': "viewMyExecutedItems"});
//                }
				this._addMenuEntry(Constants.getMessage("labelAllEWI"), dojo.hitch(this, "_onClickAllExecutionWorkItems"), false, {'subAction':"viewExecutedItems"});
				this._addMenuSeparator();
                if (!tsuitePerm || tsuitePerm.create) 
				{
					this._addNonDispatchableMenuEntry(Constants.getMessage("labelMyTestSuite"), dojo.hitch(this, "_onClickMyTestSuites"), false, null);
				}
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelAllTestSuite"), dojo.hitch(this, "_onClickAllTestSuites"), false, null);
				this._addMenuSeparator();
                /*
				if (!resultPerm || resultPerm.create) 
				{
					this._addMenuEntry(Constants.getMessage("labelMyExeResult"), dojo.hitch(this, "_onClickMyExecutionResults"), false, {'subAction': "viewMyResults"});
				}
				*/
				this._addMenuEntry(Constants.getMessage("labelAllExeResult"), dojo.hitch(this, "_onClickViewExecutionResults"), false, {'subAction': "viewResults"});
				this._addMenuSeparator();
                
                // no longer shows 'my' test case separately.
                //if (!tcPerm || tcPerm.create) 
				//{
				//	this._addNonDispatchableMenuEntry(Constants.getMessage("labelMyTestCase"), dojo.hitch(this, "_onClickMyTestCases"), false, null);
				//}

				this._addNonDispatchableMenuEntry(Constants.getMessage("labelAllTestCase"), dojo.hitch(this, "_onClickAllTestCases"), false, null);
				this._addMenuSeparator();
				this._addMenuEntry(Constants.getMessage("labelExecCon"), dojo.hitch(this, "_onClickShowExecutionConsole"), false, {'subAction':"viewExecutionConsole"});
				this._addMenuEntry(Constants.getMessage("labelAdapterConsole"), dojo.hitch(this, "_onClickShowAdapterStatus"), false, {'subAction': "viewAdapterStatus"});
				
				if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("startExecution", dojo.hitch(this, "startExecution"));
                    this.actionDispatcher.registerDispatchAction("viewResult", dojo.hitch(this, "showResult"));
					this.actionDispatcher.registerDispatchAction("viewEWIResults", dojo.hitch(this, "showEWIResults"));
					this.actionDispatcher.registerDispatchAction("runSuite", dojo.hitch(this, "runSuite"));
					this.actionDispatcher.registerDispatchAction("showSuiteResult", dojo.hitch(this, "showSuiteResult"));
                }
				
				var handler= new ServiceResponseHandler(this, "setElementResultStateTypes", "_error");
				RegistryClient.getAllExecutionElementResultStateTypes(handler);
			},
			
			setElementResultStateTypes: function(types){
				this._executionElementResultStates = types;
			},
			
			getElementResultStates: function(){
				return this._executionElementResultStates;
			},
			
			_onClickMyTestSuites: function()
			{
                window.location.hash = Utility.getMyTestSuitesURI();
			},
						
			_onClickAllTestSuites: function()
			{
                window.location.hash = Utility.getTestSuitesURI();
			},
			
            // OSOLETE - NOT USED.
			_fetchTestSuites: function(queryArgs){
				var func = function() {
					var list = new com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView({
							parentController: this, 
							suites: [],
                            showInitLoadProgress: true,
							queryName: queryArgs.name, 
							refreshCallback: dojo.hitch(this, "_refreshTestSuiteList", queryArgs)});
					list.setInProgress(Constants.getMessage("msgQueryTableList", queryArgs.name));
					this._addPage({name: queryArgs.name, content: list, closable: true});
					
					var self = this;
				 	var handler = {
                    	success: function(suites) {
                        	list.refresh(suites ? suites : []);
							list.stopInProgress();
                    	},
                    	error: function(e) {
                        	self._error(e);
                    	}
                	}
                
                	var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(handler, "success", "error");          
                	com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteSummaryDTOs(responseHandler, queryArgs); 
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView";
                this._loadClassAsync(classname, func);
			},

            // OSOLETE - NOT USED.
			_refreshTestSuiteList: function(queryArgs, tableView){
				this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", null);
				var self = this;
                var handler = {
                    success: function(suites) {
                        if (tableView && suites) {
                            tableView.refresh(suites);
                        }
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(handler, "success", "error");
                com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteSummaryDTOs(responseHandler, queryArgs);
			},
			
			_onClickShowExecutionConsole: function()
			{
				var args = {}
				var func = function() {
					args.parentController = this;
					args.name = Constants.getMessage("labelExecCon");
					var execConsole = new com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole(args);
					var browserTitle = Constants.getMessage("labelExecCon");
					this._addPage({name: args.name, content: execConsole, closable: true, browserTitle: browserTitle});
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole";
                this._loadClassAsync(classname, func);
			},
			
			runSuite: function(kwArgs)
			{
				var args = {}
				var func = function() {
					args.parentController = this;
					args.name = "Test Suite Execution";
					if(kwArgs.groupId)
						args.groupId = kwArgs.groupId;
					if(kwArgs.itemId)
						args.itemId = kwArgs.itemId;	
					var suiteConsole = new com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution(args);
					var page = this._addPage({name: args.name, content: suiteConsole, closable: true});
					suiteConsole.page = page;
					suiteConsole._updateBrowserTitle(); 
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution";
                this._loadClassAsync(classname, func);
			},
			
			showSuiteResult: function(kwArgs){
				var args = {}
				var func = function() {
					args.parentController = this;
					args.name = Constants.getMessage("labelSuiteResult");
					if(kwArgs.id)
						args.suiteId = kwArgs.id;
					if(kwArgs.itemId)
						args.itemId = kwArgs.itemId;	
					var suiteConsole = new com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog(args);
					var page = this._addPage({name: args.name, content: suiteConsole, closable: true});
					suiteConsole.page = page;
					suiteConsole._updateBrowserTitle();
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog";
                this._loadClassAsync(classname, func);
			},
			
			_onClickMyExecutionWorkItems: function()
			{
				var args = {}
				args.name = Constants.getMessage("labelMyEWI");
				args.owner = getAuthenticatedContributor().userId;
				args.browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView");
				this._showEwiList(args);
			},
			
			_onClickAllExecutionWorkItems: function()
			{
				var args = {}
				args.name = Constants.getMessage("labelAllEWI");
				args.browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                args.showQueryFilters = true;
				this._showEwiList(args);
			},
			
			_showEwiList: function(args)
			{
                var func = function() {
					args.parentController = this;
					var list = new com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList(args);
					this._addPage({name: args.name, content: list, closable: true, browserTitle: args.browserTitle});
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList";
                this._loadClassAsync(classname, func);
			},
			
			_onClickViewExecutionResults: function()
			{
				var func = dojo.hitch(this, function(){
					var args= { 
					   name: Constants.getMessage("labelAllExeResult"),
					   browserTitle: Constants.getMessage("labelExeResult") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView")
                    };
                    
                    //create and display the results table viewer (empty)
                    var _logTableViewer = new com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView({
                        results: [],
                        showQueryFilters: true,
                        queryName: args.name
                        //refreshCallback: dojo.hitch(this, function(){}) //"_refreshResultTable", args,suiteArgs) 
                    });              
                    this._addPage({name: args.name, content: _logTableViewer, closable: true, browserTitle: args.browserTitle});    	
				});
                this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView", func);								
			},
			
			startExecution: function(kwArgs)
			{
                var func = function() {
					var ewi = kwArgs.ewi;
					var runScript = kwArgs.runScript;
					var _resultId = null;
					var requestId = null;
					var ergId = null;
					if(kwArgs._resultId)
						_resultId =kwArgs._resultId; 
					if(kwArgs.requestId)
						requestId =kwArgs.requestId;
					if(kwArgs.ergId)
						ergId =kwArgs.ergId;		
						
					var _manualExecPage =new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody({ parentController: this, ewi: ewi, runScript: runScript, _resultId: _resultId, requestId: requestId, ergId: ergId });
					var page = this._addPage({name: Constants.getMessage("labelScriptExe"), content: _manualExecPage, closable: true});
					_manualExecPage.page = page;
					_manualExecPage._updateBrowserTitle();
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionPageBody";
                this._loadClassAsync(classname, func);
	
			},
			
			showResult: function(kwArgs)
			{
                var func = function() {
					var args ={
						parentController: this,
						ewiId: kwArgs.ewiId,
						resultItemId: kwArgs.resultItemId
					}
					if(kwArgs.editable)
						args.editable = kwArgs.editable;
					var _executionLog = new com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody(args);
					this._addPage({name: Constants.getMessage("labelExeResult"), 
						content: _executionLog, 
						closable: true,
						browserTitle: Constants.getMessage("labelExeResult")	
					});
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.execution.ExecutionLogBody";
                this._loadClassAsync(classname, func);
			},
			
			showEWIResults: function(args)
			{
                var func = function() {
					var _resultHistory = new com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory({ parentController: this, ewiItemId: args.ewiItemId });
					this._addPage({name: Constants.getMessage("labelResultHist"), 
						content: _resultHistory, 
						closable: true,
						browserTitle: Constants.getMessage("labelResultHist")
					});
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory";
                this._loadClassAsync(classname, func);
			},
			
			
			getStepsHaveVerdict: function()
			{
				return this._stepsHaveVerdict;
			},
	
			setStepsHaveVerdict: function(stepsHaveVerdict)
			{
				this._stepsHaveVerdict = stepsHaveVerdict;
			},
			
			_onClickMyTestCases: function()
			{
                window.location.hash = Utility.getMyTestCasesURI();
			},
            
            _onClickAllTestCases: function()
            {
                window.location.hash = Utility.getTestCasesURI();
            },            

            // OSOLETE - NOT USED.
			_loadTestCases: function(name, queryArgs)
            {
                queryArgs = queryArgs ? queryArgs : {};
				try{
					this._loadClassAsync("com.ibm.rational.test.lm.web.client.internal.config", null);
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient", null);
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", null);
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient", null);
				}catch(e){
					console.error("failed to load files async for ExecutionPopup in CABE");
				}
				var tableViewArgs = {
                    testCases: [], 
                    showInitLoadProgress: true,
                    queryName: name,
                    refreshCallback: dojo.hitch(this, "_refreshTestCaseList", queryArgs)                
                }
                
	            var list = new TestCaseTableView(tableViewArgs);
				list.setInProgress(Constants.getMessage("msgQueryTableList", name));
                // set the reference to the tabs container to allow checking for opened artifact editors
                list.artifactsDisplayContainer = this._contentArea;
                var pageName = name; 
				this._addPage( {name: pageName, content: list, closable: true});
				
                var self = this;
                var handler = {
                    success: function(cases) {
						list.refresh(cases ? cases : []);
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new TestCaseMapper(handler, "success", "error");          
                TestCaseClient.getTestCasesSummary(responseHandler, queryArgs);             
            }, 
            
            // OSOLETE - NOT USED.
            _refreshTestCaseList: function(queryArgs, tableView) {
                var self = this;
                var handler = {
                    success: function(cases) {
                        if (tableView) {
                            tableView.refresh(cases ? cases : []);
                        }
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new TestCaseMapper(handler, "success", "error");          
                TestCaseClient.getTestCasesSummary(responseHandler, queryArgs);                   
            },
			
			_onClickShowAdapterStatus: function(){
				var args = {}
				var func = function() {
					args.parentController = this;
					args.queryName = Constants.getMessage("labelAdapterConsole");
					args.hideReservationNode = true;
					var adapterConsole = new com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView(args);
					adapterConsole.setInProgress(Constants.getMessage("msgQueryTableList", Constants.getMessage("labelAdapters")));
					
					var browserTitle = Constants.getMessage("labelAdapterConsole");
					this._addPage({name: args.queryName, content: adapterConsole, closable: true, browserTitle: browserTitle});
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView";
                this._loadClassAsync(classname, func);
			},
			
			_error: function(error) 
			{
				console.debug("ExecutionActionBarEntry: Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
