/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.LabActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.LabActionBarEntry");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() 
{
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;

	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.LabActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
                this.initError = dojo.getObject("com.ibm.rqm.planning.web.ui.initError");
                
                // preload all dependent classes. This gives a better respond time
                // then just loading the page when it's accessed.
                if (!this.initError) {
                    this.alreadyLoaded = [];
                    
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.SimpleAssetsView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView", null); 
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", null);                
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.QueryRequestView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", null);             
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView", null);
                    this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.collections.CollectionsQueryView", null);
			    }
			},
           
            _showInitError: function()
            {
                // create a dialog to for the user to select a team area
                var container = document.createElement('span');
                var label1 = document.createTextNode(Constants.getMessage("errRTLMLabMgrGrpNotSet"));
                var label2 = document.createTextNode(this.initError['errorMessage']);
                container.appendChild(label1);
                container.appendChild(document.createElement('br'));
                container.appendChild(document.createElement('br'));
                container.appendChild(label2);
                                    
                var alertDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog();
                alertDialog.contentContainer.appendChild(container);
                alertDialog.setSecondaryTitle(Constants.getMessage("titleRTLMDisabled"));
                alertDialog.open();
            },
           
            _populateMenuEntries: function()
            {
                if (this.initError) {
                    // disable lab management if init failed - just put up entry to show
                    // the error message in the popup
                    this._addNonDispatchableMenuEntry(Constants.getMessage("labelRTLMDisabled"), dojo.hitch(this, "_showInitError"), true, null);
                    return;
                }
                
                var resPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE);
                var resGroupPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE_GROUP);
                var testEnvPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_TEST_ENVIRONMENT);
                var requestPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_REQUEST);
				var schemaPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_SCHEMA);

                this._addMenuEntry(Constants.getMessage("labelAllRes"), dojo.hitch(this, "_allResource"), false, {'subAction': "allAssets"});
                this._addMenuEntry(Constants.getMessage("labelFindRes"), dojo.hitch(this, "_findResource"), false, {'subAction': "searchAsset"});
                this._addMenuEntry(Constants.getMessage("labelAdvancedFind"), dojo.hitch(this, "_findResourceAdvanced"), false, {'subAction': "searchAssetAdvanced"});
                this._addMenuSeparator();
//              this._addMenuEntry(Constants.getMessage("labelMyRes"), dojo.hitch(this, "_onClickMyResources"), false, {'subAction': "myAsset"});
                
                if (!resPerm || resPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewMach"), dojo.hitch(this, "_createMachine"), false, {
                        'subAction': "newMachine",
                        'tq': ""
                    });
                    this._addMenuEntry(Constants.getMessage("labelNewVMImg"), dojo.hitch(this, "_createVirtualImage"), false, {
                        'subAction': "newVirtualImage",
                        'tq': ""
                    });
                    this._addMenuSeparator();
                }
                if (!resGroupPerm || resGroupPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewResGrp"), dojo.hitch(this, "_createResourceGroup"), false, {
                        'subAction': "newGroup",
                        'tq': ""
                    });
                }
                this._addMenuEntry(Constants.getMessage("labelAllResGrp"), dojo.hitch(this, "_manageResourceGroups"), false, {'subAction': "manageGroups"});
                this._addMenuSeparator();
                
                if (!requestPerm || requestPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewReq"), dojo.hitch(this, "_createRequest"), false, {
                        'subAction': "createRequest",
                        'tq': ""
                    });
	                this._addMenuEntry(Constants.getMessage("labelAllReq"), dojo.hitch(this, "_manageRequests"), false, {'subAction': "manageRequest"});
    	            this._addMenuSeparator();
                }

                if (!resPerm || resPerm[PermissionsClient.ACTION_CREATE]) 
				{
					this._addMenuEntry(Constants.getMessage("labelAllRsvp"), dojo.hitch(this, "_onClickManageReservations"), false, {'subAction': "manageReservations"});
					this._addMenuSeparator();
				}
                
                if (!testEnvPerm || testEnvPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuEntry(Constants.getMessage("labelNewCfg"), dojo.hitch(this, "_createConfiguration"), false, {
                        'subAction': "createConfiguration",
                        'tq': ""
                    });
                }
                this._addMenuEntry(Constants.getMessage("labelAllCfg"), dojo.hitch(this, "_onClickManageConfigurations"), false, {'subAction': "manageConfigurations"});
                this._addMenuEntry(Constants.getMessage("labelAllVirtualCollections"), dojo.hitch(this, "_onClickManageCollections"), false, {'subAction': "manageCollections"});
                this._addMenuSeparator();
                this._addMenuEntry(Constants.getMessage("labelAllAuto"), dojo.hitch(this, "_runAutomation"), false, {'subAction': "runAutomation"});
                this._addMenuEntry(Constants.getMessage("labelAllInvHist"), dojo.hitch(this, "_onClickManageInventory"), false, {'subAction': "manageInventory"});
                
                var needSep = true;
                if (!resPerm || resPerm[PermissionsClient.ACTION_CREATE]) {
                    this._addMenuSeparator();
                    this._addMenuEntry(Constants.getMessage("labelImportRes"), dojo.hitch(this, "_onClickImportResources"), false, {
                        'subAction': "importAsset"
                    });					
                    needSep = false;
                }
				
                if (!resPerm || resPerm[PermissionsClient.ACTION_ARCHIVE]) {
                    this._addMenuSeparator();
                    this._addMenuEntry(Constants.getMessage("labelArchivedLabResources"), dojo.hitch(this, "_manageArchivedAssets"), false, {'subAction': "manageArchivedAssets"});
                }

/*
 * MFV Not available for beta.  Uncomment after the Beta ships
                this._addMenuEntry(Constants.getMessage("labelImportResTemp"), dojo.hitch(this, "_onClickImportResourceTemplate"), false, {'subAction': "importTemplate"});
 */                               
                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewAsset", dojo.hitch(this, "_onViewAsset"));
                    this.actionDispatcher.registerDispatchAction("viewGroup", dojo.hitch(this, "_onViewGroup"));
                    this.actionDispatcher.registerDispatchAction("viewRequest", dojo.hitch(this, "_onViewRequest"));
                    this.actionDispatcher.registerDispatchAction("viewConfiguration", dojo.hitch(this, "_onViewConfiguration"));
                    this.actionDispatcher.registerDispatchAction("viewDeployments", dojo.hitch(this, "_onViewDeployments"));					
                    this.actionDispatcher.registerDispatchAction("viewInventory", dojo.hitch(this, "_onViewInventory"));					
                    this.actionDispatcher.registerDispatchAction("copyConfiguration", dojo.hitch(this, "_onCopyConfiguration"));
                }
            },
           
			initialize: function(args)
			{
				com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.LabActionBarEntry.superclass.initialize.call(this, args);
                this._populateMenuEntries();
			},
            
			_findResource: function(args)
			{
                var func = function() {
				    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView(args);
					var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelFind");
                    this._addPage( {name: Constants.getMessage("labelFindRes"), content: view, closable: true, browserTitle: browserTitle});
                };
                var classname = "com.ibm.rational.test.lm.web.ui.internal.views.machines.QueryAssetsView";
                this._loadClassAsync(classname, func);
				
			},
			_allResource: function(args)
			{
                var func = function() {
				    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.SimpleAssetsView(args);
					var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelAllView");
                    this._addPage( {name: Constants.getMessage("labelAllRes"), content: view, closable: true, browserTitle: browserTitle});
                };
                var classname = "com.ibm.rational.test.lm.web.ui.internal.views.machines.SimpleAssetsView";
                this._loadClassAsync(classname, func);
				
			},
			_findResourceAdvanced: function(args)
			{
                var func = function() {
				    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView(args);
					var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelAdvanceFind");
                    this._addPage( {name: Constants.getMessage("labelAdvancedFind"), content: view, closable: true, browserTitle: browserTitle});
                };
                var classname = "com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView";
                this._loadClassAsync(classname, func);
				
			},
			
            _manageArchivedAssets: function(args)
            {
                var func = function() {
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ArchivedAssetsView(args);
					var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelDeletedAndHidden");
                    this._addPage( {name: Constants.getMessage("labelArchivedLabResources"), content: view, closable: true, browserTitle: browserTitle});
                };
                var classname = "com.ibm.rational.test.lm.web.ui.internal.views.machines.ArchivedAssetsView";
                this._loadClassAsync(classname, func);                
            },
            
            _onViewAsset:function(args)
            {
                console.dir(args);
                var func = function(){
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView({
                        assetId: args.id,
                        assetType: args.type,
                        isNew: false,
                        isDeleted: (typeof args.deleted != "undefined" && args.deleted == "true")
                    });
                    var page = this._addPage({
                        name: Constants.getMessage("labelViewMach"),
                        content: view,
                        closable: true
                    });
					view.page = page;
					view._updateBrowserTitle();
                };
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView", func);
            },

            _onViewGroup: function(args) {
                var func = function() {
                    var initMessage = null;
                    var initStatus = null;
               
                    if (args.initMessage)
                        initMessage = args.initMessage;
        
                    if (args.initStatus)
                        initStatus = args.initStatus;

                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView({groupId:args.id, isNew:false, statusMessage:initMessage, statusState:initStatus});
                    this._addPage( {name: Constants.getMessage("labelResGrp"), content: view, closable: true});
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView", func);
            },
            
            _onViewRequest:function(args)
            {
                var func = function() {
                    var formArg = {
                        requestId: args.id, 
                        isNew: false
                    };
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView(formArg);
                    this._addPage( {name: Constants.getMessage("labelViewReq"), content: view, closable: true});   
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView", func);
            },

            _onViewConfiguration:function(args)
            {
                var func = function(){
                    var editorArgs = {
    					isNew: false,
                        configId: args.id,
                        assetType: args.type
                    }
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor(editorArgs);
                    this._addPage({
                        name: Constants.getMessage("labelViewCfg"),
                        content: view,
                        closable: true
                    });
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", func);
            },

            _onCopyConfiguration:function(args)
            {
                var func = function(){
                    var editorArgs = {
    					isNew: true,
                        isCopy: true,
                        configId: args.id,
                        assetType: args.type
                    }
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor(editorArgs);
                    this._addPage({
                        name: Constants.getMessage("labelViewCfg"),
                        content: view,
                        closable: true
                    });
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", func);
            },
			
            _onViewDeployments: function(args)
            {
                var viewArgs = {};
                   
                if(args && args.autoDeployRefresh) {
                    viewArgs['autoDeployRefresh'] = args.autoDeployRefresh;
                }
                var func = function(){
	               var view = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView(viewArgs);
                    this._addPage({
                        name: Constants.getMessage("labelViewInvHist"),
                        content: view,
                        closable: true
                    });
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", func);
            },

            _onViewInventory: function(args)
            {
				var func = function(){
					var view = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView();
					this._addPage({
						name: Constants.getMessage("labelViewInvHist"),
						content: view,
						closable: true
					});
				}
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", func);
            },
			
//			_onClickMyResources: function()
//			{
//				this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView", "_myResources");
//			},
			
//			_myResources: function()
//			{
//				this._addPage( {name: Constants.getMessage("labelMyRes"), content: "This is the work area for Finding a Machine.", closable: true});
//			},

			_createMachine: function(args)
			{
                var func = function(){
                    var id = dojo.date.locale.format(new Date(), {
                        selector: "time",
                        timePattern: "hh:mm:ss"
                    });
                    var machine = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView({
                        assetId: id,
                        assetType: "Machine" /* CML: hack */,
                        isNew: true
                    });
                    var page = this._addPage({
                        name: Constants.getMessage("labelNewMach"),
                        content: machine,
                        closable: true
                    });
					machine.page = page;
					machine._updateBrowserTitle();
                    // initialize the tab's icon.
                    page.controlButton.containerNode.className = "machine-icon-16";
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView", func);
			},

            _createVirtualImage: function(args)
            {
                var func = function(){
                    var id = dojo.date.locale.format(new Date(), {
                        selector: "time",
                        timePattern: "hh:mm:ss"
                    });
                    var machine = new com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView({
                        assetId: id,
                        assetType: "VirtualImage" /* CML: hack */,
                        isNew: true
                    });
                    var page = this._addPage({
                        name: Constants.getMessage("labelNewVMImg"),
                        content: machine,
                        closable: true
                    });
					machine.page = page;
					machine._updateBrowserTitle();
                    // initialize the tab's icon.
                    page.controlButton.containerNode.className = "vm-icon-16";
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.AssetDetailView", func);
            },
			
			_onClickImportResources: function()
			{
                var func = function(){
				    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView("asset");
					var browserTitle = Constants.getMessage("labelLabRes") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
                    this._addPage({
                        name: Constants.getMessage("labelImportRes"),
                        content: view,
                        closable: true,
						browserTitle: browserTitle
                    });
                }
				this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView", func);
			},
			
			_onClickImportResourceTemplate: function()
			{
                var func = function(){
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView("schema");
                    this._addPage({
                        name: Constants.getMessage("labelImportResTemp"),
                        content: view,
                        closable: true
                    });
                }
				this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ImportMachineView", func);
			},
			
			_manageResourceGroups: function(args)
			{
                var func = function(){
				    var group = new com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView({showAll:true});
					var browserTitle = Constants.getMessage("labelResGrp") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");					
                    this._addPage({
                        name: Constants.getMessage("labelAllResGrp"),
                        content: group,
                        closable: true,
						browserTitle: browserTitle
                    });
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView", func);
			},
			
			_createResourceGroup: function(args)
			{
                var func = function(){
                    var id = dojo.date.locale.format(new Date(), {
                        selector: "time",
                        timePattern: "hh:mm:ss"
                    });
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView({
                        groupId: id,
                        isNew: true
                    });
                    var page = this._addPage({
                        name: Constants.getMessage("labelNewResGrp"),
                        content: view,
                        closable: true
                    });
					view.page = page;
					view._updateBrowserTitle();
                    // initialize the tab's icon.
                    page.controlButton.containerNode.className = "machine-group-icon-16";
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.machines.GroupDetailView", func);
			},
			
			_onClickManageConfigurations: function()
			{
                var func = function(){
	               var view = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView();
				   var browserTitle = Constants.getMessage("labelConfiguration") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                    this._addPage({
                        name: Constants.getMessage("labelAllCfg"),
                        content: view,
                        closable: true,
						browserTitle: browserTitle
                    });
                }
				this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView", func);
			},
			
			_createConfiguration: function(args)
			{
                var func = function(){
                    var id = dojo.date.locale.format(new Date(), {
                        selector: "time",
                        timePattern: "hh:mm:ss"
                    });
                    var editorArgs = {
					isNew: true,
					configId: id,
					assetType: "Machine"	// CML: hack
				    };
            	    var editor = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor(editorArgs);
                    var page = this._addPage({
                        name: Constants.getMessage("labelNewCfg"),
                        content: editor,
                        closable: true
                    });
					editor.page = page;
					editor._updateBrowserTitle();
                    // initialize the tab's icon.
                    page.controlButton.containerNode.className = "config-icon-16";
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationEditor", func);
			},
			
            _onClickManageCollections: function( arguments )
            {
				if( arguments[ "id" ] )
				{
					dojo.setObject( "com.ibm.rational.test.lm.web.collection-id", arguments[ "id" ] );
				}
				
				if( arguments[ "type" ] )
				{
					dojo.setObject( "com.ibm.rational.test.lm.web.collection-type", arguments[ "type" ] );					
				}
				
                var func = function(){
	                var view = new com.ibm.rational.test.lm.web.ui.internal.views.collections.CollectionsQueryView();
					var browserTitle = Constants.getMessage("labelVirtualCollection") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                    this._addPage({
                        name: Constants.getMessage("labelAllVirtualCollections"),
                        content: view,
                        closable: true,
						browserTitle: browserTitle
                    });
					
                }
				
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.collections.CollectionsQueryView", func);
            },
            
			_manageRequests: function()
			{
                var func = function(){
					
					var req = new com.ibm.rational.test.lm.web.ui.internal.views.requests.QueryRequestView();
					var browserTitle = Constants.getMessage("labelRequest") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView"); 
                    this._addPage({
                        name: Constants.getMessage("labelAllReq"),
                        content: req,
                        closable: true,
						browserTitle: browserTitle
                    });
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.QueryRequestView", func);
			},
			
			_createRequest: function(args)
			{
                var func = function(){
                    var id = dojo.date.locale.format(new Date(), {
                        selector: "time",
                        timePattern: "hh:mm:ss"
                    });
                    var formArg = {
                        requestId: id,
                        isNew: true
                    };
                    if(args) {
                        for(var argName in args) {
                            formArg[argName] = args[argName];
                        }
                    }
    	            var requestView = new com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView(formArg);
                    var page = this._addPage({
                        name: Constants.getMessage("labelNewReq"),
                        content: requestView,
                        closable: true
                    });
					requestView.page = page;
					requestView._updateBrowserTitle();
                    // initialize the tab's icon.
                    page.controlButton.containerNode.className = "request-icon-16";
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestView", func);
			},
			
			_runAutomation: function(args)
			{
                var func = function(){
                    var view = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView();
                    
                    if(args)
                        view.showAutomationsForMachines( args.assetId );
					var browserTitle = Constants.getMessage("labelAutomation") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");						
                    this._addPage({
                        name: Constants.getMessage("labelAllAuto"),
                        content: view,
                        closable: true,
						browserTitle: browserTitle
                    });
                }
                this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView", func);
            },
			
			_onClickManageInventory: function(args)
			{
                var func = function(){
	               var view = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView();
				   var browserTitle = Constants.getMessage("labelInventoryHistory") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                   this._addPage({
                        name: Constants.getMessage("labelAllInvHist"),
                        content: view,
                        closable: true,
						browserTitle: browserTitle
                    });
                }
				this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView", func);
			},
			
			_onClickManageReservations: function()
			{
                var func = function(){
	               var view = new com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations();
				   var browserTitle = Constants.getMessage("labelReservation") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                   this._addPage({
                        name: Constants.getMessage("labelAllRsvp"),
                        content: view,
                        closable: true,
						browserTitle: browserTitle
                    });
                }
				this._loadClassAsync("com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations", func);
			},
			
			_error: function(error) 
			{
				console.debug("LabActionBarEntry: Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
