/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable");
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.DateTextBox");
dojo.require("dijit.form.NumberTextBox");

dojo.require("dojox.data.dom");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");

dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.process.web.ui.internal.util.PermissionControlUtil");
dojo.require("com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog");

(function(){
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var util = com.ibm.team.workitem.web.client.util;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var permissonUtil = com.ibm.rqm.process.web.ui.internal.util.PermissionControlUtil;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	
    dojo.declare("ApprovalTable.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        parentView: null,
        
        constructor: function(testView){
            this.parentView = testView;
        },
        
        rowCheckStateChanged: function(tableViewer, rowObject, state){
            rowObject.selected = state;
			var selectionCount = tableViewer.getCheckedRows().length;
        	if (this.parentView.deleteActionNode)
            	this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
        },
        
        tableContentSelectionChanged: function(tableViewer, contentSelectionValue){
            var content = this.parentView.changeContent(contentSelectionValue);
            tableViewer.setContent(content);
            tableViewer.show();
        },

        tableContentActionInvoked: function(tableViewer, actionId, callbackData){
            switch (actionId) {
                case "add":
                    this.parentView._handleAddNewClick();
                    break;
                case "remove":
                    this.parentView._handleDeleteClick();
                    break;
                default:
                    break;
            }
        }
    });
    
    dojo.declare("ApprovalTable.CellModifier", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, {
        tableViewer: null,
        
        constructor: function(viewer, parent){
            this.tableViewer = viewer;
            this.parent = parent;
        },
        
        cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
            if (this.parent.parentSection) {
                this.parent.parentSection.setDirty();
            }
            switch (columnIndex) {
                case 2:
                    rowObject.resultType = newValue;
                    break;
                case 3:
                    rowObject.col4 = newValue;
                    break;
                case 0:
                    rowObject.col1 = newValue;
                    break;
                case 1:
                    rowObject.ownerItem = newValue;
                    break;
                case 4:
                    rowObject.col5 = newValue;
                    break;
                default:
                    break;
            }
        },
        
        cellActionInvoked: function(rowObject, columnIndex){
        }
    });
    
    dojo.declare("ApprovalTable.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        getNumColumns: function(content){
            return 5;
        },

        getColumnHeading: function(content, index){
            var headings = [Constants.APPROVAL_TITLE_APPROVAL_TABLE, Constants.APPROVAL_NAME_APPROVAL_TABLE, Constants.APPROVAL_STATUS_APPROVAL_TABLE, Constants.APPROVAL_COMMENTS_APPROVAL_TABLE, Constants.APPROVAL_MODIFIED_APPROVAL_TABLE];
            return headings[index];
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
            return (atColumnIndex == 0 ||atColumnIndex == 2);
        },
        
        getColumnWidth: function(content, atColumnIndex){
            var width = 16;
            switch (atColumnIndex) {
                case 0:
                    width = 15;
                    break;
                case 1:
                    width = 20;
                    break;
                case 2:
                    width = 15;
                    break;
                case 3:
                    width = 40;
                    break;
                case 4:
                    width = 10;
                    break;
            }
            return width;
        },
        getIsCellEditable: function(rowData, atColumnIndex){
            var isEditable = false;
			var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
            var hasCreatorPermission = !permission || permission[PermissionsClient.ACTION_CREATE];
            switch (atColumnIndex) {
                case 0:
                case 1:
                    isEditable = (hasCreatorPermission && !permissonUtil.checkOperation(rowData.role, Constants.ROLE_REVIEWER) && (!rowData.col3 || rowData.col3 == Constants.TYPE_PENDING)) ? true : false;
                    break;
                case 2:
                    isEditable = ((permissonUtil.checkOperation(rowData.role, Constants.ROLE_REVIEWER) && rowData.col3 == Constants.TYPE_PENDING) ||
                    (hasCreatorPermission && rowData.col3 == Constants.TYPE_REJECTED)) ? true : false;
                    break;
                case 3:
                    isEditable = (permissonUtil.checkOperation(rowData.role, Constants.ROLE_REVIEWER) && rowData.col3 == Constants.TYPE_PENDING) ? true : false;
                    break;
                case 4:
                    isEditable = false;
                    break;
            }
            return isEditable;
        },
        
        getContentObjects: function(content){
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.id;
        },
        
        getCellDisplayType: function(rowData, atColumnIndex){
            var type = TableConstants.RENDER_TYPE_ENUM;            
            switch (atColumnIndex) {
                case 3:
                    type = TableConstants.RENDER_TYPE_COMMENT;
                    break;
                case 4:
                    type = TableConstants.RENDER_TYPE_TIMESTAMP;
                    break;
            }
            return type;
        },
        
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.col1;
                    break;
                case 1:
                    val = (rowData.col2 == null) ? null : rowData.col2.name;
                    break;
                case 2:
                    val = rowData.col3;
                    break;
                case 3:
					if(this.getIsCellEditable(rowData,atColumnIndex))
						val = rowData.col4;
					else
                    	val = rowData.shortComment;
                    break;
                case 4:
                    val = rowData.col5;
                    break;
            }
            return val;
        },
     
	    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
            var val = {};
            if (atColumnIndex == 0) {
                val['select'] = rowData.col1;
                val['choices'] = [{
                    'text': Constants.APPROVAL_APPROVAL_APPROVAL_TABLE,
                    'value': Constants.TYPE_APPROVER
                }, {
                    'text': Constants.APPROVAL_REVIEWER_APPROVAL_TABLE,
                    'value': Constants.TYPE_REVIEWER
                }];
            }
            if (atColumnIndex == 1) {
                val['select'] = rowData.ownerItem;//(typeof rowData.selection != "undefined") ? rowData.selection : null;
                val['choices'] = [];
				//Iterate over all the possible owners adding only those that are not archived OR match the current owner.
				for (var i = 0; rowData.owner != null && i < rowData.owner.length; i++)
				{
					if (rowData.owner[i].text == "Unassigned")
						rowData.owner[i].text = Constants.getMessage("labelUnassigned");
						
					if (!rowData.owner[i].archived) 
						val['choices'].push(rowData.owner[i]);
					else 
						if (rowData.owner[i].value == rowData.ownerItem) 
						{
							rowData.owner[i].disabled = true;
							val['choices'].push(rowData.owner[i]);
						}						
				}			
            }
            if (atColumnIndex == 2) {
                val['select'] = (rowData.resultType == null) ? rowData.col3 : rowData.resultType;
                val['choices'] = [{
                    'text': Constants.APPROVAL_PENDING_APPROVAL_TABLE,
                    'value': Constants.TYPE_PENDING
                }, {
                    'text': Constants.APPROVAL_APPROVED_APPROVAL_TABLE,
                    'value': Constants.TYPE_APPROVED
                }, {
                    'text': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                    'value': Constants.TYPE_REJECTED
                }];
				if (rowData.col1 == Constants.TYPE_REVIEWER) 
                	val['choices'] = [{
                		'text': Constants.APPROVAL_PENDING_APPROVAL_TABLE,
                    	'value': Constants.TYPE_PENDING
                	}, {
                    	'text': Constants.APPROVAL_REVIEWED_APPROVAL_TABLE,
                    	'value': Constants.TYPE_APPROVED
                    }];
				var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
            	if (!permission || permission[PermissionsClient.ACTION_CREATE])	{
                    if (rowData.col3 == Constants.TYPE_REJECTED) 
                        val['choices'] = [{
                            'text': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                            'value': Constants.TYPE_REJECTED
                        }, {
                            'text': Constants.APPROVAL_REOPEN_APPROVAL_TABLE,
                            'value': Constants.TYPE_PENDING
                        }];
                }
                else 
                    if (permissonUtil.checkOperation(rowData.role, Constants.ROLE_REVIEWER)) {
                        if (rowData.col1 == Constants.TYPE_APPROVER) 
                            val['choices'] = [{
                                'text': ' ',
                                'value': Constants.TYPE_PENDING
                            }, {
                                'text': Constants.APPROVAL_APPROVED_APPROVAL_TABLE,
                                'value': Constants.TYPE_APPROVED
                            }, {
                                'text': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                                'value': Constants.TYPE_REJECTED
                            }];
                    }
            }
            if (atColumnIndex == 3) {
                val['tooltip'] = rowData.col4;
            }
            if (rowData.selected) {
                val['state'] = true;
            }
            return val;
        }
    });
    
    dojo.declare("com.ibm.rqm.process.web.ui.internal.view.approval.ApprovalTable", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1">' +
        '</div>',
        widgetsInTemplate: true,
        printable: false,
		
        constructor: function(args){
            this.appResults = null;
            this._itemId = null;
            this.role = []; //0: manager; 1: approver/reviewer; 2: others
            this.content = null;
            this.owner = null;
            this.deleted = null;
            this.updated = null;
            this.currentUser = null;
            this.sectionOwner = null;
            this._id = 0;
        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
        },
        
        initialize: function(args){
            this.deleted = new Array();
            this.updated = new Array();
            this.parentSection = args.parentSection ? args.parentSection : null;
			this.printable = args.printable ? args.printable : null;
            this.appResults = args.appResults;
            this._itemId = args.itemId;
            this._itemType = args.itemType;
            this._sectionContainer = args.sectionContainer;
            this._mainReview = args.mainReview;
            this.sectionOwner = args.sectionOwner;
            this.owner = args.owner;
            if (args.role == Constants.ROLE_OWNER) 
                this.role.push(args.role);
            this.currentUser = args.currentUser;
//            this.projectAreaName = EditorUtil.getCurrentProjectArea().name;
            
	        //create the table viewer
	        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
	            //turn off all controls if in print mode 
	            showPagingControl: !this.printable,
				showPagingRangeControl: !this.printable,
	            showGroupFilterControls: !this.printable,
	            showPagingActionsControls: !this.printable,
                allowAdjustSettings: true,
                autoSaveSettings: true,
                tableId: "RQM-PROC-APPROVAL-TABLEVIEWER"                         
	        });
		
            this.domNode.appendChild(tableViewer.domNode);
            this.tableViewer = tableViewer;
            
            this.content = this.createContent();
            var contentProvider = new ApprovalTable.TableProvider();
            
            var views = [{
                'name': Constants.APPROVAL_ALL_APPROVAL_TABLE,
                'value': 0
            }, {
                'name': Constants.APPROVAL_PENDING_APPROVAL_TABLE,
                'value': 1
            }, {
                'name': Constants.APPROVAL_APPROVED_APPROVAL_TABLE,
                'value': 2
            }, {
                'name': Constants.APPROVAL_REJECTED_APPROVAL_TABLE,
                'value': 3
            }];
            tableViewer.setTableContentSelectors(views);
            
			var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
            // check permission for add reviewer
            if (!permission || permission[PermissionsClient.ACTION_CREATE]) {
           	    tableViewer.addAction("add", Constants.APPROVAL_ADD_AR_APPROVAL_TABLE, "_handleAddNewClick", "add-icon-image");
                this.deleteActionNode = tableViewer.addAction("remove", Constants.APPROVAL_REMOVE_AR_APPROVAL_TABLE, "_handleDeleteClick", "remove-enabled-icon-image");
				this.deleteActionNode.setDisabled(true);
            }
            tableViewer.setContent(this.content);
            tableViewer.setContentProvider(contentProvider);
            tableViewer.setTableListener(new ApprovalTable.TableListener(this));
            tableViewer.setCellModifier(new ApprovalTable.CellModifier(tableViewer, this));
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelFormalReview")));
            tableViewer.show();
        },
        
        
        createContent: function(){
            var rows = [];
            if (this.appResults == null) {
                return rows;
            }
            for (var i = 0; i < this.appResults.length; i++) {
                var res = this.appResults[i];
                var tmpRole = [];
                if (permissonUtil.checkOperation(this.role, Constants.ROLE_OWNER)) 
                    tmpRole.push(Constants.ROLE_OWNER);
                if (res.owner.itemId == this.currentUser.itemId) {
                    this.role.push(Constants.ROLE_REVIEWER);
                    tmpRole.push(Constants.ROLE_REVIEWER);
                }
				var comment = (res.comments == null) ? "" : res.comments[res.comments.length - 1].content;
				comment = this.getSafeText(comment);
				var shortComment = this.getClippedComment(comment);
                var obj = {
                    col1: res.approvalType,
                    col2: res.owner,
                    col3: res.status,
                    col4: comment,
                    col5: (res.date == null) ? "" : res.date,
                    owner: this.owner,
                    ownerItem: res.owner.itemId,
                    resultType: res.status,
                    type: 0, //type=0: existed; type=1: new;
                    role: tmpRole,//(this.role == 0)?this.role:tmpRole
                    id: ++this._id,
					shortComment:shortComment
                };
                rows.push(obj);
            }
            return rows;
        },
        
        //value=0: All; value=1: Pending; value=2: Approved; value=3: Rejected
        changeContent: function(value){
            var newContent = [];
            switch (value) {
                case "0":
                    newContent = this.content;
                    break;
                case "1":
                    if (this.content && this.content.length > 0) {
                        for (var i = 0; i < this.content.length; i++) {
                            if (!this.content[i].col3 || this.content[i].col3 == Constants.TYPE_PENDING) 
                                newContent.push(this.content[i]);
                        }
                    }
                    break;
                case "2":
                    if (this.content && this.content.length > 0) {
                        for (var i = 0; i < this.content.length; i++) {
                            if (this.content[i].col3 == Constants.TYPE_APPROVED) 
                                newContent.push(this.content[i]);
                        }
                    }
                    break;
                case "3":
                    if (this.content && this.content.length > 0) {
                        for (var i = 0; i < this.content.length; i++) {
                            if (this.content[i].col3 == Constants.TYPE_REJECTED) 
                                newContent.push(this.content[i]);
                        }
                    }
                    break;
                default:
                    break;
            }
            return newContent;
        },
        
        _handleAddNewClick: function(){
            var selectedOwner = [];
            if (this.content && this.content.length > 0) {
                for (var i = 0; i < this.content.length; i++) {
                    selectedOwner.push({
                        'itemId': this.content[i].ownerItem
                    });
                }
            }
            var self = this;
            var params = {
                title: Constants.APPROVAL_ADD_USERS_APPROVAL_TABLE,
                parentElement: this.domNode,
                disableUsers: selectedOwner,
                parent: this
            };
            new com.ibm.rqm.process.web.ui.internal.view.approval.UserSelectionDialog(params);
		},
        
        _handleDeleteClick: function(){
			this.parentSection.getParentEditor().clearStatus();
            var dels = this.tableViewer.getCheckedRows();
            if (dels && dels.length > 0) {
				for (var i = 0; i < dels.length; i++) {
                	if ((dels[i].col3 && (dels[i].col3 == Constants.TYPE_APPROVED || dels[i].col3 == Constants.TYPE_REJECTED))) {
                        var msg = Constants.getMessage("msgDelReviewItems");
		                var args = {
				            'message': msg
				        };
				        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(args);
				        confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
				        confirmDialog.open();
						break;
                    }
                    else {
                        this.deleted.push(dels[i]);
                        this.tableViewer.deleteItem(dels[i]);
                    }
                }
                this.content = this.tableViewer.getContent();
                this.tableViewer.show();
                if (this.parentSection != null) {
                    this.parentSection.setDirty();
                }
            }
            else {
				this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, 
					Constants.APPROVAL_REMOVE_MORE_WARNING_APPROVAL_TABLE);
            }
        },
        
        changeRowEditable: function(isEditable){
            if (isEditable) {
				var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
                var checkable = (!permission || permission[PermissionsClient.ACTION_CREATE]) ? true : false;
                this.tableViewer.setTableRowsCheckable(!this.printable, false);
                this.tableViewer.setEditable(true);            }
            else {
                this.tableViewer.setTableRowsCheckable(false, false);
                this.tableViewer.setEditable(false);
            }
            this.tableViewer.show();
        },
        
        getSavedParam: function(){
            var param = {};
            var addArray = new Array();
            var deleteArray = new Array();
            var updateArray = new Array();
			var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_PROCESS_APPROVAL);
            if (!permission || permission[PermissionsClient.ACTION_CREATE]) {
                if (!this._validateUsers()) {
                    return param;
                }
                if (this.content && this.content.length > 0) {
                    for (var i = 0; i < this.content.length; i++) {
                        if (this.content[i].type == 1 || this.content[i].col3 == Constants.TYPE_PENDING) {
                            var obj = this.content[i];
                            var params = {
                                originator: this.currentUser.itemId,
                                owner: obj.ownerItem,
                                approvalType: obj.col1,
                                //									status: obj.resultType,
                                artifactItemTypeName: this._itemType,
                                artifactPackageUri: Constants.PACKAGE_URI,
                                artifactItemId: this._itemId,
//                                projectAreaName: this.projectAreaName,
                                //Set the summary.  This is used if/when a work item is created for this new approval.
                                //Get the artifact type (Test Plan, Test Case) and artifact name from the parent editor
								summary: Constants.getMessage("msgApprovalSummary", this.parentSection.getParentEditor().getArtifactType(), this.parentSection.getParentEditor().getHeader().getTitle())
                            }
                            addArray.push(params);
                        }
                        if (this.content[i].type == 0 && this.content[i].col3 == Constants.TYPE_PENDING) {
                            var params = {
                                owner: this.content[i].col2.itemId,
                                artifactItemTypeName: this._itemType,
                                artifactPackageUri: Constants.PACKAGE_URI,
                                artifactItemId: this._itemId
//                                projectAreaName: this.projectAreaName
                            }
                            deleteArray.push(params);
                        }
                    }
                }
                if (this.deleted && this.deleted.length > 0) {
                    for (var i = 0; i < this.deleted.length; i++) {
                        if (this.deleted[i].type == 0) {
                            var params = {
                                owner: this.deleted[i].col2.itemId,
                                artifactItemTypeName: this._itemType,
                                artifactPackageUri: Constants.PACKAGE_URI,
                                artifactItemId: this._itemId
//                                projectAreaName: this.projectAreaName
                            }
                            deleteArray.push(params);
                        }
                    }
                }
                
                for (var i = 0; i < this.content.length; i++) {
                    //reopen
                    if (this.content[i].type == 0 && this.content[i].col3 == Constants.TYPE_REJECTED) {
                        var obj = this.content[i];
                        var params = {
                            //									originator: obj.ownerItem, //new owner
                            owner: obj.col2.itemId, //old owner
                            status: obj.resultType,
                            artifactItemTypeName: this._itemType,
                            artifactPackageUri: Constants.PACKAGE_URI,
                            artifactItemId: this._itemId
//                            projectAreaName: this.projectAreaName
                        }
                        updateArray.push(params);
                    }
                }
                
            }
            
            if (permissonUtil.checkOperation(this.role, Constants.ROLE_REVIEWER)) {
                if (this.content && this.content.length > 0) {
                    for (var i = 0; i < this.content.length; i++) {
                        if (permissonUtil.checkOperation(this.content[i].role, Constants.ROLE_REVIEWER)) {
                            var obj = this.content[i];
                            if (obj.resultType == Constants.TYPE_REJECTED && obj.col4 == "") {
                            }
                            else {
								//the service changes the tags and sends to us, need to restore them before sending it back
								var comment = this.restoreTags(obj.col4);
                                var params = {
                                    comment: comment,
                                    owner: obj.col2.itemId,
                                    status: obj.resultType,
                                    artifactItemTypeName: this._itemType,
                                    artifactPackageUri: Constants.PACKAGE_URI,
                                    artifactItemId: this._itemId
//                                    projectAreaName: this.projectAreaName
                                }
                                updateArray.push(params);
                            }
                        }
                    }
                }
            }
            if (deleteArray && deleteArray.length > 0) 
                param.remove = deleteArray;
            if (addArray && addArray.length > 0) 
                param.add = addArray;
            if (updateArray && updateArray.length > 0) 
                param.update = updateArray;
            return param;
        },
        
        validate: function(){
            for (var i = 0; i < this.content.length; i++) {
                var obj = this.content[i];
                if (obj.resultType == Constants.TYPE_REJECTED && obj.col4 == "") {
					return {
						msg: Constants.APPROVAL_REJECT_REASON_DUPLICATED_WARNING_APPROVAL_TABLE,
						value: false
					};
                }
            }
            return this._validateUsers();
        },
        
        //the owner of approver/reviewer can't be duplicated
        _validateUsers: function(){
            if (this.content && this.content.length > 0) {
                for (var i = 0; i < this.content.length; i++) {
                    var owner1 = this.content[i].ownerItem;
                    for (var j = i + 1; j < this.content.length; j++) {
                        var owner2 = this.content[j].ownerItem;
                        if (owner1 == owner2) {
							return {
								msg: Constants.APPROVAL_ADDING_DUPLICATED_WARNING_APPROVAL_TABLE,
								value: false
							};
                        }
                    }
                }
            }
            return {value: true};
        },
        
        _hasAddSaveButton: function(actions){
            if (actions && actions.length > 0) {
                for (var i = 0; i < actions.length; i++) {
                    if (actions[i].label == "Save") 
                        return true;
                }
            }
            return false;
        },
        
        _error: function(errorObj){
            alert(errorObj.message);
        },
		
		 getSafeText: function(rawText, editorPart){
            rawText = rawText.replace(/<synthetic>/g, "");
            rawText = rawText.replace(/<\/synthetic>/g, "");
            rawText = rawText.replace(/>/g, "&gt;");
            rawText = rawText.replace(/</g, "&lt;");
            rawText = rawText.replace(/(\n|\&#xA;)/g, "<br/>");
            rawText = rawText.replace(/  /g, "&nbsp;&nbsp;");
            rawText = rawText.replace(/(\t|\&#09);/g, "&nbsp;&nbsp;&nbsp;&nbsp;");
            rawText = rawText.replace(/\&lt;WBR\/\&gt;/g, "<WBR/>");
            rawText = rawText.replace(/\&lt;wbr\/\&gt;/g, "<wbr/>");
			rawText = rawText.replace(/\&amp;nbsp;/g, "&nbsp;");
            rawText = rawText.replace(/\&amp;lt;B\&amp;gt;/g, "<B>");
            rawText = rawText.replace(/\&amp;lt;b\&amp;gt;/g, "<b>");
            rawText = rawText.replace(/\&amp;lt;\/B\&amp;gt;/g, "</B>");
            rawText = rawText.replace(/\&amp;lt;\/b\&amp;gt;/g, "</b>");
            rawText = rawText.replace(/\&amp;lt;I\&amp;gt;/g, "<I>");
            rawText = rawText.replace(/\&amp;lt;i\&amp;gt;/g, "<i>");
            rawText = rawText.replace(/\&amp;lt;\/I\&amp;gt;/g, "</I>");
            rawText = rawText.replace(/\&amp;lt;\/i\&amp;gt;/g, "</i>");
            rawText = rawText.replace(/\&lt;B\&gt;/g, "<B>");
            rawText = rawText.replace(/\&lt;I\&gt;/g, "<I>");
            rawText = rawText.replace(/\&lt;b\&gt;/g, "<B>");
            rawText = rawText.replace(/\&lt;i\&gt;/g, "<I>");
            rawText = rawText.replace(/\&lt;\/B\&gt;/g, "</B>");
            rawText = rawText.replace(/\&lt;\/I\&gt;/g, "</I>");
            rawText = rawText.replace(/\&lt;\/b\&gt;/g, "</B>");
            rawText = rawText.replace(/\&lt;\/i\&gt;/g, "</I>");
            rawText = rawText.replace(/\&lt;BR\/\&gt;/gi, "<BR/>");
			rawText = rawText.replace(/\&lt;BR \/\&gt;/gi,"<BR/>");
            return rawText;
        },
		getClippedComment:function(value){
			//line breaks cause problems with clipping
			var str = value;
			var index = str.indexOf("<BR",30);
			var index2 = str.indexOf("<br",30);
			if(index != -1){
				str = str.substr(0,index);
				str = str+"...";
			}else if(index2 != -1){
				str = str.substr(0,index2);
				str = str+"...";
			}
			return str;
		},
		restoreTags: function(value){
            var rawText = value;
            rawText = rawText.replace(/\&gt;/gi, ">");
            rawText = rawText.replace(/\&lt;/gi, "<");
			rawText = rawText.replace(/\&amp;/gi, "&");
            rawText = rawText.replace(/\&tilde;/gi, "~");
            rawText = rawText.replace(/\&quot;/gi, "\"");
            rawText = rawText.replace(/\&circ;/gi, "^");
            return rawText;
        }
    });
    
})();
