/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink");
dojo.provide("com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.rqm.appscan.web.client.internal.InfoClient");
dojo.require("com.ibm.rqm.appscan.web.client.internal.Constants");
dojo.require("com.ibm.rqm.appscan.web.ui.internal.view.common.ImageCache");

(function(){
   
    var InfoClient				= com.ibm.rqm.appscan.web.client.internal.InfoClient;
	var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var ImageCache				= com.ibm.rqm.appscan.web.ui.internal.view.common.ImageCache;
	var ASEBaseUrl; 			// Cache base URL outside of ASELink
	var ASEBaseUrlInit 			= false; // Check for cache
	var Constants      			= com.ibm.rqm.appscan.web.client.internal.Constants;
   
    /**
     *  Links to ASE
     */
    dojo.declare("com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.appscan.web", "ui/internal/view/templates/common/ASELink.html"),
        
        constructor: function(){
        },
        
        postCreate: function(){
        
       		if (!ASEBaseUrlInit){
       			ASEBaseUrlInit = true; // Flag that the base url is initialized
	            var handler = new ServiceResponseHandler(this, "_initBaseUrl", "_error");
				InfoClient.getBaseUrl(handler);
			}
			
        	this._link.href = "javascript:void(0);";
            this._link.windowTitle ="ASE";   
        },
        
        _eval: function(json) {
			return eval( "(" + json + ")" );
		},
	
        _initBaseUrl: function(result){
        	ASEBaseUrl = this._eval(result).baseUrl;
        	console.debug("ASE Base URL: " + ASEBaseUrl);
        },
        
		initialize: function(args){         
			this._link.innerHTML = args.text;
			this._link.windowTitle = args.title;
		    this._link.url = "/" + args.path + "&RQM=1";

			this._extlinkImg.src = ImageCache.EXTERNALLINK;

			dojo.connect(this._link, "onclick", this, this.navigate);   
        },
        
        navigate: function(){
			var aseWindow = null;
			
			try {
				aseWindow = window.open(ASEBaseUrl + this._link.url);
			}
			catch(e) {
				aseWindow = null;
			}
			
			if (aseWindow) {
				aseWindow.focus();
			}
			else {
				this._showPopupBlockerDialog();
			}
			
			return aseWindow;
        },
		
		getLink: function() {
			return this._link;
		},
        
		_showPopupBlockerDialog: function() {
			var props = {
				title: Constants.getMessage("popup_blocker_title"),
	          	style: "position: absolute; top: 20%; left: 40%; width: 450px; height: 125px;"
	       	};
					
			var dialogContent = document.createElement("div");
			dialogContent.innerHTML = Constants.getMessage("popup_blocker");	

	        this.dialog = new dijit.Dialog(props, dialogContent);
			this.dialog.show();
		},
	
        _error: function(e) {
        	console.error("An error occurred: [" + e.message + "] @ ASELink#_error");
    	}
    });
})();

// Initialize static members
new com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink();
