/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.common.AboutDialog");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.AboutDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");


(function(){
	
	var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
	var Constants				= com.ibm.rqm.planning.web.client.internal.Constants;

    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.AboutDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/About.html"),

    	//STYLE: "position: absolute; top: 30%; left: 30%; width: 30%; height:40%",
		width: "600px",
    	title: Constants.getMessage("labelAboutDialogTitle"),
		labelVersionInformation: Constants.getMessage("labelVersionInformation"),
		labelCommonComponentsVersion: Constants.getMessage("labelCommonComponentsVersion"),
		labelRTLMVersion: Constants.getMessage("labelRTLMVersion"),
		labelQMExternalVersion: Constants.getMessage("labelQMExternalVersion"),
		labelQMInternalVersion: Constants.getMessage("labelQMInternalVersion"),
		SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IServerInfoRestService",
		
		_invokeService: function(responseHandler, method, appArgs) {
			var actualArgs= {};
			if (appArgs) {
				var jsonArgs= dojo.toJson(appArgs);						
			}
			if(appArgs.paramId)
				actualArgs.paramId = appArgs.paramId; 
		
			var serviceRequest= new ServiceRequest(this.SERVICE_URI, method, actualArgs);
			TeamServerClient.invokeService(serviceRequest, responseHandler);
		},
		
		_getVersions: function(serviceResponseHandler) {
			this._invokeService(serviceResponseHandler, "getVersions", { });
		},
		
		_getRQMVersion: function(serviceResponseHandler) {
			this._invokeService(serviceResponseHandler, "getRQMVersions", { });
		},
		
		_getAllBundleVersions: function(serviceResponseHandler) {
			this._invokeService(serviceResponseHandler, "getAllBundleVersions", { });
		},
            
        constructor: function(args){
            this.onOkCallback = null
        },
		
		postCreate: function() {          
		    var dialogArgs = {
				primaryTitle: this.title,
		        isClosable: true,
		        showActions: false
		    };                
		    this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
		    this._dialog.setWidth(this.width);
		    this._dialog.contentContainer.appendChild(this.domNode);
			this._dialog.open();			
			
			//var responseHandler = new ServiceResponseHandler(this, "_setVersion", "_error");			
			//this._getVersions(responseHandler);
			var responseHandler = new ServiceResponseHandler(this, "_setRQMVersion", "_error");			
			this._getRQMVersion(responseHandler);		
		},
		
		_setVersion: function(versions){
		   this._installVersion1.appendChild(this._createVersion(versions[0]));
		   this._installVersion2.appendChild(this._createVersion(versions[1]));
		   this._installVersion3.appendChild(this._createVersion(versions[2]));
        },
		
		_setRQMVersion: function(versions){
		   this._externalVersion.appendChild(this._createVersion(versions[0]));
		   this._internalVersion.appendChild(this._createVersion(versions[1]));
        },
		
		_createVersion: function(version){
           var aVersion = document.createElement("a");
		   var version = document.createTextNode(version);
		   aVersion.appendChild(version);
		   return aVersion;
        },
		
		_error: function(e){
            console.error(this.declaredClass + ": error: " + (e ? e.message : ""));          
        }
	
    });
      
})();
