/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");

dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ProjectsActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.AdministrationActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.RequirementsActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.LabActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ReportsActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.TeamActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

var InitializationData	   = com.ibm.team.repository.web.client.init.InitializationData;
var Constants              = com.ibm.rqm.planning.web.client.internal.Constants;

function userIsAdmin()
{
	var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer");
	if (permissionInitializer != null && permissionInitializer.canGrantPermission)
	{
		return true;
	}
	else
	{
		return false;
	}
}

(function() 
{
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar",
		[dijit._Widget, dijit._Templated],
		{
			templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/ActionBar.html"),		
	
            // If asMenuBar is true the action bar will be horizontal in the global
            // task bar area as a menu bar.  Otherwise it will be vertical at the
            // left of the screen.
            //
            asMenuBar: false,
            
            tabIndex: 1,
            
			constructor: function()
			{
                // keep track of all entries to support select with arrow keys traversal
                this.actionEntryCount = 0;
                this.allEntries = [];
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(contentArea, popupMenuArea, actionDispatcherName, asMenu)
			{
				this._contentArea = contentArea;
				this._popupMenuArea = popupMenuArea;
                this.actionDispatcherName = actionDispatcherName;
                
                this.asMenuBar = asMenu;
                if (this.asMenuBar) {
                    this._menuBar = new dijit.Toolbar({tabIndex:this.tabIndex});
                    this._menuBar.domNode.className = "com-ibm-rqm-planning-web-menu-bar";
                }

                this._isMenuShowing = false;
                this._initialize();
			},
            
            getMenuBar: function() {
                return this._menuBar;
            },
            
			_initialize: function()
			{
				var args =
				{
					imageName: "",
					imageText: "",
					contentArea: this._contentArea,
					popupMenuArea: this._popupMenuArea,
                    actionDispatcherName: this.actionDispatcherName,
                    asMenuBarEntry: this.asMenuBar,
                    parent: this
				};

//				args.imageName = "projects";
//				args.imageText = Constants.getMessage("labelProjects");
//				this._projects = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ProjectsActionBarEntry();
//				this._projects.initialize(args);
//				this.appendActionEntry(this._projects);
				
				args.imageName = "requirements";
				args.imageText = Constants.getMessage("labelRequirements");
				this._requirements = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.RequirementsActionBarEntry();
				this._requirements.initialize(args);
				this.appendActionEntry(this._requirements);

				args.imageName = "planning";
				args.imageText = Constants.getMessage("labelPlanning");
				this._planning = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.PlanningActionBarEntry();
				this._planning.initialize(args);
				this.appendActionEntry(this._planning);

				args.imageName = "construction";
				args.imageText = Constants.getMessage("labelConstruction");
				this._construction = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry();
				this._construction.initialize(args);
				this.appendActionEntry(this._construction);

				args.imageName = "labmanage";
				args.imageText = Constants.getMessage("labelLabManagement");
				this._lab = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.LabActionBarEntry();
				this._lab.initialize(args);
				this.appendActionEntry(this._lab);

				args.imageName = "execution";
				args.imageText = Constants.getMessage("labelExecution");
				this._execution = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ExecutionActionBarEntry();
				this._execution.initialize(args);
				this.appendActionEntry(this._execution);

				args.imageName = "report";
				args.imageText = Constants.getMessage("labelReports");
				this._reports = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ReportsActionBarEntry();
				this._reports.initialize(args);
				this.appendActionEntry(this._reports);

				args.imageName = "defect";
				args.imageText = Constants.getMessage("labelDefects");
				this._defects = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry();
				this._defects.initialize(args);
				this.appendActionEntry(this._defects);

//				args.imageName = "team";
//				args.imageText = Constants.getMessage("labelTeams");
//				this._teams = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.TeamActionBarEntry();
//				this._teams.initialize(args);
//				this.appendActionEntry(this._teams);
				
//				if (userIsAdmin())
//				{
					args.imageName = "admin";
					args.imageText = Constants.getMessage("labelAdministration");
					this._administration = new com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.AdministrationActionBarEntry();
					this._administration.initialize(args);
// admin menu is moved to the global task bar but we still need to initialize the action entries
//					this._administration.domNode.setAttribute("tabindex","0");
//					this.appendActionEntry(this._administration);
//				}
			},
            
            appendActionEntry: function(entryWidget)
            {
                if (this.asMenuBar) {
                    this._menuBar.addChild(entryWidget.topDomElement);
                } else {
                    // Set tab index to 1 (default) for the action entry as first element to tab into.
                    // Elements with the same index will have order based on the order of their creation.
                    entryWidget.domNode.tabIndex = this.tabIndex;
                    // add entry to vertical action bar
                    this._actionBar.appendChild(entryWidget.topDomElement);
                    // keep track of the entries for keyboard traversal
                    this.allEntries.push(entryWidget);
                    entryWidget.entryIndex = this.actionEntryCount++;
                }
            },
            
            setCurrentActionEntry: function(currentWidget) {
                this.currentActionEntry = currentWidget;
            },
            
            clearCurrentActionEntry: function() {
                this.currentActionEntry = null;
            },
            
            resetCurrentActionEntry: function(requestWidget) {
                if (this.currentActionEntry && (this.currentActionEntry != requestWidget)) {
                    this.currentActionEntry._setHoverImage(false);
                    this.currentActionEntry = null;
                } else console.debug("SKIPPING");
            },
                
            selectPrevActionEntry: function(currentWidget) {
                // check previous entry index
                var prevIndex = currentWidget.entryIndex - 1;
                if (prevIndex < 0) {
                    // loop around to the last index
                    prevIndex = this.actionEntryCount - 1;
                }
                this.allEntries[prevIndex].topDomElement.focus();
            },

            selectNextActionEntry: function(currentWidget) {
                // check next entry index
                var nextIndex = currentWidget.entryIndex + 1;
                if (nextIndex >= this.actionEntryCount) {
                    // loop around to the first index
                    nextIndex = 0;
                }
                this.allEntries[nextIndex].topDomElement.focus();
            }
		}
	);
}
)();
