/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.view.common.Banner");

dojo.require("dijit.TitlePane");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");

(function(){
dojo.declare("com.ibm.asq.common.web.ui.internal.view.common.Banner",
[dijit._Widget, dijit._Templated],
{
    templateString: '<div id="${id}" dojoAttachPoint="domNode" class="com-ibm-asq-common-web-ui-banner-area">' +
                    '  <div class="header" dojoAttachPoint="focusNode" class="header">' +
                    '    <div class="header-left">' +
                    '      <div class="header-right">' +
                    '        <div class="header-mid">' +
                    '          <div class="title-container">' +
                    '            <span dojoAttachPoint="titleNode" class="title"></span>' +
                    '          </div>' +
                    '        </div>' +
                    '      </div>' +
                    '    </div>' +
                    '  </div>' +
                    '  <div class="banner-content-outer-container" dojoAttachPoint="hideNode">' +
                    '    <div class="banner-content-inner-container" dojoAttachPoint="wipeNode">' +
                    '      <div class="banner-content-area" dojoAttachPoint="containerNode,contentNode" waiRole="region" tabindex="-1"></div>' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',

    open: true,
    collapsedTitle: "",  // title to show when collapsed
    
    postCreate: function() {
        com.ibm.asq.common.web.ui.internal.view.common.Banner.superclass.postCreate.apply(this, arguments);

        this._updateCaret();
    },
    
    setTitle: function(title) {
        this.title = title;
        this._updateTitle();
    },
        
    _updateCaret: function() {
//        if (this.open) {
//            this.arrowLabelNode.innerHTML = MessageUtil.getMessage(MessageBundle.COMMON, "actionLabel_Less");
//            dojo.addClass(this.arrowNode, "arrow-icon-up");
//            dojo.removeClass(this.arrowNode, "arrow-icon-down");
//        } else {
//            this.arrowLabelNode.innerHTML = MessageUtil.getMessage(MessageBundle.COMMON, "actionLabel_More");
//            dojo.addClass(this.arrowNode, "arrow-icon-down");
//            dojo.removeClass(this.arrowNode, "arrow-icon-up");
//        }
        this._updateTitle();
    },
	
   _updateTitle: function() {
           if (this.title != "") {
                this.titleNode.innerHTML = "<strong>" + this.title + "</strong>";
    		}    
	}
});    
})();
