/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.common.progressbar.ProgressBar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.common.progressbar.ProgressBar",
			 [dijit._Widget, dijit._Templated], 
{
		
	templateString: "<div>"+
						"<div style=\"float:right;\" dojoAttachPoint=\"_percent\"></div>"+
						"<div class=\"com-ibm-rqm-execution-view-common-progressbar-progressbar\" dojoAttachPoint=\"_container\">"+
							"<div class=\"container\" dojoAttachPoint=\"_bar\">"+
								"<div class=\"container barPart completed\"><div class=\"barPartTile\"></div></div>"+
								"<div class=\"container barPart open\"><div class=\"barPartTile\"></div></div>"+
							"</div>"+
						"</div>"+
					"</div>",
	
	postCreate: function()
	{
		if(!this.width)
			this.width = "100%";
		if(!this.height)
			this.height = "1em";
		dojo.style(this._container, "width", this.width);
		dojo.style(this._container, "height", this.height);
		dojo.style(this._container, "float", "right")
		this.update(0);
	},
	
	update: function(completed)
	{
		completed = Math.round(completed)
		var incomplete = 100 - completed;
		
		this._applyStyle(".container .completed", "width", completed);
		this._applyStyle(".container .open", "width", Math.abs(incomplete));
		
		var displayValue= "";
		if(completed < 10)
			displayValue = "&nbsp;&nbsp;"+completed;
		else if(completed == 100)
			displayValue = completed;
		else
			displayValue = "&nbsp;"+completed;
		
		this._percent.innerHTML = displayValue + "%";
	},
	
	_applyStyle: function(query, style, value) {
		dojo.query(query, this._container).style(style, Math.round(value) + "%");
	}
	
});
	
