/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
//xojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
//xojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dojo.dnd.Source");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {

var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
//var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ImageCache				 		= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var CSHelp							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare("KeywordLibraryView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content)
    {
        return 3;
    },
    
    getColumnHeading: function(content, index)
    {
        var headings = [
//			Constants.getMessage("labelInconclusive"),
//			Constants.getMessage("labelBlocked"),
//			Constants.getMessage("labelExeResult")
			"",
			Constants.getMessage("labelKeywords"),
			Constants.getMessage("labelType")
        ];
        return headings[index];
    },

    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;//(atColumnIndex == 2);     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return (atColumnIndex == 2);   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 10;
            case 1: 
                return 60;
            case 2: 
                return 30;
        }
        return 0;
    },
    
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_execution_result_" + rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;				 
        }
        return type;
    },

    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.elements[0].value;
                break;
            case 1: 
                val = rowData.elements[1].value;
                break;
            case 2: 
                val = rowData.elements[2].value;
                break;
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if (atColumnIndex == 0) {
           val = {};
           val.image = ImageCache.TEST_SCRIPT;
 		   val.href = rowData.link;
        }		  		  		  
        return val;
    }    
});
dojo.declare("KeywordLibraryView.TableRowRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer,
{
	editor:null,
	constructor :function(params)
	{
		this.editor = params.editor;
	},
	renderRow: function(viewer, rowObject, trNode)
    {
		if(!dojo.hasClass(trNode.parentNode,"dojoDndSource"))
		{
			if(this.dndSource)
				this.dndSource.destroy();
			this.dndSource= new dojo.dnd.Source(trNode.parentNode,
				{
					accept:[],
					copyOnly:true,
					singular:true,
					creator:this._dndCreator
				});
		}
			
        var img = document.createElement('img');
        img.src = ImageCache.TEST_SCRIPT;
		img.alt = "Title";
        var td = document.createElement("td");
		td.appendChild(img);
        trNode.appendChild(td);
        for (var j =1; j<rowObject.elements.length-1; j++)
        {
            var element = rowObject.elements[j];
			var td = document.createElement("td");
            td.appendChild(document.createTextNode(element.value));
            trNode.appendChild(td);
        }
        var editorId = rowObject.elements[rowObject.elements.length-1];
        trNode["editorId"] = editorId;
		trNode.id = "_tr"+editorId+rowObject.elements[0].value; //0 contains the ID
		this._attachContextMenu(trNode,rowObject.scriptObj);
		
		this.dndSource.setItem(trNode.id, {data: rowObject, type: [editorId]});
		dojo.addClass(trNode, "dojoDndItem");
    },
	
	clearRowStates: function()
    {
		if(this.dndSource)
        	this.dndSource.clearItems();
    },

    _dndCreator:function(row,hint)
	{
        if(hint == "avatar")
        {
        	var tr = document.createElement("tr");
            var td = document.createElement("td");
            td.appendChild(document.createTextNode(row.elements[1].value));
            tr.appendChild(td);
            var editorId = row.elements[row.elements.length-1];
            return {node: tr, data: row, type: [editorId]};
		}			
	},
	_attachContextMenu: function(node,scriptObj)
		{
	
			var callback = this;
			if(node)
			{
				var pMenu = new dijit.Menu({targetNodeIds:[node]});
	            pMenu.addChild(new dijit.MenuItem({
					label:Constants.getMessage("labelInsertBefore"),
					scriptObj: scriptObj, 
					callback: callback, 
					onClick:this._insertKeyword}));
	            pMenu.addChild(new dijit.MenuItem({
					label:Constants.getMessage("labelReplaceStatement"),
					scriptObj: scriptObj, 
					callback: callback, 
					onClick:this._replaceCurrentWithKeyword}));
	            pMenu.startup();	
			}
	
	
		},
	
		_replaceCurrentWithKeyword: function()
		{
			var editor = this.callback.editor;
			if(editor)
			{	if(editor.lastClickedRow != "none" && editor.lastClickedRow != "")
				{
					var row = dojo.byId(editor.lastClickedRow);
					editor._addKeyword(row, this.scriptObj,true);
				}
				else
					alert(Constants.getMessage("msgNoStepToReplace"));
			}		
		},
		_insertKeyword: function()
		{
			var editor = this.callback.editor;
			if(editor)
			{
				if(editor.lastClickedRow != "none" && editor.lastClickedRow != "")
				{
					var row = dojo.byId(editor.lastClickedRow);
					editor._addKeyword(row, this.scriptObj,false);
				}
				else
					alert(Constants.getMessage("msgNoStep"));
			}
		}		
});		
dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/KeywordLibraryView.html"),
		
		labelKeywordView: Constants.getMessage("labelKeywordView"),
		editor:null,
		constructor: function() {
		},
		
		postCreate: function() {
			this.rows = [];
			var responseHandler = new ServiceResponseHandler(this, "_fillScripts", "_error");
			try{
				com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {});
			}catch(e){
				console.debug("getKeywords failed in KeywordLibraryView");
			}
			//cshelp
			if (this._cshelp) {
		        var cshelp = new CSHelp({
		        	contextID: "rqm_keyword_view.html"
		        });
				cshelp.setButtonLabel(Constants.getMessage("labelKeywordLibCSHelp"));
		        this._cshelp.appendChild(cshelp.domNode);
			}
		},	

		_fillScripts: function(keywords)
		{
			if(keywords)
			{	
				for(var i=0;i<keywords.length ; i++)
				{
					if(keywords[i].archived)
						continue;
					var type = keywords[i].defaultScript ? Constants.getExtensionDisplayMessage(keywords[i].defaultScript.scriptType.name):"";
					var scriptId = keywords[i].defaultScript ? keywords[i].defaultScript.id:keywords[i].manualScript.id;
					var scriptObj = keywords[i].defaultScript? keywords[i].defaultScript: keywords[i].manualScript;
					this.rows.push({
						elements: [ { value: keywords[i].id},
									{ value: keywords[i].name},
									{value: type},
									this.editor.id],
						scriptObj: keywords[i]				
					});
				}
			}	
			this._displayTable();
		},
		
		
		_displayTable: function()
		{
			var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
	        this._tableViewerNode.appendChild(tableViewer.domNode);			          
	     	var keywordRowRenderer = new KeywordLibraryView.TableRowRenderer({editor:this.editor});
			tableViewer.setCustomRowRenderer(keywordRowRenderer);
	        tableViewer.setContentPageSize(10);
	        tableViewer.setContent(this.rows);
	        tableViewer.setContentProvider(new KeywordLibraryView.TableProvider());
			tableViewer.show();
			this.tableViewer = tableViewer;
			//need to do this tweaking to keep the keyword library view from not getting too wide
			var pageSelectParent = tableViewer.PageSelectControlNode.parentNode;
			if(pageSelectParent)
				pageSelectParent.parentNode.removeChild(pageSelectParent);
			var actionsAreaParent = tableViewer.actionsAreaNode.parentNode;
			if(actionsAreaParent)
				actionsAreaParent.parentNode.removeChild(actionsAreaParent);
			var pageControlParent = tableViewer.PageControlNode.parentNode;
			if(pageControlParent)
				pageControlParent.removeAttribute('nowrap');
		},
		
		_error: function(errorObj) {
			alert("Error: (message: '" + errorObj.message + "') in KeywordLibrary#_error");
			
		}
	}
);

})();
