/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.NewSectionDialog");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.NewSectionDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;

    /**
     *
     */
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.NewSectionDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/NewSectionDialog.html"),
        
		labelSectionName: Constants.getMessage("labelSectionName"),
		labelDescription: Constants.getMessage("labeldescription"),
		labelApplyToTemplate: Constants.getMessage("labelApplyToTemplate"),
		labelOk: Constants.getMessage("labelOk"),
        labelCancel: Constants.getMessage("labelCancel"),
                
        constructor: function(args){},
        
        postCreate: function(){
			if (!dojo.isFunction(this.onOk)) {
				throw new Error("Parameter 'onOk' is REQUIRED and must be a Function.");
			}
			
			this._applyTemplateCheckbox.style.display = "none";
			this._applyTemplateLabel.style.display = "none";
			this._messages.style.display = "none";
			
            var dialogArgs = {
				primaryTitle: Constants.getMessage("labelNewSection"),
                okCallback: dojo.hitch(this, "_onOk"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				_truncate: function() {}  //disable the Dialog's '_truncate'
            };      
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._dialog.setWidth("500px");
			var cshelp = new CSHelp({contextID: "rqm_new_custom.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelNewSectionCSHelp"));
			this._dialog.setSecondaryTitleNode(cshelp.domNode);
			this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = false;
            this._dialog.open();		
			
			setTimeout(dojo.hitch(this, function() {this._name.focus()}), 250);		
        },
        
        _onCancel: function() {
			if (this._dialog) {
				//this.floatingPane.close();  //removed --> SelectionDialog closes itself on cancel
				//dojox.data.dom.removeChildren(this.floatingPane.containerNode);
				this._dialog = null;
			}			
        },
        
        _onOk: function() {
			this._messages.style.display = "none";
            if (this._name.value == null || dojo.trim(this._name.value).length == 0) {
                this._messages.style.display = "inline";
				this._messages.appendChild(document.createTextNode(Constants.getMessage("labelSectionNameRequired")));
				return false;
				
            } else {
				// generate a new section id
                var id = "dynamicSection_" + new Date().getTime();
	            if (dojo.isFunction(this.onOk)) {
	                this.onOk(id, this._name.value, this._description.value);
	            }		
            }
        },
        
        _onKeyup: function(e){
            if (e.keyCode == dojo.keys.ENTER) {
                if (this._dialog) {
					this._dialog.getOkButton().onclick();
				}
            }
        }
        
    });
})();
