/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container

var COMMENT_VIEW			="commentView"
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/properties/CommentView.html"),
		
		labelWriteComments: Constants.getMessage("labelWriteComments"),
		constructor: function(){
		},
		postCreate: function(){
			this._initializeView();
		},
		setComment: function(comment){
			this._textArea.value = comment;
			this.commentData = comment;
		},
		setFocus:function(){
			this._textArea.focus();
		},
		setData: function(elements){
			if(elements.length ==0){
				this.setComment("");
			}
			for(var i=0;i<elements.length;i++){
				var name = elements[i].propertyName;
				var value = elements[i].propertyValue;
				if(name == "comment")
					this.setComment(value);
			}
		},
		getData: function(){
			var returnData = new Array();
			returnData.push(COMMENT_VIEW);
			returnData.push("comment");
			var value =this.commentData;
			if(value.length>250){
				value = value.substr(0,249);
			}
			returnData.push(value);			
			return returnData;
		},
		_initializeView: function(){
			this.setComment("");
			dojo.connect(this._textArea, "onkeypress", this, this._validate);
		},
		_validate:function(e){
			if(e && (e.keyChar || e.keyCode)){
				setTimeout(dojo.hitch(this, this._validate), 1);
			}else{
				this.commentData = this._textArea.value;
				if(this._textArea.value.length>250){
					this._msgArea.innerHTML ="<b>"+Constants.getMessage("labelError")+": "+Constants.getMessage("labelTextTooLong")+"<b>";
					dojo.removeClass(this._msgArea,"hidden");
					this.msgAreaShowing = true;
				}else if(this.msgAreaShowing == true){
					this._msgArea.innerHTML = "";
					dojo.addClass(this._msgArea,"hidden");
					this.msgAreaShowing = false;					
				}
			}
		},
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from CommentView#_error");
		}
}
);

})();	
