/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties.MainView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.MainView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var MAIN_VIEW				= "mainView";
var EXECUTION_STEP			= Constants.getMessage("labelExecutionStep");
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.MainView",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/properties/MainView.html"),

		labelType: Constants.getMessage("labelType"),
		labelDescription: Constants.getMessage("labelDescription"),
		constructor: function()
		{
			
		},
		
		postCreate: function()
		{
//			this.id = "com.ibm.rqm.planning.web.ui.internal.view.construction.properties.MainView";
//			this.setType("Type Information");
//			this.setDescription("Statement Description");
		},
		
		setType: function(type)
		{
			this._type.innerHTML = type;
		},
		
		setDescription: function(desc)
		{
			this._description.value = desc;
		},
		
		getType: function()
		{
			return this._type.innerHTML;
		},
		
		getDescription: function()
		{
			return this._description.value
		},
		
		setData: function(elements)
		{
			if(elements.length ==0)
			{
				this.setType(EXECUTION_STEP);//Initial value set to Execution Step
				this.setDescription("");	
			}
			for(var i=0;i<elements.length;i++)
			{
				var name = elements[i].propertyName;
				var value = elements[i].propertyValue;
				if(name == "type")
					this.setType(value)
				if(name == "description")
					this.setDescription(value);	
			}
		},
		
		getData: function()		
		{
			var returnData = new Array();
			
			returnData.push(MAIN_VIEW);
			returnData.push("type");
			returnData.push(this._type.innerHTML);
			
			returnData.push(MAIN_VIEW);
			returnData.push("description");
			returnData.push(this._description.value);
/*		
			var arg = {
					propertyType: "mainView",
					propertyName: "type",
					propertyValue: this._type.innerHTML
				}
			returnData.push(arg)
			
			var arg = {
					propertyType: "mainView",
					propertyName: "description",
					propertyValue: this._description.innerHTML
				}
			returnData.push(arg)
*/				
			return returnData;
		},
				
		_error: function()
		{
			alert("Error: (message: '" + errorObj.message + "') from MainView#_error");
		}

}
);

})();	
