/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dijit.ProgressBar");
dojo.require("dojo.parser");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.progressbar.ProgressBar");

(function() {
var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants                      	= com.ibm.rqm.planning.web.client.internal.Constants;
var ProgressBar						= com.ibm.rqm.execution.web.ui.internal.view.common.progressbar.ProgressBar
var ConfigurationUriUtil 			= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer", [dijit._Widget, dijit._Templated],
{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/EnvironmentContainer.html"),
		
		postCreate: function(){		
			this._createHeader();
		},
		
		_createHeader: function(){
			if(this.showProgressBar){
				this.progressBar = new ProgressBar({width: "25%"});
				this._progressBarContainer.appendChild(this.progressBar.domNode)
			}	
				
			dojox.data.dom.removeChildren(this._envTableBody);
	         if (this.title != null) {
	            var headerRow = this._envTableBody.insertRow(this._envTableBody.rows.length);
					var headerCell = headerRow.insertCell(headerRow.cells.length);
				 	dojo.addClass(headerCell, "env-table-header");
					headerCell.colSpan = 2;
					headerCell.innerHTML = this.title;			 	
	         }
			if (this.ewi.configuration) {
			 	var responseHandler = new ServiceResponseHandler(this, "_createCat", "_error");
			 	this.config = new com.ibm.rational.test.lm.web.client.internal.config();
			 	this.config.retrieveConfigurationWithDetails(responseHandler, this.ewi.configuration);
         } else {
				this.ewiConfig = new Array(3)
				for(var i=0;i<3;i++)
					this.ewiConfig[i] = Constants.getMessage("labelNotConfig");
				this._displayEnvValues();
			}
		},

		_createCat: function(config){
			this.config = config;
			var responseHandler = new ServiceResponseHandler(this, "_setEnvData", "_error");
			this.theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
			var cat = com.ibm.asq.common.web.client.internal.Catalog;
            if(!cat.theCatalog)
				this.theCatalog.initializeTemplates(responseHandler);
			else
				this._setEnvData();
		},
		
		_setEnvData: function(){
			var conf = this.theCatalog.createConfigurationFromJson(this.config.configuration);
			var envValue = new Array(3);
			var configRoot = conf.getRoot();
			var attributeIds = this.theCatalog.getDisplayTypes();
			var attributeVals = [];
			var attributeTypes = [];
			for(var i=0;i<attributeIds.length;i++){
           		var attribute = conf.getValue(attributeIds[i]);
				if(!attribute) {
				//	attributeVals.push("Not Configured");
					continue;
				}
				attributeTypes.push(attributeIds[i]);
				attributeVals.push(attribute)
			}
			
			this.ewiConfig = {envTypes: attributeTypes, envValue: attributeVals};
			this._displayEnvValues();
		},
		
		_displayEnvValues: function(){
			var envValue = this.ewiConfig;
			var elements = [];
			
			if(this.showEnvDetails){
				//Name
				var label = document.createElement('label');
				label.className = "config-name";
				label.innerHTML = this.config ? this.config.name : "";
				if(this.config && this.config.id){
					var anchorTag = document.createElement('a');
					anchorTag.href = ConfigurationUriUtil.getEditConfigurationURI(this.config.id);
					anchorTag.appendChild(label);
					this._environmentDetails.appendChild(anchorTag);
				}else{
					this._environmentDetails.appendChild(label);
				}
				this._environmentDetails.appendChild(document.createElement('br'));
				//Description
				var descLabel = document.createElement('div');
				descLabel.className = "";
				descLabel.innerHTML = this.config ? this.config.description : "";
				this._environmentDetails.appendChild(descLabel);
			}else
				dojox.data.dom.removeChildren(this._environmentDetails);
			
			if (this.tsName) {
				elements.push({name: Constants.getMessage("labelTestScriptName"), value: this.tsName});
			}
			
			for(var i=0;i<(this.ewiConfig.envTypes ? this.ewiConfig.envTypes.length: 0);i++){
				elements.push({name: this.ewiConfig.envTypes[i], value: this.ewiConfig.envValue[i]});
			}

	      for (var i = 0; i < elements.length; i++){
				//row for each environment entry
				var row = this._envTableBody.insertRow(this._envTableBody.rows.length);
				dojo.addClass(row, "env-table-row");
				//column for the name
				var nameCell = row.insertCell(row.cells.length);
				dojo.addClass(nameCell, "env-table-name-col");
				nameCell.innerHTML = elements[i].name;
				//column for the value
	        	var valueCell = row.insertCell(row.cells.length);
	            dojo.addClass(valueCell, "env-table-value-col");
	            valueCell.innerHTML = elements[i].value;				
			}
		},
		
		updateProgress: function(percent){
			if(this.showProgressBar)
				this.progressBar.update(percent);
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from EnvironmentContainer#_error");
		}
	}
);
}
)();
		
