/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
//console.debug("Loading: com.ibm.rqm.adapter.rft.web.ui.internal.view.execution.FunctionalExecutionLog");
dojo.provide("com.ibm.rqm.adapter.rft.web.ui.internal.view.execution.FunctionalExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Utlities
//dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
//Clients
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.adapter.rft.web.ui.internal.RftUiUtil");
(function() { // module container

var ImageCache				= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var DOWNLOAD_SERVICE_URI 		= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/"; //RQM Downaload Service
var TeamServerClient 			= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var RftUiUtil	= com.ibm.rqm.adapter.rft.web.ui.internal.RftUiUtil;

dojo.declare("com.ibm.rqm.adapter.rft.web.ui.internal.view.execution.FunctionalExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.rft.web", "ui/internal/view/templates/execution/FunctionalExecutionLog.html"),
		postCreate: function() {		
		},
		
		initialize: function()
		{
			if (this.result.properties)
			{
				for (var i = 0; i < this.result.properties.length; i++)
				{
					if(this.result.properties[i].propertyName == "message")
					{
						var label1 = document.createElement('label');
						label1.innerHTML = RftUiUtil.getMessage(this.result.properties[i].propertyValue);
						//label1.innerHTML = this.result.properties[i].propertyValue;
						this._detailsContainer.appendChild(label1);
					} else if (this.result.properties[i].propertyName == "message1")				
					{
						var label1 = document.createElement('label');
						if (i+1 < this.result.properties.length) 
						{
							label1.innerHTML = RftUiUtil.getMessage(this.result.properties[i].propertyValue, this.result.properties[i+1].propertyValue);
							i++;
						} else 
						{
							label1.innerHTML = this.result.properties[i].propertyValue;
						}
						this._detailsContainer.appendChild(label1);
					}
				}
			}
			console.debug(this);
			if (this.result.attachments)
			{
				
				//Write Functional Test details here
				//var label = document.createElement('label');
				//label.innerHTML = "Functional Execution Log: ";
				//this._detailsContainer.appendChild(label);
				//var attachID = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + this.result.attachments[0].itemId;			
				//this._detailsContainer.appendChild(this._getDownloadAnchor(this.result.attachments[0], "Rational Functional Tester Log"));
				if (this.result.attachments.length == 1)
				{			
					this._detailsContainer.appendChild(this._getDownloadAnchor(this.result.attachments[0], RftUiUtil.getMessage("rftlogmessage")));
				}else 			
				{
					this._detailsContainer.appendChild(this._getDownloadAnchor(this.result.attachments[0], RftUiUtil.getMessage("rftlogsimplemessage")));
					var test = document.createElement("p");
					this._detailsContainer.appendChild(test);
					this._detailsContainer.appendChild(this._getDownloadAnchor(this.result.attachments[1], RftUiUtil.getMessage("rftlogdetailedmessage")));
					var str =  document.createTextNode(" (" + RftUiUtil.getMessage("needsrft") + ")");
					this._detailsContainer.appendChild(str);
				}
			}
			
		},
		
		_getDownloadAnchor: function(attachment, text) {
		
			var saveAnchor= document.createElement("a");
			saveAnchor.className= "actionLink";
			saveAnchor.href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + attachment.itemId;			
			saveAnchor.appendChild(document.createTextNode(text));					
			return saveAnchor;
		}
	}
);

}
)();