/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Utlities
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("net.jazz.ajax.ui.internal.HoverPopup");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.defects.web.client.DefectsManager");

//Clients
dojo.require("dijit.layout.SplitContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dojo.parser");

(function() { // module container

var ImageCache				= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var TestScriptClient		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ReportsClient 			= com.ibm.team.reports.web.client.internal.ReportsClient;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var HoverPopup 				= net.jazz.ajax.ui.internal.HoverPopup;
var getCurrentProjectArea 	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants               = com.ibm.rqm.planning.web.client.internal.Constants;
var DatapoolClient          = com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient;
var CompareView				= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView;
var DefectView				= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;
var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;
var getDefectsManager				= com.ibm.rqm.defects.web.client.DefectsManager.getInstance;

var DOWNLOAD_SERVICE_URI 	= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var REPORT_REST_SERVICE_URI = "com.ibm.team.reports.common.internal.service.IReportRestService";
var COMMENT_VIEW_TYPE				= "commentView";
var DEFECT_VIEW_TYPE				= "defectView";
var RTC_DEFECT_VIEW_TYPE			= "rtcdefectView";
var ATTACHMENT_VIEW_TYPE			= "attachmentView";
var RESULT_ATTACTMENT_VIEW_TYPE		= "result AttachmentView";
var COMPARE_VIEW_TYPE				= "compareView";
var KEYWORD_STEP_COMPARE			= "keyword step";
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ManualExecutionLog.html"),
		
		labelType: Constants.getMessage("labelType"),
		labelResult: Constants.getMessage("labelResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		result: null,
		_verdict: null,
		_elementResults: [],
		_itemId: null,
		_scriptName: null,
		_scriptDesc: null,
		_testcase: null,
		_scriptOwner: null,
		_scriptId: null,
		_scriptElements: null,
		_startTime: null,
		_endTime: null,
		_logName: null,
		stepDescriptions: [],
		stepTypes: [],
		stepResults: [],
		stepAttachments: [],
		stepProperties: [],
		widgetsInTemplate: true,
		//for Datapool: 
		_cells: [],
		
		// populate the template with data, connect events, and show initial
		// sub-tab
		postCreate: function() {		
			//Will receive this.resultItemId, this.ewiId
			this.lastClickedRow = "none";
			this._stepsHaveVerdict = this.parentController.getStepsHaveVerdict();
			this.DEFECT_ICON = this.id+"_defectIcon"
			this.DEFECT_ID	= this.id+"_defect"
			this.ATTACH_ICON = this.id+"_attachIcon"
			this.ATTACH_ID = this.id+"_attach"
			this.COMMENT_ICON = this.id+"_commentIcon"
			this.COMMENT_ID = this.id+"_comment"
			this.COMPARE_ICON = this.id+"_compareIcon"
			this.COMPARE_ID = this.id+"_compare"
		},
		
		initialize: function(){
			this.setResult(this.result);
		},
		
		setResult: function(result){
			this.result = result;
			if(this.result.itemId != null){
				this._itemId = this.result.itemId;
			}	
			this._elementResults = null;
			this.stepDescriptions=[];
			this.stepTypes=[];
			this.stepResults=[];
			this.stepProperties=[];
			if(this.result.elementResults != null){
				this._elementResults = this.result.elementResults;
				for(var i=0;i<this._elementResults.length;i++)
					if(this._elementResults[i].result != null && this._elementResults[i].result.name != "undefined")
						this.stepResults[i] = this._elementResults[i].result; //.name;
			}
			
			// find the related datapool
			var self = this;
			var callbackObj = {
				success: function(results){
					self._datapool = results && results.length == 1 ? results[0] : null;
					self.fillDetails();
				},
				failure: function(e){
					console.error("Failed to find related Test Data");
				}
			}
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			DatapoolClient.getDatapoolDTOs(responseHandler, {
				linkedTestScriptUUID: this.result.script.itemId,
				linkedTestScriptStateUUID: this.result.script.stateId,
				isIterationRequired: true,
				isDataRequired: true
			});
							
			this._showReport();	 
		},
				
		fillDetails: function(){
			
			if(this.result.script && this.result.script.elements){
				for(var i = 0; i < this.result.script.elements.length; i++){
					if(this.result.script.elements[i].content != null)
						this.stepDescriptions[i] = this.result.script.elements[i].content;
	
					if(this.result.script.elements[i].elementType.name != null)
						this.stepTypes[i] = this.result.script.elements[i].elementType;
				}
			}
			if(this._elementResults){
				for(var i = 0; i < this._elementResults.length; i++){
					if(this._elementResults[i].properties != null){
						this.stepProperties[i] = new Array();
						for(var j=0;j<this._elementResults[i].properties.length;j++)
							this.stepProperties[i].push(this._elementResults[i].properties[j]);
					}else{
						this.stepProperties[i] = [];
					}
					this._appendEditableStepRow(null, i, this.result.script.elements[i%this.result.script.elements.length]);
				}
			}
		},
		
		getHelpContextID: function(){
      		return "rqm_manual_execution_results_overview.html";
   		},
		
		getAttributes: function(){
			return null;
		},
		
		_createPropertiesHtml: function(stepNum,properties){
			var attachCell = this._getEmptyCell();
			attachCell.id = this.ATTACH_ID+stepNum;
			attachCell.align = "right";  
			var defectCell = this._getEmptyCell();
			defectCell.id = this.DEFECT_ID+stepNum;
			defectCell.align = "right"; 
			var commentCell = this._getEmptyCell();
			commentCell.id = this.COMMENT_ID+stepNum;
			commentCell.align = "right"; 
			var compareCell = this._getEmptyCell();
			compareCell.id = this.COMPARE_ID+stepNum;
			compareCell.align = "right"; 
			
			var defectFound = false; var attachmentFound = false; var commentFound = false;
			var attachmentCount= 0;
			var defectCount = 0;
			var defectsHtml = document.createElement("span");
			var attachmentsHtml = document.createElement("span");
			var attachmentsHtmlTable = attachmentsHtml.appendChild(document.createElement("table"));
			var attachmentsHtmlContent = attachmentsHtmlTable.appendChild(document.createElement("tbody"));
			var commentsHtmlContent = document.createElement("span"); 
			if(properties){
				for(var i=0;i<properties.length;i++){
					switch(properties[i].propertyType){
						case DEFECT_VIEW_TYPE:
						case RTC_DEFECT_VIEW_TYPE:
							if(defectFound == false){
								var defectLabel = document.createElement("label");
								var defectImg = document.createElement("img");
								defectImg.alt= Constants.getMessage("labelDefects");
								defectImg.src = ImageCache.DEFECT;
								defectImg.className = "type-image";
								defectImg.id = this.DEFECT_ICON + stepNum;
								defectLabel.appendChild(defectImg);
								defectLabel.style.cursor = "pointer";
								defectCell.appendChild(defectLabel);
								defectLabel.onclick = dojo.hitch(this,this._showDefect,stepNum,properties[i].propertyType);
								defectFound = true;
							}							
							defectCount++;							
							break;
						
						case ATTACHMENT_VIEW_TYPE:
						case RESULT_ATTACTMENT_VIEW_TYPE:						
						if(attachmentFound == false){
								var attachImg = document.createElement("img");
								attachImg.alt= Constants.getMessage("labelAttachment");
								attachImg.src = ImageCache.ATTACHMENT;
								attachImg.className = "type-image";
								attachImg.id = this.ATTACH_ICON + stepNum;								
								attachCell.appendChild(attachImg);
								attachmentFound = true;
								dojox.data.dom.removeChildren(attachmentsHtmlContent);
							}
							attachmentCount++;
							var attachmentsHtmlContentRow = this._getEmptyRow();
							var attachmentsHtmlContentCell = this._getEmptyCell();
							var attachmentsAnchor = document.createElement("a");
							attachmentsAnchor.target = "_blank";
							var valueArr = properties[i].propertyValue.split(":");
							var attachmentsText = valueArr[0];
							attachmentsAnchor.appendChild(document.createTextNode(attachmentsText));
							attachmentsAnchor.href = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + valueArr[3];
							attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
							attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
							attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
							break;
						
						case COMMENT_VIEW_TYPE:
							if(properties[i].propertyValue && properties[i].propertyValue.length>0){
								commentFound = true;
								dojox.data.dom.removeChildren(commentsHtmlContent);
								commentsHtmlContent.appendChild(document.createTextNode(properties[i].propertyValue));
								commentImg = document.createElement("img");
								commentImg.alt= Constants.getMessage("labelComment");
								commentImg.src = ImageCache.COMMENT;
								commentImg.className = "type-image";
								commentImg.id = this.COMMENT_ICON + stepNum;
								commentCell.appendChild(commentImg);
							}
							break;
						case COMPARE_VIEW_TYPE:
							var compareButton = document.createElement("button");
							if(dojo.isIE >= 7)
									compareButton.style.backgroundColor = '#FFFFFF';
								else
									compareButton.style.background = "inherit";
							compareButton.style.border="0pt";
							var compareImg = document.createElement("img");
							compareImg.alt= Constants.getMessage("labelCompare");
							compareImg.src = ImageCache.COMPARE;
							compareImg.className = "type-image";
							compareButton.id = this.COMPARE_ICON + stepNum;
							compareButton.appendChild(compareImg);
							compareCell.appendChild(compareButton);
							dojo.connect(compareButton, "onclick", this,dojo.hitch(this,"_showCompareDialog",stepNum,null));
							break;
						default:
							//do Nothing
					}
				}	
			}
			var tooltip;
			if(attachmentCount>0){
				var _attachmentTooltipSpan = document.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = document.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				tooltip = new HoverPopup({connectNode: [attachImg],label: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
			}
			if(defectCount>0){
				var _defectTooltipSpan = document.createElement("span");
				defectCell.appendChild(_defectTooltipSpan);
				var defectCountText = document.createTextNode("("+defectCount+")");
				dojo.style(defectCell,"fontSize","0.7em");
				defectCell.appendChild(defectCountText);
				defectsHtml.appendChild(document.createTextNode(Constants.getMessage("labelDefectIconText")));
				tooltip = new HoverPopup({connectNode: [defectImg]}, defectsHtml);				
			}	
			if(commentFound ===true){
				var _commentTooltipSpan = document.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				tooltip = new HoverPopup({connectNode: [commentImg],label:commentsHtmlContent.innerHTML}, _commentTooltipSpan);				
			}			
			return [attachCell,defectCell,commentCell,compareCell];
		},		
		_showCompareDialog:function(stepNum,properties){
			var stepProperties = properties ? properties:this.stepProperties[stepNum];
			if(!stepProperties){
				if(stepNum.indexOf('_')>0){
					var keywordStepNum = stepNum.split('_')[1];
					var keywordNum = stepNum.split('_')[0];
					keywordNum = parseInt(keywordNum,10);
					var props = this.stepProperties[keywordNum];
					for(var i=0;i<props.length;i++){
						if(props[i].propertyName ==keywordStepNum && props[i].propertyType == KEYWORD_STEP_COMPARE){
							var propName = props[i].propertyValue.split('#')[0];
							var propValue = props[i].propertyValue.split('#')[1];
							stepProperties = [{propertyName:propName,propertyType:COMPARE_VIEW_TYPE,propertyValue:propValue}];
							break;
						}
					}
				}else
					return;
			}
			var compareButton = dojo.byId(this.COMPARE_ICON + stepNum);
			dijit.popup.close(this.compareView);
			if (!this.compareView) {
				this.compareView = new CompareView({
					hideActual: false,
					editable: false,
					callback:dojo.hitch(this,function(){
							dijit.popup.close(this.compareView);
						})
				});
				dojo.style(this.compareView.domNode,"background","white");
				dojo.style(this.compareView.domNode,"border","1px solid gray");
				dojo.style(this.compareView.domNode,"padding","5px");
				dojo.style(this.compareView.domNode,"width","200px");
			}
			this.compareView.setData(stepProperties);
			dijit.popup.open({ parent: compareButton,
				popup: this.compareView,
				around: compareButton,
				orient: {'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'},
				onExecute: function(){}
			});
			this.compareView.setFocus();
		},
		
		_showDefect:function(stepNum, propertyType){
			defectProps = [];
			var props = this.stepProperties[stepNum];
			if(props){
				for(var i=0;i<props.length ;i++)
					if(props[i].propertyType == propertyType)
						defectProps.push(props[i]);
			}
			if(propertyType == DEFECT_VIEW_TYPE){
				if(!this._defectView)
					this._defectView = new DefectView();
				this._defectView.setData(defectProps);			
				var dialogArgs = {
					primaryTitle: Constants.getMessage("labelDefectsView"),
		            isClosable: true,
					showActions:false,
					zIndex : 100
	            };
				this._defectView.setViewType("list");
	            this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
	            this._defectsViewer.setWidth('800px');			
				this._defectView.setParentDialog(this._defectsViewer);
				this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);
				this._defectsViewer._onClose = function(){
					this.destroy();//dont destroy recursive;
				}
				this._defectsViewer.open();
			} else if (propertyType == RTC_DEFECT_VIEW_TYPE){
				var draftUriFilter = [];
				var ewiId = this.parentEditor.getEWI().itemId;
				ewiId = ewiId ? ewiId : null;
				for(var i = 0; i < defectProps.length; i++){
					draftUriFilter.push(
						defectProps[i].propertyValue
					);
				}
				var listDialog= AssociatedWorkItemViewer.create(getDefectsManager(), ewiId, "com.ibm.rqm.execution.linktype.eresultrelatedtodefect", false, draftUriFilter);
			}

		},
		_appendEditableStepRow: function(targetRow, stepNum, stepObj){
			if ( targetRow == null ){
				targetRow = this._getEmptyRow();
				targetRow.id = "_tr"+stepNum;
				this.attachmentEvent = dojo.connect(targetRow, "onclick", this, this._handleRowClick);
				this._stepsTableBody.appendChild(targetRow);
			}
			if(stepObj.elementType && stepObj.elementType.name == "Keyword"){
				var scriptId = null;
				var scriptStateId = null;
				for(var j=0;j<this.stepProperties[stepNum].length;j++){
					if(this.stepProperties[stepNum][j].propertyName == "scriptId" && 
						this.stepProperties[stepNum][j].propertyType == "keyword")
					{
						scriptId = this.stepProperties[stepNum][j].propertyValue;
						break;
					}	
					if(this.stepProperties[stepNum][j].propertyName == "scriptStateId" && 
						this.stepProperties[stepNum][j].propertyType == "keyword")
					{
						scriptStateId = this.stepProperties[stepNum][j].propertyValue;
					}	
				}
				if(!scriptId)
					return;
				var self = this;
				var callbackObj = {
					success: function(scripts){
						self._insertStep(targetRow,stepNum,scripts[0],true);
					},
					failure: function(e){
						self._error(e);
					}				
				}
				var args = {id:scriptId,includeArchived:true};
				if(scriptStateId)
					args.stateId = scriptStateId;
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				TestScriptClient.getTestScripts(responseHandler, args);
				return;
			}
			this._insertStep(targetRow,stepNum,stepObj);
		},
		
		_insertStep:function(targetRow,stepNum,stepObj,isKeyword){
			dojox.data.dom.removeChildren(targetRow);
			//step number cell
			var numCell = this._getEmptyCell();
			numCell.appendChild(document.createTextNode(stepNum+1));
			targetRow.appendChild(numCell);
			//step type cell
			var typeCell = this._getEmptyCell();
			var typeImg = document.createElement("img");
			typeImg.title = "";
			typeImg.alt= "";
			typeImg.src= ImageCache.getTypeIconURL(this.stepTypes[stepNum%this.result.script.elements.length]);
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			targetRow.appendChild(typeCell);
			
			//result type cell
			var resultCell = this._getEmptyCell();
			var resultImg = document.createElement("img");
			resultImg.src= Utility.getImageForResult(this.stepResults[stepNum]);
			resultImg.alt = this.stepResults[stepNum].name;
			resultImg.id = "_results" + stepNum;
			resultCell.appendChild(resultImg);
			//if(this.stepTypes[stepNum%this.result.script.elements.length].name != "Execution Step" || this._stepsHaveVerdict == true){
			if(this.stepResults[stepNum%this.result.script.elements.length]&& 
				this.stepResults[stepNum%this.result.script.elements.length].id != "com.ibm.rqm.execution.common.state.complete"){
					resultCell.appendChild(document.createTextNode(this.stepResults[stepNum].name));
			}
			targetRow.appendChild(resultCell);
			if(!isKeyword){
				//step name / description cell
				var descriptionCell = this._getEmptyCell();
				var descriptionInput = document.createElement('div');
				descriptionInput.innerHTML = unescape(this.stepDescriptions[stepNum%this.result.script.elements.length]);
				descriptionInput.id = "_stepDesc" + stepNum;
				descriptionCell.appendChild(descriptionInput);	
				targetRow.appendChild(descriptionCell);
				
				//deal with Datapool value: 
				this._replaceVariable(descriptionInput, Math.floor(stepNum/this.result.script.elements.length));
				
				//Changes for Properties
				var properties = this.stepProperties[stepNum];
				propshtml = this._createPropertiesHtml(stepNum,properties);
				targetRow.appendChild(propshtml[0]);
				targetRow.appendChild(propshtml[1]);
				targetRow.appendChild(propshtml[2]);
				targetRow.appendChild(propshtml[3]);
			}else{
				//step name / description cell
				var descriptionCell = this._getEmptyCell(4);	
				var descriptionElement = null;
				descriptionElement = document.createElement("table");
				var descriptionElementBody = document.createElement("tbody");
				descriptionElement.width = "100%";
				var descriptionRow = this._getEmptyRow();
				var descriptionInnerCell = this._getEmptyCell(20);
				var detailsDiv = document.createElement('div');
				detailsDiv.innerHTML = unescape(this.stepDescriptions[stepNum%this.result.script.elements.length]);
				descriptionInnerCell.appendChild(detailsDiv);
				descriptionRow.appendChild(descriptionInnerCell);
				descriptionElementBody.appendChild(descriptionRow);
				descriptionElement.appendChild(descriptionElementBody);
				descriptionCell.appendChild(descriptionElement);
				targetRow.appendChild(descriptionCell); 
				var properties = this.stepProperties[stepNum];
				propshtml = this._createPropertiesHtml(stepNum,properties);
				descriptionRow.appendChild(propshtml[0]);
				descriptionRow.appendChild(propshtml[1]);
				descriptionRow.appendChild(propshtml[2]);
				descriptionRow.appendChild(propshtml[3]);
				//script statements
				if(stepObj.elements){	
					for(var i=0;i<stepObj.elements.length;i++){
						var keywordStepsRow = this._getEmptyRow();
						var typeCell2 = this._getEmptyCell();
						dojo.style(typeCell2,"width","16px");
						var typeElement = document.createElement("img");
						typeElement.title = Constants.getMessage("labelKeyword");
						typeElement.alt= Constants.getMessage("labelKeyword");
						typeElement.src= ImageCache.getTypeIconURL(stepObj.elements[i].elementType);
						typeElement.className = "type-image";
						typeCell2.appendChild(typeElement);
						keywordStepsRow.appendChild(typeCell2);
					
						var keywordCell = this._getEmptyCell(20);
						var keywordSteps = document.createElement('div');
						keywordSteps.innerHTML = unescape(stepObj.elements[i].content);
						keywordCell.appendChild(keywordSteps);
						keywordCell.width = "85%";
						keywordStepsRow.appendChild(keywordCell);						
						properties = stepObj.elements[i].properties;
						propshtml = this._createPropertiesHtml(stepNum+"_"+i,properties);
						propshtml[0].width="5%";
						propshtml[1].width="5%"
						propshtml[2].width="5%"
						propshtml[2].width="5%"
						keywordStepsRow.appendChild(propshtml[0]);
						keywordStepsRow.appendChild(propshtml[1]);
						keywordStepsRow.appendChild(propshtml[2]);
						keywordStepsRow.appendChild(propshtml[3]);
						descriptionElementBody.appendChild(keywordStepsRow);
					}
				}
			}	
		},
		
		_getEmptyRow: function(){
			var row = document.createElement("tr");
			row.className = "steps-table-row";
			return row;
		},
		
		_getEmptyCell: function(span, align){
			var cell = document.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ){
				cell.colSpan = span;
			}
			if ( align != null ){
				cell.align = align;
			}
			return cell;
		},
		
		_handleRowClick: function(e){
			e.preventDefault();
			var currentTarget = e.currentTarget.id
			var s = currentTarget.split("_tr")
			if(this.lastClickedRow != "none"){
				var row = document.getElementById("_tr"+this.lastClickedRow)
				row.className = "steps-table-row"
			}	
			this.lastClickedRow = s[1];
			var row = document.getElementById("_tr"+s[1])
			row.className = "selected-row"	
		},
		
		_showReport: function(){
			/*ReportUUID is static and defined for Manual Execution Status report as execution.manualStatus*/
			var self = this;
			var arguments = {
				projectAreaUUID: getCurrentProjectArea().itemId,
				reportUUID: "execution.manualStatus",
				parameterName: "resultId",
				parameterValue: self._itemId,
				showArchived: false,
				webui: true
			};
			var serviceObject = {
			// Service success
				success: function(html) {
					self._reportChart.innerHTML = html;
				},
			// Service failure
				failure: function(errorObject) {
					self._error(errorObject);
				}
			};
			var responseHandler = new ServiceResponseHandler(serviceObject, "success", "failure");
			var request = new ServiceRequest(REPORT_REST_SERVICE_URI,"getRenderedReport",arguments);
			// Invoke the service
			TeamServerClient.invokeService(request, responseHandler);
		},
		
		///////////////////////////////////////////////////////////////////////////////
		// replace placeholder by real cell value
		///////////////////////////////////////////////////////////////////////////////
		_replaceVariable: function(desDiv, iteration) {
			var children = desDiv.getElementsByTagName("BUTTON");//desDiv.childNodes;
			var newArray = [];
			for(var i=0; i<(children ? children.length : 0); i++) {
				newArray.push(children[i]);
			}
			if(newArray && newArray.length) {
				var newDiv = document.createElement("div");
				for(var i=0; i<newArray.length; i++) {
					var child = newArray[i];
					if (child.name == "variable") {
						var itemId = child.id;
						var preString = this._getButtonHTML(desDiv.innerHTML, itemId);
						var cell = this._getCellFromExist(itemId, iteration);
						if (!cell) {
							cell = "";
						}
						var preContent = desDiv.innerHTML;
						var newString = preContent.replace(preString, cell);
						desDiv.innerHTML = newString;
					}
				}
			}
			return desDiv;
		},
		
		_getButtonHTML: function(whole, itemId) {
			var hasMore = true;
			while(hasMore) {
				var tmpWhole = whole.toLowerCase(); 
				var start = tmpWhole.indexOf("<button ");
				var end = tmpWhole.indexOf("</button>");
				var tmpString = whole.substring(start, end+9);
				var idSite = tmpString.indexOf(itemId);
				if(idSite > 0){
					return tmpString;
				}
				whole = whole.substring(end+9, whole.length);
				hasMore = (whole.indexOf("<button ") > 0)?true: false;
			}
			return "";
		},
		
		_getCellFromExist: function(variableItemId, iteration) {
			if (!this._datapool || !this._datapool.variables || !this._datapool.records) {
				return null;
			}else{
				if(!this.parentEditor.isDatapoolValueUpdated()){
					this.parentEditor.showDatapoolUsage(this._datapool);
				}
			} 
			
			for(var i = 0; i < this._datapool.variables.length; i++)
			{
				if (this._datapool.variables[i].itemId == variableItemId || this._datapool.variables[i].id == variableItemId) 
					return "<b>" + this._datapool.records[iteration].cells[i].value + "</b>";			
			}
			return null;
		},
		
		_contains: function(items, itemId){
            if(items && items.length) {
				for(var i = 0; i< items.length; i++) {
					if(items[i].itemId == itemId)
						return true;
				}
			}
			return false;
        },
		
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ ManualExecutionLog#_error");
		}
	}
);

}
)();
