/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.commandline.web.ui.internal.view.extension.CommandLineExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.adapter.commandline.web.ui.internal.view.execution.CommandLineExecution");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { // module container

var   ExecutionViewer    				= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;
var   COMMAND					   	= "command";
var   ARGUMENTS					   	="arguments"

dojo.declare(
   "com.ibm.rqm.adapter.commandline.web.ui.internal.view.extension.CommandLineExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_commandLineExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-CommandLineExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

	//@Overriden from ExecutionViewer
   	initialize: function()
	{   
		var scriptInfo = {
			itemId: this.script.itemId,
			type: this.script.scriptType.id,
			_resultId: this._resultId,
			parentWidget:this.parentEditor
		};
		if (this.script != null) {
		  if(this.script.properties)
		  {
			for(var i=0;i<this.script.properties.length; i++)
			{
				if(this.script.properties[i].propertyName === ARGUMENTS)
					scriptInfo.arguments = this.script.properties[i].propertyValue;	
			}
		  }
		}         
		this.scriptInfo = scriptInfo;     
		dojox.data.dom.removeChildren(this._commandLineExecutionSection);
		this._cmdWidget = new com.ibm.rqm.adapter.commandline.web.ui.internal.view.execution.CommandLineExecution({ parentController: this.parentController, ewiItemId: this.ewiItemId, scriptInfo: scriptInfo, parentSection: this});
		this._commandLineExecutionSection.appendChild(this._cmdWidget.domNode);
		this.inherited("initialize", arguments);	        
   },

	//@Overriden from ExecutionViewer
	getHelpContextID: function()
	{
	  return "rqm_commandline_test.html";
	}, 

	//@Overriden from ExecutionViewer
	setCurrentRequest: function(request)
	{
		this._cmdWidget.showMessages(request.response)
		this.inherited("setCurrentRequest", arguments)
	}
});

})();