/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.extension.SectionGroup");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.extension.SectionGroup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    /**
     * Widget to display list of link elements in the LeftNavigation.
     */
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.extension.SectionGroup", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templateString: '<div dojoAttachPoint="_subSectionsNode"></div>',
        
        constructor: function(){
            this.initialized = false;
			this.sections = [];		
        },
        
        postCreate: function(args){	
            this.inherited('postCreate', arguments);
            if (!this.getConfig().sections) {
                throw new Error("SectionGroup: widget should only be instantiated for SectionGroupDTO !")
            }            
        },
        
		//will be lazily loaded by getMainContent
		//@Overridden from AbstractArtifactEditorSection
        initialize: function(isEditable) {
            //create the rich text control
			dojox.data.dom.removeChildren(this._subSectionsNode);
            for (var i = 0; i < (this.sections ? this.sections.length : 0); i++) {
                this._subSectionsNode.appendChild(this.sections[i].container.domNode);
            }        
        },
        
        addSection: function(/* EditorSubSection */subSectionWidget) {
            this.sections.push(subSectionWidget);
        },
        
        getMainContent: /* DOM Node */ function(isEditable) {
            //lazily initialize main content
            if (!this.initialized) {
                this.initialize(isEditable);
                this.initialized = true;
            }
            return this.domNode;
        },        
               
        //@Overridden from AbstractArtifactEditorSection
        getHelpContextID: function(){
			// cs help id will be a custom attribute with id 'csHelpId'
			var config = this.getConfig();
            if (config && config.properties) {
				for (var index in config.properties) {
					if(config.properties[index].id == "csHelpId") {
						return config.properties[index].value + ".html";
					}
				}  
			}
            return null;
        },
        
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            //nothing
        },
        
        _error: function(e){
            alert("An error occurred: [" + e.message + "] @ SectionGroup#_error");
        }
    });
})();
