/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList");
dojo.provide("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog");
dojo.require("com.ibm.rqm.keyword.web.ui.internal.view.keyword.NewKeywordPopup");
dojo.require("com.ibm.rqm.keyword.web.ui.internal.view.table.KeywordsTableView");
dojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

(function() {

var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var NewKeywordPopup 		= com.ibm.rqm.keyword.web.ui.internal.view.keyword.NewKeywordPopup;
var TestScriptClient 		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var KeywordClient 			= com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient;
var SelectItemTableDialog   = com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ViewHeaderLayout		= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;

/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;

dojo.declare("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoAttachPoint="viewHeaderNode"></div>' +
                    '  <div dojoAttachPoint="keywordTableNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '</div>',

    constructor: function() {
	 	this.keywords = [];
	 },

    postCreate: function(){
        var headerArg = {
			title: Constants.getMessage("labelAllKeywords"),
            contextHelpId: "rqm_all_keywords.html"
        };
		this.viewHeader = new com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout(headerArg);
		this.viewHeader.setCSHelpButtonLabel(Constants.getMessage("labelKeywordsHelp"));
		this.viewHeaderNode.appendChild( this.viewHeader.domNode );
		net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient",function(){});
		this._initialize();
	},
	
	_initialize:function(){
		var responseHandler = new ServiceResponseHandler(this, "_showTable", "_error");
		KeywordClient.getKeywordDTO(responseHandler, {});
	},
    _showTable:function(keywords){
		this.keywords = [];
		if(keywords && keywords.length > 0){
			for(var i=0;i<keywords.length;i++){
				if(keywords[i].archived)
					continue;
				this.keywords.push({
					id:keywords[i].id,
					name:keywords[i].name,
					implementation:keywords[i].defaultScript ? keywords[i].defaultScript:keywords[i].manualScript ,
					tags:keywords[i].tags,
					modified:keywords[i].modified,
					executionScripts:keywords[i].executionScripts,
					manualScript:keywords[i].manualScript,
					stateId:keywords[i].stateId
				});
			}
		}
        var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SCRIPT);
		if (!this.keywordTable) {
			this.keywordTable = new com.ibm.rqm.keyword.web.ui.internal.view.table.KeywordsTableView({
				keywords: this.keywords
			});
			this.keywordTableNode.appendChild(this.keywordTable.domNode);
			
			if (!permission || permission[PermissionsClient.ACTION_CREATE]) {
				this.keywordTable.addAction("create",Constants.getMessage("labelCreateKeyword"), null, "create-keyword-image", dojo.hitch(this, "onCreate"));
			}
			if (!permission || permission[PermissionsClient.ACTION_EDIT]) {
				this.keywordTable.addAction("associate", Constants.getMessage("labelAssociateScripts"), this, "associate-keyword-image", dojo.hitch(this, "onAssociate"));
				this.keywordTable.addAction("edit", Constants.getMessage("labelEditKeywords"), this, "edit-keyword-image", dojo.hitch(this, "onEdit"));
				this.keywordTable.addAction("save", Constants.getMessage("labelSaveKeywords"), this, "save-keyword-image", dojo.hitch(this, "onSave"));
			}
			if (!permission || permission[PermissionsClient.ACTION_ARCHIVE]) {
				this.keywordTable.addAction("archive", Constants.getMessage("labelDeleteKeywords"), this, "archive-keyword-image", dojo.hitch(this, "onArchive"));
			}
			this.keywordTable.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, "refresh"));
			this.keywordTable.show();
		}
		else
			this.keywordTable.refresh(this.keywords);
		this.keywordTable.disableAction("save");
		this.keywordTable.disableAction("edit");
		this.keywordTable.disableAction("associate");
		this.keywordTable.disableAction("archive");
		        	
	},
	onCreate:function(){
		var tagList = this.keywordTable.getTagList();
		var args = {
            itemType: Constants.MODEL_TYPE_KEYWORD,
            onOkCallback: dojo.hitch(this, "_handleAddNewItem"),
			tagList:tagList
        }
        this._newKeywordDialog = new NewKeywordPopup(args);
	},
	onAssociate:function(){
		var selectedKeyword = this.keywordTable.getSelectedRows();
		if(selectedKeyword && selectedKeyword.length > 0 ){
			var responseHandler = new ServiceResponseHandler(this, "_showRemoteScripts", "_error");	
			var scriptObj = {
				includeArchived:false
			};
			com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient.getExecutionScripts(
						responseHandler, scriptObj);
		}
	},
	
	onArchive:function(){
		var selectedKeywords = this.keywordTable.getSelectedRows();
		if(selectedKeywords && selectedKeywords.length > 0 ){           
            var messagespan = document.createElement("label");
            messagespan.innerHTML = Constants.getMessage("msgArchiveKeyword");
            var yesNoDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog({
				primaryTitle:Constants.getMessage("labelDeleteKeywords"),
                yesCallback:dojo.hitch(this,"_archiveKeyword"),
                yesCallbackData:selectedKeywords,
				isClosable: true
            });
            yesNoDialog.contentContainer.appendChild(messagespan);
            yesNoDialog.open();			
		}		
	},
	
	_archiveKeyword:function(selectedKeywords){
		this.toBeArchived = selectedKeywords;
		this._postArchiveKeyword(this);
        
	},
	_postArchiveKeyword:function(kwSelf){
		if(kwSelf.toBeArchived && kwSelf.toBeArchived.length>0){
			var keyword = kwSelf.toBeArchived[0];
			kwSelf.toBeArchived.splice(0,1);
			var handler = {
				kwSelf:kwSelf,
	            success: function() {
					//we wont get the new stateId for the keyword
					// but since after archiving, we cant do any operations on keyword, its ok
	                kwSelf._updateKeywordList(keyword,true);
					if(kwSelf.toBeArchived.length >0){
						kwSelf._postArchiveKeyword(this.kwSelf);
					}else{
						kwSelf.keywordTable.refresh(kwSelf.keywords);
						kwSelf.viewHeader.clearStatus();
					}
	            },
	            error: function(e) {
	                kwSelf._error(e);
	            }
	        };
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
			var scriptObj = {
				id: keyword.id,
				stateId:keyword.stateId,
				archive:true
			};
			KeywordClient.postArchiveKeyword(responseHandler, scriptObj);
		}
	},
    onEdit:function(){
		if(!this.keywordTable.getTableStateForEditing()){
			this.keywordTable.setTableStateForEditing();
		}else{ //discard changes
			this.keywordTable.changedKeywords=[];
			this.keywordTable.unsetTableStateForEditing();
			this.keywordTable.refresh(this.keywords);
			this.viewHeader.clearStatus();
		}
	}, 
	onSave:function(){
		this.keywordTable.unsetTableStateForEditing();
		var changedKeywords = this.keywordTable.getChangedKeywords();
		if(changedKeywords.length>0){
			this.lastChangedKeyword = changedKeywords[changedKeywords.length-1].id;
			for(var i=0;i<changedKeywords.length;i++)
				this._updateKeywords(changedKeywords[i]);
		}
	},
	_updateKeywords:function(changedKeyword){
		var self = this;
    	var handler = {
        	success: function(keyword) {
            	self._updateKeywordList(keyword);
				if(self.lastChangedKeyword == keyword.id){
					self.keywordTable.refresh(self.keywords);
					self.viewHeader.clearStatus();
				}
        	},
        	error: function(e) {
            	self._postError(e);
        	}
        }		
		var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
		var keywordObj = {
			id:changedKeyword.id,
			name:changedKeyword.name,
			tags:changedKeyword.tags,
			defaultScript:changedKeyword.implementation.itemId,
			stateId:changedKeyword.stateId
		};
		KeywordClient.postKeywordDTO(responseHandler, keywordObj);
	},
	_handleAddNewItem:function(){
		var newItem = this._newKeywordDialog.getItemForDisplay();
		if(newItem.selectedScriptItemId){
			this._createKeyword({itemId:newItem.selectedScriptItemId}, newItem);
			return;
		}
		var self = this;
        var handler = {
            success: function(testScript) {
                self._createKeyword(testScript, newItem);
            },
            error: function(e) {
                self._error(e);
            }
        }
		var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
		var scriptObj = {
			name: newItem.name,
			type: "Manual",
			description: Constants.getMessage("labelKeywordDesc"),
			newScript: true,
			state:Constants.STATETRANSITION_STATE_DRAFT
		};
		TestScriptClient.saveTestScript(responseHandler, scriptObj);
	},

	_createKeyword:function(testScript,newItem){
		var responseHandler = new ServiceResponseHandler(this, "_createFinished", "_postError");	
		var keywordObj = {
			newKeyword:true,
			name: newItem.name,
			tags: newItem.tags,
			manualScript:testScript.itemId,
			defaultScript:testScript.itemId
		};
		KeywordClient.postKeywordDTO(responseHandler, keywordObj);
	},

	_createFinished:function(keyword){
		this.keywords.push({
			id:keyword.id,
			name:keyword.name,
			implementation:keyword.defaultScript ? keyword.defaultScript:keyword.manualScript,
			tags:keyword.tags,
			modified:keyword.modified,
			executionScripts:[],
			manualScript:keyword.manualScript,
			stateId:keyword.stateId
		});
		this.keywordTable._parseTags(keyword.tags);
		this.keywordTable.refresh(this.keywords);
		this.viewHeader.clearStatus();
	},
	_showRemoteScripts:function(scripts){
        var params = {
            title: Constants.getMessage("labelAssociateScripts"),
            parentElement: this.domNode,
            exclusionList: [],                    
            itemType: Constants.TYPE_SCRIPT + " Automated",               
            onOk: dojo.hitch(this, "_handleAddedItems")
        };
        var itemListWidget = new SelectItemTableDialog(params);
        itemListWidget.setExclusionList([]);
		itemListWidget._list.setTableRowsCheckable(true,true);
		itemListWidget.show(scripts);
		//itemListWidget._setItems(scripts);
	},
	_handleAddedItems:function(addedItems){
		var selectedKeyword = this.keywordTable.getSelectedRows();
		if(selectedKeyword && selectedKeyword.length > 0 ){
			var scriptIds = [];
			for (var i = 0; i < addedItems.length; i++)
				scriptIds.push(addedItems[i].itemId);
			var self = this;
	    	var handler = {
	        	success: function(keyword) {
	            	self._updateKeywordList(keyword);
					self.keywordTable.refresh(self.keywords);
	        	},
	        	error: function(e){
	            	self._postError(e);
	        	}
	        }		
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
			var keywordObj = {
				id:selectedKeyword[0].id,
				stateId:selectedKeyword[0].stateId,
				scripts: scriptIds,
				defaultScript:scriptIds[0]
			};
			KeywordClient.postKeywordDTO(responseHandler, keywordObj);
		}			
	},
	_updateKeywordList:function(keyword,isArchived){
		for(var i=0;i<this.keywords.length;i++){
			if(keyword.id == this.keywords[i].id){
				if (isArchived) {
					this.keywords.splice(i, 1);
					return;
				}
				if(keyword.defaultScript)
					this.keywords[i].implementation = keyword.defaultScript;
				this.keywords[i].tags = keyword.tags;
				this.keywords[i].executionScripts = keyword.executionScripts;
				this.keywords[i].modified = keyword.modified;
				this.keywords[i].stateId = keyword.stateId;
				break;
			}
		}
	},
	// handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        if ((changeType == GlobalEvents.ArtifactsUpdated || changeType == GlobalEvents.ArtifactsDeleted) 
				&& (artifactType == Constants.TYPE_SCRIPT)) {
			var found = false;
			var archivedCount = 0;
			var updatedCount = 0;
			var msgDetail = null;
			var status = -1;
            for (var i = 0; i < artifactArray.length; i++) {
				for(var j=0;j<this.keywords.length;j++){
					if (this.keywords[j].implementation.itemId == artifactArray[i].itemId) {
						if(changeType == GlobalEvents.ArtifactsDeleted){
							if(this.keywords[j].manualScript.itemId == artifactArray[i].itemId){
								this.keywords.splice(j, 1);
								j = j-1;
								status = 1;
								archivedCount++;
								msgDetail = Constants.getMessage("msgKeywordsManualScriptArchived"); 
							}
							else{
								this.keywords[j].implementation = this.keywords[j].manualScript;
								if(this.keywords[j].manualScript.archived){
									this.keywords.splice(j, 1);
									status = 1;
									archivedCount++;
									msgDetail = Constants.getMessage("msgKeywordsManualScriptArchived");
								}else{
									status = 0;
									msgDetail = Constants.getMessage("msgKeywordsRemoteScriptArchived");
									updatedCount++;
								}
							}
						}else{
							this.keywords[j].implementation = dojo.clone(artifactArray[i]);
							status = 0;
							msgDetail = Constants.getMessage("msgKeywordsScriptUpdated");
							updatedCount++;
						}
						found = true;
                	}else if (this.keywords[j].manualScript.itemId == artifactArray[i].itemId && 
							changeType == GlobalEvents.ArtifactsDeleted) {
						this.keywords[j].manualScript.archived = true;
						found = true;
					}
            	}
        	}
			if(found){
				var statusMsg = "";
				this.viewHeader.clearStatus();
				if(status == 0){
					statusMsg = Constants.getMessage("msgKeywordsUpdated",updatedCount);
					this.viewHeader.setStatus(statusMsg,ViewHeaderLayout.WARNING,msgDetail);
				}
				else if(status == 1){
					statusMsg = Constants.getMessage("msgKeywordsArchived",archivedCount);
					this.viewHeader.setStatus(statusMsg,ViewHeaderLayout.WARNING,msgDetail);
				}
				this.keywordTable.refresh(this.keywords);
				
			}
		}
    },
	_postError:function(e){
		alert(e.message);
	},
	_error: function(e){
		console.error("An error occurred: [" + e.message + "] @ KeywordList#Error");
	},
    refresh: function() {
         this._initialize();
		 this.viewHeader.clearStatus();   
    }      
});

})();
