/******************************SuiteExecutionLog************************************************ 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * ExecutionLogView for Suite
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteWeightSection");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function(){ 
	
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ERGClient 						= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
	var ExecutionResultStateClient		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient;
	var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
	var Utility 						= com.ibm.rqm.execution.web.ui.internal.util.Utility;
	var TSIResultTableView				= com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView;
	var CollapsibleSection				= com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection;
	var WeightSection					= com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteWeightSection;
	var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ViewHeaderLayout 				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var YesNoDialog      				= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
	var EditorUtil						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var ERGMapper						= com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper;
	
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecutionLog", [dijit._Widget, dijit._Templated], {
		
		templateString: "<div>"+
							"<div dojoType=\"com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout\" dojoAttachPoint=\"viewHeaderNode\">" +
							"<div dojoAttachPoint=\"_topSection\"></div>"+
							"<div dojoAttachPoint=\"_weightSection\"></div>"+
							"<div dojoAttachPoint=\"_table\"></div>"+
						"</div>",
		
		widgetsInTemplate: true,
		initialized: false,
		verdicts: [],
		
		postCreate: function(){
			var args = {}
			if(this.suiteId){
				args.id = this.suiteId;
			}else if(this.itemId){
				args.itemId = this.itemId
			}
			var responseHandler = new ERGMapper(this, "initialize", "_error");
			ERGClient.getExecutionResultGroupDTOs(responseHandler, args);
		},
		
		initialize: function(erGroup){
			if(erGroup && erGroup.length > 0){
				this.erGroup = erGroup[0];
			}
			this.fillDetails();
			if(!this.initialized){
				this.viewHeaderNode.setCSHelpId("rqm_suite_results_overview.html");
				this.viewHeaderNode.setIconClass("ewiresult-icon-48");
				this.viewHeaderNode.setTypeLabel(Constants.getMessage("labelTestSuite"));
				this.viewHeaderNode.setTitle(Constants.getMessage("labelTestSuiteResultExecution", this.erGroup.name));
			
				if(this._isPermitted()){
					this.cancelButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"), null, null);
					this.saveButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"), null, null);
					this.saveButton.disabled = true;
					this.cancelButton.disabled = true;
					var registryResponseHandler = new ServiceResponseHandler(this, "_setResultStates", "_error");
					ExecutionResultStateClient.getExecutionResultStates(registryResponseHandler, {});
				}
				this.initialized = true;
			}
			
			this._updateBrowserTitle();
		},
		
		fillDetails: function(){
			var table = document.createElement('table');
			table.width = "50%";
			dojox.data.dom.removeChildren(this._topSection);
			this._topSection.appendChild(table);
			
			//Verdict row
			var verdictRow = this._getEmptyRow();
			verdictRow.width = "100%";
			table.appendChild(verdictRow);
			var verdictLabelCell = this._getEmptyCell();
			verdictLabelCell.width = "45%";
			var verdictEmptyCell = this._getEmptyCell();
			verdictEmptyCell.width = "5%";
			var verdictValueCell = this._getEmptyCell();
			verdictValueCell.width = "50%";
			verdictRow.appendChild(verdictLabelCell);
			verdictRow.appendChild(verdictEmptyCell);
			verdictRow.appendChild(verdictValueCell);
			var verdictLabel = document.createElement('label');
			verdictLabel.innerHTML = Constants.getMessage("labelOverallVerdict");
			this.verdictImg = document.createElement('img');
			this.verdictImg.src = Utility.getImageForState(this.erGroup.state.id);
			verdictLabelCell.appendChild(verdictLabel);
			verdictEmptyCell.appendChild(this.verdictImg);
			if(!this._isPermitted()){
				this.verdictValue = document.createElement('label');
				this.verdictValue.innerHTML = this.erGroup.state.name;
				dojo.style(this.verdictValue, "fontWeight", "bold");
				verdictValueCell.appendChild(this.verdictValue);
			}else{
				this.verdictCombo = document.createElement('select');
				verdictValueCell.appendChild(this.verdictCombo);
				dojo.style(this.verdictCombo, "fontWeight", "bold");
				if(this.verdicts.length > 0)
					this._setResultStates(this.verdicts)
				dojo.connect(this.verdictCombo, "onchange", this, this._updateVerdictIcon);
			}
			
			//StartTime row
			var startTimeRow = this._getEmptyRow();
			startTimeRow.width = "100%";
			table.appendChild(startTimeRow);
			var stLabelCell = this._getEmptyCell();
			stLabelCell.width = "45%";
			var stEmptyCell = this._getEmptyCell();
			stEmptyCell.width = "5%";
			var stValueCell = this._getEmptyCell();
			stValueCell.width = "50%";
			startTimeRow.appendChild(stLabelCell);
			startTimeRow.appendChild(stEmptyCell);
			startTimeRow.appendChild(stValueCell);
			var stLabel = document.createTextNode(Constants.getMessage("labelStartTime"));
			var stValue = document.createTextNode(Utility._convertLongToDate(this.erGroup.startTime));
			stLabelCell.appendChild(stLabel);
			stValueCell.appendChild(stValue);
			
			//EndTime row
			var endTimeRow = this._getEmptyRow();
			endTimeRow.width = "100%";
			table.appendChild(endTimeRow);
			var endLabelCell = this._getEmptyCell();
			endLabelCell.width = "45%";
			var endEmptyCell = this._getEmptyCell();
			endEmptyCell.width = "5%";
			var endValueCell = this._getEmptyCell();
			endValueCell.width = "50%";
			endTimeRow.appendChild(endLabelCell);
			endTimeRow.appendChild(endEmptyCell);
			endTimeRow.appendChild(endValueCell);
			var endLabel = document.createTextNode(Constants.getMessage("labelEndTime"));
			endLabelCell.appendChild(endLabel);
			if(this.erGroup.endTime>0){
				var endValue = document.createTextNode(Utility._convertLongToDate(this.erGroup.endTime));
				endValueCell.appendChild(endValue);
			}
			
			//Total Run Time row
			var totalTimeRow = this._getEmptyRow();
			totalTimeRow.width = "100%";
			table.appendChild(totalTimeRow);
			var totalLabelCell = this._getEmptyCell();
			totalLabelCell.width = "45%";
			var totalEmptyCell = this._getEmptyCell();
			totalEmptyCell.width = "5%";
			var totalValueCell = this._getEmptyCell();
			totalValueCell.width = "50%";
			totalTimeRow.appendChild(totalLabelCell);
			totalTimeRow.appendChild(totalEmptyCell);
			totalTimeRow.appendChild(totalValueCell);
			var totalLabel = document.createTextNode(Constants.getMessage("labelTotalRunTime"));
			var duration = this.erGroup.endTime - this.erGroup.startTime;
			var totalValue = document.createTextNode(Utility.getTimeDifferenceInHrMinSec(duration > 0 ? duration : 0));
			totalLabelCell.appendChild(totalLabel);
			totalValueCell.appendChild(totalValue);
			
			//Mode row
			var modeRow = this._getEmptyRow();
			modeRow.width = "100%";
			table.appendChild(modeRow);
			var modeLabelCell = this._getEmptyCell();
			modeLabelCell.width = "45%";
			var modeEmptyCell = this._getEmptyCell();
			modeEmptyCell.width = "5%";
			var modeValueCell = this._getEmptyCell();
			modeValueCell.width = "50%";
			modeRow.appendChild(modeLabelCell);
			modeRow.appendChild(modeEmptyCell)
			modeRow.appendChild(modeValueCell);
			var modeLabel = document.createElement('label');
			modeLabel.innerHTML = Constants.getMessage("labelExecutionMode");
			var mode = this.erGroup.sequentialExecution ? Constants.getMessage("labelSequential") : Constants.getMessage("labelParallel");
			var modeValue = document.createTextNode(mode);
			modeLabelCell.appendChild(modeLabel);
			modeValueCell.appendChild(modeValue);
			
			this._createWeightSection();
			this._createTable();
		},
		
		_createWeightSection: function(){
			this.weightSection = new  WeightSection();
			this.weightSection.initialize(this.erGroup);
			var params ={
					title: Constants.getMessage("labelWeightDist"),
					summary: this.weightSection.domNode,
					helpContextId: "rqm_execution_weight_help.html"
				}

				var resultWeightSection = this._createCollapsibleSection(params)
				dojox.data.dom.removeChildren(this._weightSection);
				this._weightSection.appendChild(resultWeightSection.domNode);
		},
		
		_createTable: function(){
			var results = this.erGroup.results ? this.erGroup.results : [];
			this.results = results;
			if(!this._TSIResultTableView){
				var args = {
					results: results
				}
				this._TSIResultTableView = new TSIResultTableView(args);
				
				var params ={
					title: Constants.getMessage("labelResultDetails"),
					summary: this._TSIResultTableView.domNode,
					helpContextId: "rqm_test_suite.html"
				}

				var resultDetailsSection = this._createCollapsibleSection(params)
				this._table.appendChild(resultDetailsSection.domNode);
			}else
				this._TSIResultTableView.refresh(results);
			var elements = this.erGroup.elements;	
			for(var j=0;j<this.results.length;j++){
				var args = null;
				var args = this.getProperty(elements[j]);//Order of Results need to be order of Elements
				if(args)
					this._TSIResultTableView.updateItem(this.results[j].itemId, args)
			}	
		},
		
		getProperty: function(element){
			var value = null;
			if(element){
				value = {
					ewiId: element.workitem.id,
					configName: element.ewiConfigurationName,
					configId: element.workitem.configuration,
					weight: element.workitem.weight
				}
			}
			return value;
		},
		
		_getEmptyRow: function() {
			var row = document.createElement("tr");
			row.className = "steps-table-row";
			return row;
		},
		
		_getEmptyCell: function(span, align) {
			var cell = document.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ) {
				cell.colSpan = span;
			}
			if ( align != null ) {
				cell.align = align;
			}
			return cell;
		},
		
		_setResultStates: function(verdicts){	
			this.verdicts = [];
			for(var i=0;i<verdicts.length; i++) {
				this.verdicts.push({name: verdicts[i].name, id: verdicts[i].id});
				SelectUtility.add(this.verdictCombo, new Option(this.verdicts[i].name, this.verdicts[i].id));
			}
			SelectUtility.select(this.verdictCombo, this.erGroup.state.id);
		},

		_updateVerdictIcon: function(){
			this.verdictImg.src = Utility.getImageForState(this.verdictCombo.value);
			this._setDirty(true);
		},
		
		_createCollapsibleSection: function(args){
			var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({open: true, collapsible: false});
	        expando.domNode.name = "first-section";
	        expando.setTitle(args.title ? args.title : "");
	        expando.infoNode.innerHTML = args.info ? args.info: "" ;
			if(args.summary)
				expando.summaryNode.appendChild(args.summary);
			else
				expando.summaryNode.innerHTML = "";
	        if(args.headerRight)
				expando.headerRightNode.appendChild(args.headerRight);
			else
				expando.headerRightNode.innerHTML = "";
			expando.containerHeaderNode.innerHTML = "";
        	var content = document.createElement('div');
			content.innerHTML = "";
        	expando.containerNode.appendChild(content);
			expando.setCSHelpId(args.helpContextId);
			expando.headerCollapsNode.style.display = "none";
		   	return expando;
		},
		
		_isPermitted:function(){
            if(!this.erg_type)
                this.erg_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_SUITE_RESULT;
            if(!this.erg_perm)
                this.erg_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(this.erg_type);
			if (this.erg_perm && !this.erg_perm.edit)
                return false;
            return true;

        },
		
		onSave: function(){
			var params = {};
			params.id = this.erGroup.id;
			params.stateId = this.erGroup.stateId;
			params.state = this.verdictCombo.value;//OnSave will be enabled only if editable
			var responseHandler = new ServiceResponseHandler(this, "saveFinished", "saveError");
			ERGClient.postExecutionResultGroupDTO(responseHandler, params);
			this.setLastSaved(Constants.STATUS_SAVING);
		},
		
		saveFinished: function(summaryDTO){
			if (summaryDTO.elements!=null && summaryDTO.elements.length > 0) {
				for(var i=0;i<summaryDTO.elements.length;i++){
					summaryDTO.elements[i].workitem = {};
					summaryDTO.elements[i].workitem.id = summaryDTO.elements[i].ewiId;
					summaryDTO.elements[i].workitem.name = summaryDTO.elements[i].ewiName;
					summaryDTO.elements[i].workitem.itemId = summaryDTO.elements[i].ewiitemId;
					summaryDTO.elements[i].workitem.testCase = summaryDTO.elements[i].testCase;
					summaryDTO.elements[i].workitem.weight = summaryDTO.elements[i].ewiWeight;
					if(summaryDTO.elements[i].ewiDefaultScriptId){
						summaryDTO.elements[i].workitem.defaultScript = {};
						summaryDTO.elements[i].workitem.defaultScript.id = summaryDTO.elements[i].ewiDefaultScriptId;
						summaryDTO.elements[i].workitem.defaultScript.name = summaryDTO.elements[i].ewiDefaultScriptName;
						summaryDTO.elements[i].workitem.defaultScript.itemId = summaryDTO.elements[i].ewiDefaultScriptItemId;
						summaryDTO.elements[i].workitem.defaultScript.stateId = summaryDTO.elements[i].ewiDefaultScriptStateId;
						summaryDTO.elements[i].workitem.defaultScript.scriptType = {};
						summaryDTO.elements[i].workitem.defaultScript.scriptType.id = summaryDTO.elements[i].ewiDefaultScriptStateType;
					}else
						summaryDTO.elements[i].workitem.defaultScript = null;	
					summaryDTO.elements[i].workitem.stateId = summaryDTO.elements[i].ewiStateId;
					summaryDTO.elements[i].workitem.configuration = summaryDTO.elements[i].ewiConfigurationItemId;
					
					if(summaryDTO.elements[i].ewiPlanName){
						summaryDTO.elements[i].workitem.testPlan = {};
						summaryDTO.elements[i].workitem.testPlan.name = summaryDTO.elements[i].ewiPlanName;
						summaryDTO.elements[i].workitem.testPlan.id = summaryDTO.elements[i].ewiPlanId;
						summaryDTO.elements[i].workitem.testPlan.versionableItemId = summaryDTO.elements[i].ewiPlanVersionableItemId;
					}
					if(summaryDTO.elements[i].ewiPhaseName){
						summaryDTO.elements[i].workitem.phase = {};
						summaryDTO.elements[i].workitem.phase.name = summaryDTO.elements[i].ewiPhaseName;
						summaryDTO.elements[i].workitem.phase.itemId = summaryDTO.elements[i].ewiPhaseItemId;
					}
					
					delete summaryDTO.elements[i].ewiId;
					delete summaryDTO.elements[i].ewiName;
					delete summaryDTO.elements[i].ewiitemId;
					delete summaryDTO.elements[i].testCase;
					delete summaryDTO.elements[i].ewiDefaultScriptId;
					delete summaryDTO.elements[i].ewiDefaultScriptName;
					delete summaryDTO.elements[i].ewiDefaultScriptItemId;
					delete summaryDTO.elements[i].ewiDefaultScriptStateId;
					delete summaryDTO.elements[i].ewiDefaultScriptStateType;
					delete summaryDTO.elements[i].ewiConfigurationItemId;
					delete summaryDTO.elements[i].ewiStateId;
					delete summaryDTO.elements[i].ewiPhaseItemId;
					delete summaryDTO.elements[i].ewiPhaseName;
					delete summaryDTO.elements[i].ewiPlanVersionableItemId;
					delete summaryDTO.elements[i].ewiPlanName;
					delete summaryDTO.elements[i].ewiPlanId;
					delete summaryDTO.elements[i].ewiWeight;
				}	
			}
			var ergObj = summaryDTO;
			this._setDirty(false);
			this.setLastSaved(Constants.STATUS_SUCCESS);
			this.saveButton.disabled = true;
			this.cancelButton.disabled = true;
			this.initialize([ergObj]);
		},
		
		saveError: function(status){
			if (status!=null && status.message!=null) {
				var re = /^\[(\d+)\]\s*:\s*/;
				status.message = status.message.replace(re, "");
			}
			this.setLastSaved(Constants.STATUS_FAILURE, status);
		},
		
		onCancel: function(){
			var self = this;
			var args = {
				title: Constants.getMessage("labelConfirmation"),
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self.initialize(self.erGroup);
					return true;          
				},
				noCallback: function() {
					return false;
				}
			}
			var dialog = new YesNoDialog(args);
	        dialog.setSecondaryTitle(args.title);
	        dialog.open();
		},
		
		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
			if ((changeType != GlobalEvents.ArtifactsAdded) && (artifactType == Constants.TYPE_EXE_LOG)) {
                var suiteResults = this.erGroup.results;
				var changed = false;
				for (var i = 0; i < artifactArray.length; i++) {
					for(var j=0;j<suiteResults.length;j++){
						if (suiteResults[j] && suiteResults[j].id == artifactArray[i].id) {
							if(changeType == GlobalEvents.ArtifactsDeleted){
								this.viewHeaderNode.setStatus(Constants.getMessage("msgEROfSuiteDeleted"), ViewHeaderLayout.ERROR);
								changed = true;
							}
							if(changeType == GlobalEvents.ArtifactsUpdated){
								this.viewHeaderNode.setStatus(Constants.getMessage("msgEROfSuiteUpdated"), ViewHeaderLayout.INFO);
								changed = true;
							}	
                    	}
					}
                }
				if(changed && this.suiteId){
					var args ={id:this.suiteId}//Fetch the ERG again, ERG result rolled up on update of ER
					var responseHandler = new ERGMapper(this, "initialize", "_error");
					ERGClient.getExecutionResultGroupDTOs(responseHandler, args);
				}
            }
        },
		
		setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
                                 
            if ( status == Constants.STATUS_SUCCESS ) {
                st_code = ViewHeaderLayout.SUCCESS;
                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());  
            } 
            else if ( status == Constants.STATUS_FAILURE ) {
                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
                    EditorUtil.showServerErrorMessage(licenseMsg);
                }
                st_code = ViewHeaderLayout.ERROR;
                text = Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());  
                
                if(error && error.message) {
                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
                }
            } 
            else if ( status == Constants.STATUS_SAVING ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusSaving");
            } 
            else if ( status == Constants.STATUS_NEW ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusNewNeedSave");
            } 
            else if ( status == Constants.STATUS_DIRTY ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusDirty");
            }
            
            if(st_code > -1)
               this.viewHeaderNode.setStatus(text, st_code, detail_msg);
            else
                this.viewHeaderNode.clearStatus();
        },
		
		_setDirty:function(dirty){
			this.dirty = dirty;
			this.saveButton.disabled = !dirty;
			this.cancelButton.disabled = !dirty;
			dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, dirty]);
			if(dirty)
				this.setLastSaved(Constants.STATUS_DIRTY);
		},
		
		_error: function(errorObj){
			console.error("Error in Suite Execution Log"+ errorObj.message + " ");
		},
		
		_updateBrowserTitle: function(){
			if (this.page){
				var name = "";
				if (this.erGroup && this.erGroup.name) {
					name = this.erGroup.name;
				}
										  
				this.page.browserTitle =  Constants.getMessage("labelTestSuiteResultExecution", Constants.getMessage("labelColen") +" " + name);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;	
			}
		}          
    });
})();
