/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.DefectTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
//RTC Integration
dojo.require("com.ibm.rqm.defects.web.client.DefectsManager");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredListDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.WindowUtil");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() {

var TableConstants 	= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Utility        	= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      	= com.ibm.rqm.planning.web.client.internal.Constants;
var ImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var DEFECT_URL		= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DefectView		= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;//Need DV here since same table used in EWIListing

var getDefectsManager				= com.ibm.rqm.defects.web.client.DefectsManager.getInstance;
var WorkItemSelectionDialog			= com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog;
var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;

var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var DeferredDialog					= com.ibm.rqm.defects.web.ui.view.common.DeferredDialog;
var WindowUtil						= com.ibm.rqm.defects.web.ui.utils.WindowUtil;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var Status                          = com.ibm.team.repository.web.foundation.Status;
var DEFECT_ORIGIN_1					= "ExecutionResult";
var DEFECT_ORIGIN_2					= "ScriptlessResult";
var DEFECT_ORIGIN_3					= "BlockingPopup";
var RESULT_RELATED_LINKTYPE 		= "com.ibm.rqm.execution.linktype.eresultrelatedtodefect";
var EWI_BLOCKING_LINKTYPE 			= "com.ibm.rqm.execution.linktype.ewiblockingdefect"; 
var RELATED_ARTIFACT				= "com.ibm.team.workitem.linktype.relatedartifact";

dojo.declare("DefectTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(view){
		this.parentView = view;
	},
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		 var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.changeStatusActionNode){
			if(selectionCount != 1 || rowObject.statusId == 5)
            	this.parentView.changeStatusActionNode.setDisabled(true);
			else
				this.parentView.changeStatusActionNode.setDisabled(false);
		}
    },
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    } 
});

dojo.declare("DefectTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
    },
    cellActionInvoked: function(rowObject, columnIndex){
    }
});

dojo.declare("DefectTableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    _createListContents: function(viewer, rowObject, listWidget){
        this.inherited("_createListContents", arguments);
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = Constants.getMessage("labelAddCustCrtl");
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("DefectTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 4;
    },
    getColumnHeading: function(content, index){
        var headings = [
            Constants.getMessage("labelBlockingStatus"),
            Constants.getMessage("labelId"),
            Constants.getMessage("labelSummary"),
			Constants.getMessage("labelState")
        ];
        return headings[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },
    getIsColumnGroupable: function(content, atColumnIndex){
        return false;
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return false;   
    },
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 20;
            case 1: 
                return 15;
            case 2: 
                return 40;
            case 3: 
                return 25;		 
        }
        return 0;
    },
    getContentObjects: function(content){
        return content;
    },    
    getRowDataId: function(rowData){
        return "_table_row_for_defect_" + (rowData.defectItemUri ? rowData.defectItemUri : rowData.id);
    },
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;						 
        }
        return type;
    },
    getCellAlignment: function(rowData, atColumnIndex){
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.isBlocking;
                break;
            case 1: 
                val = rowData.id;
                break;
            case 2: 
                val = rowData.summary;
                break;   
            case 3: 
				val = rowData.status;
                break;  
        }
        return val;
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
        var val = null;  
        if (atColumnIndex == 0) {
           val = {};
			  val.image = rowData.isBlocking ? ImageCache.BLOCKING_DEFECT: ImageCache.NON_BLOCKING_DEFECT; 
			  val.tooltip = "";
		  }
		 if (atColumnIndex == 1) {
           val = {};
			  if (rowData.defectItemUri) {
			  	val.onclick = dojo.hitch(this, function(){
			  		WindowUtil.openArtifactInNewWindow(rowData.defectItemUri);
			  	});
			  } else {
			  	val.href = DEFECT_URL + rowData.id;
			  }
		  } 		  
        return val;
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.DefectTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
						  '</div>',

    widgetsInTemplate: true,
    constructor: function() {
		this.draftDefectId = 0;
		this.draftItemUriList = [];
		this.needDisabled = false; 
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-DEFECT-TABLEVIEWER"                          
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.defects ? this.defects : [];
        tableViewer.setContentPageSize(5);
        tableViewer.setContent(content);
		var tableProvider = new DefectTableView.TableProvider();
        tableViewer.setContentProvider(tableProvider);
        tableViewer.setTableListener(new DefectTableView.TableListener(this));
        tableViewer.setCellModifier(new DefectTableView.CellModifier());
		  
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelDefects")));
        tableViewer.show();
		this.actions = this.getTableActions();
		for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, null, action.iconClass, action.actionHandler);
            if (action.disabled && action.disabled == true)
                actionButton.setDisabled(true);
			if(action.actionId == "refresh"){
				this.freshActionNode = actionButton;
			}
			if(action.actionId == "newdefect"){
				this.addNewActionNode = actionButton;
			}
			if(action.actionId == "adddefect"){
				this.addExistingActionNode = actionButton;
			}
			if(action.actionId == "changestatus"){
				this.changeStatusActionNode = actionButton;
			}	
        }
		this.tableViewer = tableViewer;
    },
	setContent: function(content){
		var newContent = content ? content : [];
		this.tableViewer.setContent(newContent);
		this.tableViewer.refresh();
		if(this._defectView){
			this._defectView.defectList = [];
		}
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	enableActions:function(){
		this.freshActionNode.setDisabled(false); 
		this.addNewActionNode.setDisabled(false); 
		this.addExistingActionNode.setDisabled(false); 
	},
	getTableActions: function(){
		var actions = [];  
		if(this.parentEditor.getCurrentDefectProvider() && this.parentEditor.getCurrentDefectProvider().isConfigured()){
			if((this.defectOrigin == DEFECT_ORIGIN_2))
				this.needDisabled = true;
			actions.push({
                actionId: "refresh",
                label: "refresh",
                actionHandler: dojo.hitch(this, "onFreshExtDraft"),
                iconClass: "refresh-icon-image",
				disabled: this.needDisabled                  
            });  
		}			   
            actions.push({
                actionId: "newdefect",
                label: Constants.getMessage("labelAddNewDefect"),
                actionHandler: dojo.hitch(this, "onCreateNewDefect"),
                iconClass: "new-defect-icon-image",
				disabled: this.needDisabled                  
            });
            actions.push({
                actionId: "adddefect",
                label: Constants.getMessage("labelAddExistingDefect"),
                actionHandler: dojo.hitch(this, "onAddDefect"),
                iconClass: "add-defect-icon-image",
                disabled: this.needDisabled              
            });
			actions.push({
                actionId: "changestatus",
                label: Constants.getMessage("labelChangeStatus"),
                actionHandler: dojo.hitch(this, "onChangeStatus"),
                iconClass: "change-blocked-defect-status-icon-image",
                disabled: true              
            });
			return actions;
	},
	_getEWI: function(){
		return this.parentEditor.ewi?this.parentEditor.ewi:this.parentEditor.ewis[0];
	},
	_freshExtDraftViaProvider: function(){
		var itemId;
		var isExecResultRelated = false;
		var linkType = RESULT_RELATED_LINKTYPE;
		if(this.defectOrigin == DEFECT_ORIGIN_1){
			itemId = this.parentEditor.resultItemId;	
			isExecResultRelated = true;		
		}
		if(this.defectOrigin == DEFECT_ORIGIN_3){
			itemId = this.parentEditor.ewis[0].itemId;
			linkType = EWI_BLOCKING_LINKTYPE;
		}
		var self = this;
		ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociatedDefects"), dojo.hitch(this, function(monitor){		
			getDefectsManager().queryAssociatedDefects(linkType, isExecResultRelated, itemId, monitor, 
			dojo.hitch(this, function(status, response) {
				try{
					if (status.isOK()) {
						dojo.forEach(response, dojo.hitch(this, function(workItem) {
							if(self.defectOrigin == DEFECT_ORIGIN_1){
								if(!(workItem.id == "---"))
									self._freshDefectTable(workItem);
							}
						}));
						if(this._getEWI().itemId && this._getEWI().itemId != "null"){
							this.parentEditor._getExtEwiRelatedDefects(this._getEWI().itemId , false, RESULT_RELATED_LINKTYPE);						
						}
					} else if (status.getSeverity() != Status.CANCEL) {
		                status.log();
						alert(Constants.getMessage("labelNoAssociatedWorkItems", status.getMessage()));
		            }
				} finally {
					monitor.done();
				}				
			}));
		}));
		
	},
	_freshDefectTable: function(defect){
		this.parentEditor._updateExternalDraftItem({id: defect.id,
						summary: Utility._restoreTags(defect.summary),
						status: defect.status,
						defectItemUri: defect.reference
		});
	},
	
	onCreateNewDefect: function(){
		this._defectIconClicked("new",Constants.getMessage("labelAddNewDefect"));
	},
	
	onAddDefect: function(){
		this._defectIconClicked("existing",Constants.getMessage("labelAddExistingDefect"));
	},
	
	onFreshExtDraft: function(){
		this._defectIconClicked("fresh",Constants.getMessage("labelFreshExtDraftDefect"));
	},
	_defectIconClicked: function(contextMenuSelection, title){		
		var currentProviderInstance = this.parentEditor.getCurrentDefectProvider();
		if(currentProviderInstance != null && currentProviderInstance != undefined && currentProviderInstance.isConfigured()){
			this._dispatchDefectActionViaProvider(contextMenuSelection);
		}else {			
			this._defectIconClicked2(contextMenuSelection,title);
		}
	},
	
	_dispatchDefectActionViaProvider: function(contextMenuSelection) {
		if (!contextMenuSelection || contextMenuSelection == "new") {
			this._addNewDefectViaProvider();
		} else if (contextMenuSelection == "existing") { 
			this._addExistingDefectViaProvider();
		} else if (contextMenuSelection == "fresh"){
			this._freshExtDraftViaProvider();
		}
	},
	
	_addNewDefectViaProvider: function() {
        var defectDescription = { summary: "", description: "", links: [] }; 
		if(this.defectOrigin == DEFECT_ORIGIN_1 && this._getEWI()){
			defectDescription["summary"] = this._getEWI().name != this._getEWI().testCase.name ? Constants.getMessage("labelFailingTestCaseWithEWI", this._getEWI().testCase.name, this._getEWI().name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this._getEWI().testCase.name)
		}		               

		defectDescription["isExecResultRelated"] = true;
		defectDescription["defectOriginItemId"] = this.parentEditor.resultItemId;
		var queryString = "?ewiId="+this._getEWI().id;  
        defectDescription["links"].push({
            type: RELATED_ARTIFACT,
            uri: this._getExecutionResultUri()+ queryString,
            comment: Constants.getMessage("labelRelatedER", this.parentEditor.result.name)
        });

        var self = this;
        ProgressDialog.doRunWithProgress(Constants.getMessage("labelCreatedefect"), dojo.hitch(this, function(monitor){
            getDefectsManager().createDefect(RESULT_RELATED_LINKTYPE, [defectDescription["defectOriginItemId"]], defectDescription, monitor, dojo.hitch(this, function(status, draftItemUri){
                try{
					if(status.isOK()) {   
                        WindowUtil.openArtifactInNewWindow(draftItemUri);
						// Construct the new created external RTC defect's info 
						var defect = {
								id: "Draft:"+(++self.draftDefectId),
								summary: defectDescription["summary"],
								status: "External",
								defectItemUri: draftItemUri					
							}
						var defectList= [];
						defectList.push(defect);
						if(dojo.isFunction(self.parentEditor._appendInExtDefectList)){
							self.parentEditor._appendInExtDefectList(defectList,"new");
						}
                    }
                    else if(status.getSeverity() != Status.CANCEL) {
                        status.log();
                        alert(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
                    }
				} finally {
					monitor.done();
				}                
            }
			));
        }));
	},

	_addExistingDefectViaProvider: function() {
		var selectionDialog= WorkItemSelectionDialog.create(getDefectsManager(), "queryExistingDefects");
		var self = this;
		this.connect(selectionDialog, "onOk", dojo.hitch(this, function(selection) { 
			var workItem= selection[0];	
			var defect = {
					id: workItem.id,
					summary: Utility._restoreTags(workItem.summary),
					status: workItem.status,
					defectItemUri: workItem.reference					
				}
			var defectList= [];
			defectList.push(defect);
			if(self.defectOrigin == DEFECT_ORIGIN_1){
				if(dojo.isFunction(self.parentEditor._appendInExtDefectList)){
					self.parentEditor._appendInExtDefectList(defectList,"new");
				}	
			}			
			var addLinkParams= {
				ewiUri: self._getExecutionResultUri(),
				linkType: RELATED_ARTIFACT,
				workItemId: workItem.id,
				workItemUri: workItem.reference,
				comment: Constants.getMessage("labelRelatedER", this.parentEditor.result.name),
				label: workItem.label
			};
			
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelCreatedefect"), function(monitor) {
				getDefectsManager().associateDefect(RESULT_RELATED_LINKTYPE, addLinkParams, monitor, function(status, response) {				
					monitor.done();					
					if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
						status.log();
						alert(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
					}
				});
			});
		}));
	},
	_getExecutionResultUri:function(){
		var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
		result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
		result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionResult/" + this.parentEditor.resultItemId;
		return result;
	},
	_getEwiUri: function() {
		var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
		result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
		result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + this._getEWI().itemId;
		return result;
	},
	_defectIconClicked2: function(contextMenuSelection, title){
		if(!this._defectView)
			this._defectView = new DefectView();
		this.addNewActionNode.setDisabled(true);
		this.addExistingActionNode.setDisabled(true);
		var dialogArgs = {
			primaryTitle: title,
            isClosable: true,
			showActions:false,
			style: "z-index: 999;",
			zIndex: 999,//keep below 1000 for datepicker to show
			onClose: dojo.hitch(this, function(){
				this.addNewActionNode.setDisabled(false);
				this.addExistingActionNode.setDisabled(false);
				//ELB
				if(dojo.isFunction(this.parentEditor._appendInDefectList)){
					this.parentEditor._appendInDefectList(this._defectView.defectList,contextMenuSelection);
				}
			})
		}
		this._defectView.setViewType(contextMenuSelection);
        this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog(dialogArgs);
		this._defectsViewer.blockerDiv.style.zIndex = 998;
		this._defectView.setParentDialog(this._defectsViewer);
		this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);
		var self = this;
		this._defectsViewer._onClose = function(){
			if(dojo.isIE)
				self._defectsViewer.contentContainer.removeChild(self._defectView.domNode);
			this.destroy();
		}
		this._defectsViewer.open();
		this._defectsViewer.setWidth('800px');
	},
	
	onChangeStatus: function(){
		var defects = this.tableViewer.getCheckedRows();
		var defect = defects[0];
		var blocking = true;
		if(defect){
			if(defect.isBlocking)
				blocking = false;
			if(defect.defectItemUri && this.parentEditor.resultItemId){
				ProgressDialog.doRunWithProgress(Constants.getMessage("labelChangeBlocking"), dojo.hitch(this, function(monitor){
		            getDefectsManager().changeBlockingDefect(defect.defectItemUri, this.parentEditor.resultItemId, blocking, monitor, dojo.hitch(this, function(status, draftItemUri, draftLinkParams){
		                monitor.done();
		                if(status.isOK()){
							if(dojo.isFunction(this.parentEditor._updateExtDefectStatus)){
								this.parentEditor._updateExtDefectStatus(defect,blocking);
							}
						}
		            }));
	        	}));
			}else {
				if(dojo.isFunction(this.parentEditor._updateDefectStatus)){
					this.parentEditor._updateDefectStatus(defect.id,blocking);			
				}
			}	
		}
	},
	
	getSelectedRows: function() {
	     return this.tableViewer.getCheckedRows();
	 }
});
})();
