//AssetSelectorDialogProvider
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.providers.AssetSelectorDialogProvider"); 

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineTableProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");


(function() {
	
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;		
	
	var column_types = {
		'Machine': [TableConstants.RENDER_TYPE_TEXT, TableConstants.RENDER_TYPE_TEXT, TableConstants.RENDER_TYPE_TEXT, TableConstants.RENDER_TYPE_TEXT],
		'VirtualImage': [TableConstants.RENDER_TYPE_TEXT, TableConstants.RENDER_TYPE_TEXT, TableConstants.RENDER_TYPE_TEXT, TableConstants.RENDER_TYPE_TEXT, TableConstants.RENDER_TYPE_TEXT ]
	};
    var SEARCH_ATTRIBUTE_HEADINGS = {
        'Machine' : [
		  {title: RtlmUiUtil.getMessage("Name"), native_column: "machine\\.name", isSortable: true, includeInFilter: true, width: 30}, 
		  {title: RtlmUiUtil.getMessage("labelHeaderGroupName"), native_column: "machine\\.group", isSortable: true, includeInFilter: true, width: 25  },
		  {title: RtlmUiUtil.getMessage("Operating System"), native_column: "machine\\.operatingsystem", isSortable: true, includeInFilter: true, width: 25  },
		  {title: RtlmUiUtil.getMessage("IP Address"), native_column: "machine\\.ipAddress", isSortable: true, includeInFilter: true, width: 20  }
		],
		'VirtualImage' : [
          {title: "Image Name", native_column: "VirtualImage\\.name", isSortable: true, includeInFilter: true, width: 20}, 
          {title: "Image Type", native_column: "VirtualImage\\.ImageType", isSortable: true, includeInFilter: true, width: 20  },
		  {title: RtlmUiUtil.getMessage("labelHeaderGroupName"), native_column: "VirtualImage\\.group", isSortable: true, includeInFilter: true, width: 20  },
          {title: "Operating System", native_column: "VirtualImage\\.operatingsystem", isSortable: true, includeInFilter: true, width: 20  },
          {title: "VM File", native_column: "VirtualImage\\.VMFile", isSortable: true, includeInFilter: true, width: 20  }
		]
    };
    
    var ATTRIBUTE_ID_FIELDS = {
        'Machine' : "machine\\.id",
        'VirtualImage' : "VirtualImage\\.id"
    };
    
    var SEARCH_ATTRIBUTE_CRITERIA = {
        'Machine' : "machine.id, machine.name, machine.group, machine.operatingsystem, machine.ipAddress, machine.assetfamily",
        'VirtualImage' : "VirtualImage.id, VirtualImage.name, VirtualImage.ImageType, VirtualImage.group, VirtualImage.operatingsystem, VirtualImage.VMFile"
    };
    

com.ibm.rational.test.lm.web.ui.internal.views.providers.AssetSelectorDialogSearchInfo = {
	getSearchAttributeHeadings : function()
	{
		return( SEARCH_ATTRIBUTE_HEADINGS );
	},
	
	getIdFields: function()
	{
		return( ATTRIBUTE_ID_FIELDS );
	},
	
	getSearchAttributeCriteria: function()
	{
		return( SEARCH_ATTRIBUTE_CRITERIA );
	}
};

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.providers.AssetSelectorDialogProvider", 
             com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineTableProvider,
{
	constructor: function( assetType )
	{
		this.setParameters( { "column_headings" : SEARCH_ATTRIBUTE_HEADINGS,
					  "id_fields" : ATTRIBUTE_ID_FIELDS,
					  "column_types" : column_types,
					  "column_section" : assetType } );
	},
    
	getCellDisplayData: function(rowData, atColumnIndex)
    {
		var data = this.inherited( "getCellDisplayData", arguments );
        
    	return( ( data ) ? data : "" );
    },
	
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        return val;
    },
	
	getIsColumnGroupable: function(content, atColumnIndex)
    {
		//group by OS
		return( (this.columns_section == "Machine" && atColumnIndex == 1) || (this.columns_section == "VirtualImage" && atColumnIndex == 2 ));
    }   
});	
})();
