/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.ReservationViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.rational.test.lm.web.client.internal.reservations");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.reservations.QueryReservationWidget");

(function() {

var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var QueryReservationWidget = com.ibm.rational.test.lm.web.ui.internal.views.reservations.QueryReservationWidget;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.ReservationViewlet",	Viewlet,
{	
	templateString: "<div><div dojoAttachPoint=\"reservationViewletContent\" \></div>",
	
	/*
	 * Called by the framework after the viewlet is instantiated, but before the
	 * first refresh. Viewlets that need to initialize themselves shoudl override.
	 */
	init: function() {
        var args = {
            defaultQuery: QueryReservationWidget.ACTIVE_RESERVATION_QUERY_ID,
            tableId: "RQM-LM-RESERVE-QUERY-TABLEVIWLET"
        };
		this.reservationWidget = new QueryReservationWidget(args, this.reservationViewletContent);
	},
	
	/*
 	 * Public Method
 	 * 
 	 * Refreshes the viewlet content.
 	 * 
 	 * @param <none>
 	 * @return <none>
 	 */	
	refresh: function() {  
		this.reservationWidget.loadQueryCombo();
		//Need to set the isRefreshing on the container so that refreshing of the viewlet can occur,
		//otherwise it can only happen once.
		this.container.isRefreshing = 0;
	},
	
	/*
	 * Repopulates the viewlet. New content should not be retrieved from the server.
	 * Called when presentation of the viewlet is changed in some way, but new information
	 * is not required.
	 * 
	 * Viewlets should override.
	 */
	update: function() {
	}
	
});

})();
