/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

(function() {

dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");

// define a message bundle id for Defects
var MessageBundleDefects = "Defects";

dojo.declare("com.ibm.rqm.defects.web.ui.utils._MessageLoader", null,
{
    constructor: function(){
        // initializes the rqm message bundle
       MessageUtil.registerRequireBundle(MessageBundleDefects, "com.ibm.rqm.defects.web.ui.internal", "messages");
    }
});

com.ibm.rqm.defects.web.ui.utils.MessageLoader = new com.ibm.rqm.defects.web.ui.utils._MessageLoader();
com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil = {
	   
    /**
     * Return the message from the message bundle with the specified keyword.
     * Optional token arguments are for replacing place holders in the message
     * definition.  The place holders have the syntax "%number" with the number
     * starting from 1.  For example, if the message "myStr" is defined as
     * "This is %1 of %2 message".  getMessage("myStr", "one", "my many") will return
     * "This is one of my many message".
     */
    getMessage: function(keyword, tokens) {
        var args = [];
		if (arguments.length > 1)
		{
        	for( var i = 1; i < arguments.length; i++){ 
            	args.push(arguments[i]);
			}
        }
		if (args.length == 0)
			return MessageUtil.getMessage(MessageBundleDefects, keyword);
		else if (args.length == 1)
			return MessageUtil.getMessage(MessageBundleDefects, keyword, args[0]);
		else if (args.length == 2)
			return MessageUtil.getMessage(MessageBundleDefects, keyword, args[0], args[1]);
		else if (args.length == 3)
        	return MessageUtil.getMessage(MessageBundleDefects, keyword, args[0], args[1], args[2]);
    }
};
})();
