/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");

(function(){
    com.ibm.rqm.configuration.web.util.TestConfigurationUtil = {
        DO_NOT_CARE: "DC",
        _PLANNING_URI: "#action=com.ibm.rqm.test.planning.viewTestPlans",
        _actionPrefix: "#action=com.ibm.rqm.configuration.",
        entryURL: "",
		NO_ASSOCIATED_TEST_PLAN: -1,
        /*
         * Generate a hash for an action and any keyword arguments
         */
        getActionURI: function(action, kwArgs){
            var result = this._actionPrefix + action;
            for (var key in kwArgs) {
                result += "&" + key + "=" + kwArgs[key];
            }
            result += "&random=" + Math.random();
            return result;
        },
        
        
        getTestCaseURI: function(testId){
        
            var _actionPrefix = "#action=com.ibm.rqm.test.construction.";
            var action = "viewTestCase";
            var result = _actionPrefix + action;
            
            if (testId != null) {
                result += "&" + "id=" + testId;
            }
            return result;
        },
        
        getTestConfigurationList: function(params){
            var args = {};
            if (params != null) {
                args = params
            }
            this.setLocationToActionWithKeywords("showConfigurationList", args);
        },
        
        getGenerateEWIConfigurationURI: function(args){
            this.entryURL = window.location.hash;
            this.setLocationToActionWithKeywords("generateEWI", args);
        },
        
        getEWIListURI: function(params){
            this.setLocationToActionWithKeywords("showEWILists", params);
        },
        
        getPlanningURI: function(){
            window.location.hash = this._PLANNING_URI;
        },
        
        /*
         * Set the window location to an action with keywords
         */
        setLocationToActionWithKeywords: function(action, kwArgs){
            this.setLocationHash(this.getActionURI(action, kwArgs));
        },
        
        /*
         * Set the window location hash.
         * This is pushed to a method so all changes to the URI can be traced if needed
         */
        setLocationHash: function(locationHash){
            window.location.hash = locationHash;
        },
        
        //Return a unique id for use in urls
        getUniqueId: function(){
            return Date.parse(new Date().toString());
        },
        
        //Auto generate a test configuration name according to the content.
        getTestConfigurationName: function(contentArr){
            var testConfigurationName = "";
            for (var i = 0; i < contentArr.length; i++) {
				if(i == contentArr.length - 1){
					testConfigurationName += dojo.trim(contentArr[i]);
				}else{
					testConfigurationName += dojo.trim(contentArr[i]) + "_";
				}
            }
            return testConfigurationName;
        }
        
    };
    
})();
